{-# OPTIONS -fglasgow-exts -cpp #-}
module FrontEnd.HsParser (parse, parseHsStmt) where

import C.FFI
import FrontEnd.HsSyn
import FrontEnd.ParseMonad
import FrontEnd.Lexer
import FrontEnd.ParseUtils hiding(readInteger,readRational)
import FrontEnd.SrcLoc

import Control.Monad (liftM, liftM2)
import Debug.Trace (trace)
#if __GLASGOW_HASKELL__ >= 503
import Data.Array
#else
import Array
#endif
#if __GLASGOW_HASKELL__ >= 503
import GHC.Exts
#else
import GlaExts
#endif

-- parser produced by Happy Version 1.18.2

newtype HappyAbsSyn  = HappyAbsSyn HappyAny
#if __GLASGOW_HASKELL__ >= 607
type HappyAny = GHC.Exts.Any
#else
type HappyAny = forall a . a
#endif
happyIn5 :: (HsModule) -> (HappyAbsSyn )
happyIn5 x = unsafeCoerce# x
{-# INLINE happyIn5 #-}
happyOut5 :: (HappyAbsSyn ) -> (HsModule)
happyOut5 x = unsafeCoerce# x
{-# INLINE happyOut5 #-}
happyIn6 :: (HsModule) -> (HappyAbsSyn )
happyIn6 x = unsafeCoerce# x
{-# INLINE happyIn6 #-}
happyOut6 :: (HappyAbsSyn ) -> (HsModule)
happyOut6 x = unsafeCoerce# x
{-# INLINE happyOut6 #-}
happyIn7 :: (([HsImportDecl],[HsDecl])) -> (HappyAbsSyn )
happyIn7 x = unsafeCoerce# x
{-# INLINE happyIn7 #-}
happyOut7 :: (HappyAbsSyn ) -> (([HsImportDecl],[HsDecl]))
happyOut7 x = unsafeCoerce# x
{-# INLINE happyOut7 #-}
happyIn8 :: (([HsImportDecl],[HsDecl])) -> (HappyAbsSyn )
happyIn8 x = unsafeCoerce# x
{-# INLINE happyIn8 #-}
happyOut8 :: (HappyAbsSyn ) -> (([HsImportDecl],[HsDecl]))
happyOut8 x = unsafeCoerce# x
{-# INLINE happyOut8 #-}
happyIn9 :: (()) -> (HappyAbsSyn )
happyIn9 x = unsafeCoerce# x
{-# INLINE happyIn9 #-}
happyOut9 :: (HappyAbsSyn ) -> (())
happyOut9 x = unsafeCoerce# x
{-# INLINE happyOut9 #-}
happyIn10 :: (Maybe [HsExportSpec]) -> (HappyAbsSyn )
happyIn10 x = unsafeCoerce# x
{-# INLINE happyIn10 #-}
happyOut10 :: (HappyAbsSyn ) -> (Maybe [HsExportSpec])
happyOut10 x = unsafeCoerce# x
{-# INLINE happyOut10 #-}
happyIn11 :: ([HsExportSpec]) -> (HappyAbsSyn )
happyIn11 x = unsafeCoerce# x
{-# INLINE happyIn11 #-}
happyOut11 :: (HappyAbsSyn ) -> ([HsExportSpec])
happyOut11 x = unsafeCoerce# x
{-# INLINE happyOut11 #-}
happyIn12 :: (()) -> (HappyAbsSyn )
happyIn12 x = unsafeCoerce# x
{-# INLINE happyIn12 #-}
happyOut12 :: (HappyAbsSyn ) -> (())
happyOut12 x = unsafeCoerce# x
{-# INLINE happyOut12 #-}
happyIn13 :: ([HsExportSpec]) -> (HappyAbsSyn )
happyIn13 x = unsafeCoerce# x
{-# INLINE happyIn13 #-}
happyOut13 :: (HappyAbsSyn ) -> ([HsExportSpec])
happyOut13 x = unsafeCoerce# x
{-# INLINE happyOut13 #-}
happyIn14 :: (HsExportSpec) -> (HappyAbsSyn )
happyIn14 x = unsafeCoerce# x
{-# INLINE happyIn14 #-}
happyOut14 :: (HappyAbsSyn ) -> (HsExportSpec)
happyOut14 x = unsafeCoerce# x
{-# INLINE happyOut14 #-}
happyIn15 :: ([HsName]) -> (HappyAbsSyn )
happyIn15 x = unsafeCoerce# x
{-# INLINE happyIn15 #-}
happyOut15 :: (HappyAbsSyn ) -> ([HsName])
happyOut15 x = unsafeCoerce# x
{-# INLINE happyOut15 #-}
happyIn16 :: (HsName) -> (HappyAbsSyn )
happyIn16 x = unsafeCoerce# x
{-# INLINE happyIn16 #-}
happyOut16 :: (HappyAbsSyn ) -> (HsName)
happyOut16 x = unsafeCoerce# x
{-# INLINE happyOut16 #-}
happyIn17 :: ([HsImportDecl]) -> (HappyAbsSyn )
happyIn17 x = unsafeCoerce# x
{-# INLINE happyIn17 #-}
happyOut17 :: (HappyAbsSyn ) -> ([HsImportDecl])
happyOut17 x = unsafeCoerce# x
{-# INLINE happyOut17 #-}
happyIn18 :: (HsImportDecl) -> (HappyAbsSyn )
happyIn18 x = unsafeCoerce# x
{-# INLINE happyIn18 #-}
happyOut18 :: (HappyAbsSyn ) -> (HsImportDecl)
happyOut18 x = unsafeCoerce# x
{-# INLINE happyOut18 #-}
happyIn19 :: (Bool) -> (HappyAbsSyn )
happyIn19 x = unsafeCoerce# x
{-# INLINE happyIn19 #-}
happyOut19 :: (HappyAbsSyn ) -> (Bool)
happyOut19 x = unsafeCoerce# x
{-# INLINE happyOut19 #-}
happyIn20 :: (Maybe Module) -> (HappyAbsSyn )
happyIn20 x = unsafeCoerce# x
{-# INLINE happyIn20 #-}
happyOut20 :: (HappyAbsSyn ) -> (Maybe Module)
happyOut20 x = unsafeCoerce# x
{-# INLINE happyOut20 #-}
happyIn21 :: (Maybe (Bool, [HsImportSpec])) -> (HappyAbsSyn )
happyIn21 x = unsafeCoerce# x
{-# INLINE happyIn21 #-}
happyOut21 :: (HappyAbsSyn ) -> (Maybe (Bool, [HsImportSpec]))
happyOut21 x = unsafeCoerce# x
{-# INLINE happyOut21 #-}
happyIn22 :: ((Bool, [HsImportSpec])) -> (HappyAbsSyn )
happyIn22 x = unsafeCoerce# x
{-# INLINE happyIn22 #-}
happyOut22 :: (HappyAbsSyn ) -> ((Bool, [HsImportSpec]))
happyOut22 x = unsafeCoerce# x
{-# INLINE happyOut22 #-}
happyIn23 :: ([HsImportSpec]) -> (HappyAbsSyn )
happyIn23 x = unsafeCoerce# x
{-# INLINE happyIn23 #-}
happyOut23 :: (HappyAbsSyn ) -> ([HsImportSpec])
happyOut23 x = unsafeCoerce# x
{-# INLINE happyOut23 #-}
happyIn24 :: (HsImportSpec) -> (HappyAbsSyn )
happyIn24 x = unsafeCoerce# x
{-# INLINE happyIn24 #-}
happyOut24 :: (HappyAbsSyn ) -> (HsImportSpec)
happyOut24 x = unsafeCoerce# x
{-# INLINE happyOut24 #-}
happyIn25 :: ([HsName]) -> (HappyAbsSyn )
happyIn25 x = unsafeCoerce# x
{-# INLINE happyIn25 #-}
happyOut25 :: (HappyAbsSyn ) -> ([HsName])
happyOut25 x = unsafeCoerce# x
{-# INLINE happyOut25 #-}
happyIn26 :: (HsName) -> (HappyAbsSyn )
happyIn26 x = unsafeCoerce# x
{-# INLINE happyIn26 #-}
happyOut26 :: (HappyAbsSyn ) -> (HsName)
happyOut26 x = unsafeCoerce# x
{-# INLINE happyOut26 #-}
happyIn27 :: (HsDecl) -> (HappyAbsSyn )
happyIn27 x = unsafeCoerce# x
{-# INLINE happyIn27 #-}
happyOut27 :: (HappyAbsSyn ) -> (HsDecl)
happyOut27 x = unsafeCoerce# x
{-# INLINE happyOut27 #-}
happyIn28 :: (Int) -> (HappyAbsSyn )
happyIn28 x = unsafeCoerce# x
{-# INLINE happyIn28 #-}
happyOut28 :: (HappyAbsSyn ) -> (Int)
happyOut28 x = unsafeCoerce# x
{-# INLINE happyOut28 #-}
happyIn29 :: (HsAssoc) -> (HappyAbsSyn )
happyIn29 x = unsafeCoerce# x
{-# INLINE happyIn29 #-}
happyOut29 :: (HappyAbsSyn ) -> (HsAssoc)
happyOut29 x = unsafeCoerce# x
{-# INLINE happyOut29 #-}
happyIn30 :: ([HsName]) -> (HappyAbsSyn )
happyIn30 x = unsafeCoerce# x
{-# INLINE happyIn30 #-}
happyOut30 :: (HappyAbsSyn ) -> ([HsName])
happyOut30 x = unsafeCoerce# x
{-# INLINE happyOut30 #-}
happyIn31 :: ([HsDecl]) -> (HappyAbsSyn )
happyIn31 x = unsafeCoerce# x
{-# INLINE happyIn31 #-}
happyOut31 :: (HappyAbsSyn ) -> ([HsDecl])
happyOut31 x = unsafeCoerce# x
{-# INLINE happyOut31 #-}
happyIn32 :: (HsDecl) -> (HappyAbsSyn )
happyIn32 x = unsafeCoerce# x
{-# INLINE happyIn32 #-}
happyOut32 :: (HappyAbsSyn ) -> (HsDecl)
happyOut32 x = unsafeCoerce# x
{-# INLINE happyOut32 #-}
happyIn33 :: (HsRule) -> (HappyAbsSyn )
happyIn33 x = unsafeCoerce# x
{-# INLINE happyIn33 #-}
happyOut33 :: (HappyAbsSyn ) -> (HsRule)
happyOut33 x = unsafeCoerce# x
{-# INLINE happyOut33 #-}
happyIn34 :: ([HsRule]) -> (HappyAbsSyn )
happyIn34 x = unsafeCoerce# x
{-# INLINE happyIn34 #-}
happyOut34 :: (HappyAbsSyn ) -> ([HsRule])
happyOut34 x = unsafeCoerce# x
{-# INLINE happyOut34 #-}
happyIn35 :: ([HsRule]) -> (HappyAbsSyn )
happyIn35 x = unsafeCoerce# x
{-# INLINE happyIn35 #-}
happyOut35 :: (HappyAbsSyn ) -> ([HsRule])
happyOut35 x = unsafeCoerce# x
{-# INLINE happyOut35 #-}
happyIn36 :: ([(HsName,Maybe HsType)]) -> (HappyAbsSyn )
happyIn36 x = unsafeCoerce# x
{-# INLINE happyIn36 #-}
happyOut36 :: (HappyAbsSyn ) -> ([(HsName,Maybe HsType)])
happyOut36 x = unsafeCoerce# x
{-# INLINE happyOut36 #-}
happyIn37 :: ([(HsName,Maybe HsType)]) -> (HappyAbsSyn )
happyIn37 x = unsafeCoerce# x
{-# INLINE happyIn37 #-}
happyOut37 :: (HappyAbsSyn ) -> ([(HsName,Maybe HsType)])
happyOut37 x = unsafeCoerce# x
{-# INLINE happyOut37 #-}
happyIn38 :: ([HsDecl]) -> (HappyAbsSyn )
happyIn38 x = unsafeCoerce# x
{-# INLINE happyIn38 #-}
happyOut38 :: (HappyAbsSyn ) -> ([HsDecl])
happyOut38 x = unsafeCoerce# x
{-# INLINE happyOut38 #-}
happyIn39 :: ([HsDecl]) -> (HappyAbsSyn )
happyIn39 x = unsafeCoerce# x
{-# INLINE happyIn39 #-}
happyOut39 :: (HappyAbsSyn ) -> ([HsDecl])
happyOut39 x = unsafeCoerce# x
{-# INLINE happyOut39 #-}
happyIn40 :: (HsDecl) -> (HappyAbsSyn )
happyIn40 x = unsafeCoerce# x
{-# INLINE happyIn40 #-}
happyOut40 :: (HappyAbsSyn ) -> (HsDecl)
happyOut40 x = unsafeCoerce# x
{-# INLINE happyOut40 #-}
happyIn41 :: ([HsDecl]) -> (HappyAbsSyn )
happyIn41 x = unsafeCoerce# x
{-# INLINE happyIn41 #-}
happyOut41 :: (HappyAbsSyn ) -> ([HsDecl])
happyOut41 x = unsafeCoerce# x
{-# INLINE happyOut41 #-}
happyIn42 :: (HsDecl) -> (HappyAbsSyn )
happyIn42 x = unsafeCoerce# x
{-# INLINE happyIn42 #-}
happyOut42 :: (HappyAbsSyn ) -> (HsDecl)
happyOut42 x = unsafeCoerce# x
{-# INLINE happyOut42 #-}
happyIn43 :: (HsDecl) -> (HappyAbsSyn )
happyIn43 x = unsafeCoerce# x
{-# INLINE happyIn43 #-}
happyOut43 :: (HappyAbsSyn ) -> (HsDecl)
happyOut43 x = unsafeCoerce# x
{-# INLINE happyOut43 #-}
happyIn44 :: ([HsName]) -> (HappyAbsSyn )
happyIn44 x = unsafeCoerce# x
{-# INLINE happyIn44 #-}
happyOut44 :: (HappyAbsSyn ) -> ([HsName])
happyOut44 x = unsafeCoerce# x
{-# INLINE happyOut44 #-}
happyIn45 :: (Maybe (String,HsName)) -> (HappyAbsSyn )
happyIn45 x = unsafeCoerce# x
{-# INLINE happyIn45 #-}
happyOut45 :: (HappyAbsSyn ) -> (Maybe (String,HsName))
happyOut45 x = unsafeCoerce# x
{-# INLINE happyOut45 #-}
happyIn46 :: (HsType) -> (HappyAbsSyn )
happyIn46 x = unsafeCoerce# x
{-# INLINE happyIn46 #-}
happyOut46 :: (HappyAbsSyn ) -> (HsType)
happyOut46 x = unsafeCoerce# x
{-# INLINE happyOut46 #-}
happyIn47 :: ([HsTyVarBind]) -> (HappyAbsSyn )
happyIn47 x = unsafeCoerce# x
{-# INLINE happyIn47 #-}
happyOut47 :: (HappyAbsSyn ) -> ([HsTyVarBind])
happyOut47 x = unsafeCoerce# x
{-# INLINE happyOut47 #-}
happyIn48 :: (HsTyVarBind) -> (HappyAbsSyn )
happyIn48 x = unsafeCoerce# x
{-# INLINE happyIn48 #-}
happyOut48 :: (HappyAbsSyn ) -> (HsTyVarBind)
happyOut48 x = unsafeCoerce# x
{-# INLINE happyOut48 #-}
happyIn49 :: (HsKind) -> (HappyAbsSyn )
happyIn49 x = unsafeCoerce# x
{-# INLINE happyIn49 #-}
happyOut49 :: (HappyAbsSyn ) -> (HsKind)
happyOut49 x = unsafeCoerce# x
{-# INLINE happyOut49 #-}
happyIn50 :: (HsKind) -> (HappyAbsSyn )
happyIn50 x = unsafeCoerce# x
{-# INLINE happyIn50 #-}
happyOut50 :: (HappyAbsSyn ) -> (HsKind)
happyOut50 x = unsafeCoerce# x
{-# INLINE happyOut50 #-}
happyIn51 :: (HsType) -> (HappyAbsSyn )
happyIn51 x = unsafeCoerce# x
{-# INLINE happyIn51 #-}
happyOut51 :: (HappyAbsSyn ) -> (HsType)
happyOut51 x = unsafeCoerce# x
{-# INLINE happyOut51 #-}
happyIn52 :: (HsType) -> (HappyAbsSyn )
happyIn52 x = unsafeCoerce# x
{-# INLINE happyIn52 #-}
happyOut52 :: (HappyAbsSyn ) -> (HsType)
happyOut52 x = unsafeCoerce# x
{-# INLINE happyOut52 #-}
happyIn53 :: (HsType) -> (HappyAbsSyn )
happyIn53 x = unsafeCoerce# x
{-# INLINE happyIn53 #-}
happyOut53 :: (HappyAbsSyn ) -> (HsType)
happyOut53 x = unsafeCoerce# x
{-# INLINE happyOut53 #-}
happyIn54 :: (HsName) -> (HappyAbsSyn )
happyIn54 x = unsafeCoerce# x
{-# INLINE happyIn54 #-}
happyOut54 :: (HappyAbsSyn ) -> (HsName)
happyOut54 x = unsafeCoerce# x
{-# INLINE happyOut54 #-}
happyIn55 :: (HsQualType) -> (HappyAbsSyn )
happyIn55 x = unsafeCoerce# x
{-# INLINE happyIn55 #-}
happyOut55 :: (HappyAbsSyn ) -> (HsQualType)
happyOut55 x = unsafeCoerce# x
{-# INLINE happyOut55 #-}
happyIn56 :: ((HsContext, HsContext)) -> (HappyAbsSyn )
happyIn56 x = unsafeCoerce# x
{-# INLINE happyIn56 #-}
happyOut56 :: (HappyAbsSyn ) -> ((HsContext, HsContext))
happyOut56 x = unsafeCoerce# x
{-# INLINE happyOut56 #-}
happyIn57 :: (HsClassHead) -> (HappyAbsSyn )
happyIn57 x = unsafeCoerce# x
{-# INLINE happyIn57 #-}
happyOut57 :: (HappyAbsSyn ) -> (HsClassHead)
happyOut57 x = unsafeCoerce# x
{-# INLINE happyOut57 #-}
happyIn58 :: ([HsType]) -> (HappyAbsSyn )
happyIn58 x = unsafeCoerce# x
{-# INLINE happyIn58 #-}
happyOut58 :: (HappyAbsSyn ) -> ([HsType])
happyOut58 x = unsafeCoerce# x
{-# INLINE happyOut58 #-}
happyIn59 :: ((HsName, [HsType])) -> (HappyAbsSyn )
happyIn59 x = unsafeCoerce# x
{-# INLINE happyIn59 #-}
happyOut59 :: (HappyAbsSyn ) -> ((HsName, [HsType]))
happyOut59 x = unsafeCoerce# x
{-# INLINE happyOut59 #-}
happyIn60 :: ([HsType]) -> (HappyAbsSyn )
happyIn60 x = unsafeCoerce# x
{-# INLINE happyIn60 #-}
happyOut60 :: (HappyAbsSyn ) -> ([HsType])
happyOut60 x = unsafeCoerce# x
{-# INLINE happyOut60 #-}
happyIn61 :: ([HsConDecl]) -> (HappyAbsSyn )
happyIn61 x = unsafeCoerce# x
{-# INLINE happyIn61 #-}
happyOut61 :: (HappyAbsSyn ) -> ([HsConDecl])
happyOut61 x = unsafeCoerce# x
{-# INLINE happyOut61 #-}
happyIn62 :: (HsConDecl) -> (HappyAbsSyn )
happyIn62 x = unsafeCoerce# x
{-# INLINE happyIn62 #-}
happyOut62 :: (HappyAbsSyn ) -> (HsConDecl)
happyOut62 x = unsafeCoerce# x
{-# INLINE happyOut62 #-}
happyIn63 :: ([HsTyVarBind]) -> (HappyAbsSyn )
happyIn63 x = unsafeCoerce# x
{-# INLINE happyIn63 #-}
happyOut63 :: (HappyAbsSyn ) -> ([HsTyVarBind])
happyOut63 x = unsafeCoerce# x
{-# INLINE happyOut63 #-}
happyIn64 :: ((HsName, [HsBangType])) -> (HappyAbsSyn )
happyIn64 x = unsafeCoerce# x
{-# INLINE happyIn64 #-}
happyOut64 :: (HappyAbsSyn ) -> ((HsName, [HsBangType]))
happyOut64 x = unsafeCoerce# x
{-# INLINE happyOut64 #-}
happyIn65 :: ((HsName, [HsBangType])) -> (HappyAbsSyn )
happyIn65 x = unsafeCoerce# x
{-# INLINE happyIn65 #-}
happyOut65 :: (HappyAbsSyn ) -> ((HsName, [HsBangType]))
happyOut65 x = unsafeCoerce# x
{-# INLINE happyOut65 #-}
happyIn66 :: (HsBangType) -> (HappyAbsSyn )
happyIn66 x = unsafeCoerce# x
{-# INLINE happyIn66 #-}
happyOut66 :: (HappyAbsSyn ) -> (HsBangType)
happyOut66 x = unsafeCoerce# x
{-# INLINE happyOut66 #-}
happyIn67 :: (HsBangType) -> (HappyAbsSyn )
happyIn67 x = unsafeCoerce# x
{-# INLINE happyIn67 #-}
happyOut67 :: (HappyAbsSyn ) -> (HsBangType)
happyOut67 x = unsafeCoerce# x
{-# INLINE happyOut67 #-}
happyIn68 :: ([([HsName],HsBangType)]) -> (HappyAbsSyn )
happyIn68 x = unsafeCoerce# x
{-# INLINE happyIn68 #-}
happyOut68 :: (HappyAbsSyn ) -> ([([HsName],HsBangType)])
happyOut68 x = unsafeCoerce# x
{-# INLINE happyOut68 #-}
happyIn69 :: (([HsName],HsBangType)) -> (HappyAbsSyn )
happyIn69 x = unsafeCoerce# x
{-# INLINE happyIn69 #-}
happyOut69 :: (HappyAbsSyn ) -> (([HsName],HsBangType))
happyOut69 x = unsafeCoerce# x
{-# INLINE happyOut69 #-}
happyIn70 :: (HsBangType) -> (HappyAbsSyn )
happyIn70 x = unsafeCoerce# x
{-# INLINE happyIn70 #-}
happyOut70 :: (HappyAbsSyn ) -> (HsBangType)
happyOut70 x = unsafeCoerce# x
{-# INLINE happyOut70 #-}
happyIn71 :: ([HsName]) -> (HappyAbsSyn )
happyIn71 x = unsafeCoerce# x
{-# INLINE happyIn71 #-}
happyOut71 :: (HappyAbsSyn ) -> ([HsName])
happyOut71 x = unsafeCoerce# x
{-# INLINE happyOut71 #-}
happyIn72 :: ([HsName]) -> (HappyAbsSyn )
happyIn72 x = unsafeCoerce# x
{-# INLINE happyIn72 #-}
happyOut72 :: (HappyAbsSyn ) -> ([HsName])
happyOut72 x = unsafeCoerce# x
{-# INLINE happyOut72 #-}
happyIn73 :: ([HsDecl]) -> (HappyAbsSyn )
happyIn73 x = unsafeCoerce# x
{-# INLINE happyIn73 #-}
happyOut73 :: (HappyAbsSyn ) -> ([HsDecl])
happyOut73 x = unsafeCoerce# x
{-# INLINE happyOut73 #-}
happyIn74 :: ([HsDecl]) -> (HappyAbsSyn )
happyIn74 x = unsafeCoerce# x
{-# INLINE happyIn74 #-}
happyOut74 :: (HappyAbsSyn ) -> ([HsDecl])
happyOut74 x = unsafeCoerce# x
{-# INLINE happyOut74 #-}
happyIn75 :: ([([HsName],[HsName])]) -> (HappyAbsSyn )
happyIn75 x = unsafeCoerce# x
{-# INLINE happyIn75 #-}
happyOut75 :: (HappyAbsSyn ) -> ([([HsName],[HsName])])
happyOut75 x = unsafeCoerce# x
{-# INLINE happyOut75 #-}
happyIn76 :: ([([HsName],[HsName])]) -> (HappyAbsSyn )
happyIn76 x = unsafeCoerce# x
{-# INLINE happyIn76 #-}
happyOut76 :: (HappyAbsSyn ) -> ([([HsName],[HsName])])
happyOut76 x = unsafeCoerce# x
{-# INLINE happyOut76 #-}
happyIn77 :: (([HsName],[HsName])) -> (HappyAbsSyn )
happyIn77 x = unsafeCoerce# x
{-# INLINE happyIn77 #-}
happyOut77 :: (HappyAbsSyn ) -> (([HsName],[HsName]))
happyOut77 x = unsafeCoerce# x
{-# INLINE happyOut77 #-}
happyIn78 :: ([HsName]) -> (HappyAbsSyn )
happyIn78 x = unsafeCoerce# x
{-# INLINE happyIn78 #-}
happyOut78 :: (HappyAbsSyn ) -> ([HsName])
happyOut78 x = unsafeCoerce# x
{-# INLINE happyOut78 #-}
happyIn79 :: ([HsDecl]) -> (HappyAbsSyn )
happyIn79 x = unsafeCoerce# x
{-# INLINE happyIn79 #-}
happyOut79 :: (HappyAbsSyn ) -> ([HsDecl])
happyOut79 x = unsafeCoerce# x
{-# INLINE happyOut79 #-}
happyIn80 :: ([HsDecl]) -> (HappyAbsSyn )
happyIn80 x = unsafeCoerce# x
{-# INLINE happyIn80 #-}
happyOut80 :: (HappyAbsSyn ) -> ([HsDecl])
happyOut80 x = unsafeCoerce# x
{-# INLINE happyOut80 #-}
happyIn81 :: (HsDecl) -> (HappyAbsSyn )
happyIn81 x = unsafeCoerce# x
{-# INLINE happyIn81 #-}
happyOut81 :: (HappyAbsSyn ) -> (HsDecl)
happyOut81 x = unsafeCoerce# x
{-# INLINE happyOut81 #-}
happyIn82 :: (HsRhs) -> (HappyAbsSyn )
happyIn82 x = unsafeCoerce# x
{-# INLINE happyIn82 #-}
happyOut82 :: (HappyAbsSyn ) -> (HsRhs)
happyOut82 x = unsafeCoerce# x
{-# INLINE happyOut82 #-}
happyIn83 :: ([HsGuardedRhs]) -> (HappyAbsSyn )
happyIn83 x = unsafeCoerce# x
{-# INLINE happyIn83 #-}
happyOut83 :: (HappyAbsSyn ) -> ([HsGuardedRhs])
happyOut83 x = unsafeCoerce# x
{-# INLINE happyOut83 #-}
happyIn84 :: (HsGuardedRhs) -> (HappyAbsSyn )
happyIn84 x = unsafeCoerce# x
{-# INLINE happyIn84 #-}
happyOut84 :: (HappyAbsSyn ) -> (HsGuardedRhs)
happyOut84 x = unsafeCoerce# x
{-# INLINE happyOut84 #-}
happyIn85 :: (HsExp) -> (HappyAbsSyn )
happyIn85 x = unsafeCoerce# x
{-# INLINE happyIn85 #-}
happyOut85 :: (HappyAbsSyn ) -> (HsExp)
happyOut85 x = unsafeCoerce# x
{-# INLINE happyOut85 #-}
happyIn86 :: (HsExp) -> (HappyAbsSyn )
happyIn86 x = unsafeCoerce# x
{-# INLINE happyIn86 #-}
happyOut86 :: (HappyAbsSyn ) -> (HsExp)
happyOut86 x = unsafeCoerce# x
{-# INLINE happyOut86 #-}
happyIn87 :: (HsExp) -> (HappyAbsSyn )
happyIn87 x = unsafeCoerce# x
{-# INLINE happyIn87 #-}
happyOut87 :: (HappyAbsSyn ) -> (HsExp)
happyOut87 x = unsafeCoerce# x
{-# INLINE happyOut87 #-}
happyIn88 :: (HsExp) -> (HappyAbsSyn )
happyIn88 x = unsafeCoerce# x
{-# INLINE happyIn88 #-}
happyOut88 :: (HappyAbsSyn ) -> (HsExp)
happyOut88 x = unsafeCoerce# x
{-# INLINE happyOut88 #-}
happyIn89 :: ([HsExp]) -> (HappyAbsSyn )
happyIn89 x = unsafeCoerce# x
{-# INLINE happyIn89 #-}
happyOut89 :: (HappyAbsSyn ) -> ([HsExp])
happyOut89 x = unsafeCoerce# x
{-# INLINE happyOut89 #-}
happyIn90 :: (HsExp) -> (HappyAbsSyn )
happyIn90 x = unsafeCoerce# x
{-# INLINE happyIn90 #-}
happyOut90 :: (HappyAbsSyn ) -> (HsExp)
happyOut90 x = unsafeCoerce# x
{-# INLINE happyOut90 #-}
happyIn91 :: (HsExp) -> (HappyAbsSyn )
happyIn91 x = unsafeCoerce# x
{-# INLINE happyIn91 #-}
happyOut91 :: (HappyAbsSyn ) -> (HsExp)
happyOut91 x = unsafeCoerce# x
{-# INLINE happyOut91 #-}
happyIn92 :: (Int) -> (HappyAbsSyn )
happyIn92 x = unsafeCoerce# x
{-# INLINE happyIn92 #-}
happyOut92 :: (HappyAbsSyn ) -> (Int)
happyOut92 x = unsafeCoerce# x
{-# INLINE happyOut92 #-}
happyIn93 :: ([HsExp]) -> (HappyAbsSyn )
happyIn93 x = unsafeCoerce# x
{-# INLINE happyIn93 #-}
happyOut93 :: (HappyAbsSyn ) -> ([HsExp])
happyOut93 x = unsafeCoerce# x
{-# INLINE happyOut93 #-}
happyIn94 :: (HsExp) -> (HappyAbsSyn )
happyIn94 x = unsafeCoerce# x
{-# INLINE happyIn94 #-}
happyOut94 :: (HappyAbsSyn ) -> (HsExp)
happyOut94 x = unsafeCoerce# x
{-# INLINE happyOut94 #-}
happyIn95 :: ([HsExp]) -> (HappyAbsSyn )
happyIn95 x = unsafeCoerce# x
{-# INLINE happyIn95 #-}
happyOut95 :: (HappyAbsSyn ) -> ([HsExp])
happyOut95 x = unsafeCoerce# x
{-# INLINE happyOut95 #-}
happyIn96 :: ([HsStmt]) -> (HappyAbsSyn )
happyIn96 x = unsafeCoerce# x
{-# INLINE happyIn96 #-}
happyOut96 :: (HappyAbsSyn ) -> ([HsStmt])
happyOut96 x = unsafeCoerce# x
{-# INLINE happyOut96 #-}
happyIn97 :: (HsStmt) -> (HappyAbsSyn )
happyIn97 x = unsafeCoerce# x
{-# INLINE happyIn97 #-}
happyOut97 :: (HappyAbsSyn ) -> (HsStmt)
happyOut97 x = unsafeCoerce# x
{-# INLINE happyOut97 #-}
happyIn98 :: ([HsAlt]) -> (HappyAbsSyn )
happyIn98 x = unsafeCoerce# x
{-# INLINE happyIn98 #-}
happyOut98 :: (HappyAbsSyn ) -> ([HsAlt])
happyOut98 x = unsafeCoerce# x
{-# INLINE happyOut98 #-}
happyIn99 :: ([HsAlt]) -> (HappyAbsSyn )
happyIn99 x = unsafeCoerce# x
{-# INLINE happyIn99 #-}
happyOut99 :: (HappyAbsSyn ) -> ([HsAlt])
happyOut99 x = unsafeCoerce# x
{-# INLINE happyOut99 #-}
happyIn100 :: (HsAlt) -> (HappyAbsSyn )
happyIn100 x = unsafeCoerce# x
{-# INLINE happyIn100 #-}
happyOut100 :: (HappyAbsSyn ) -> (HsAlt)
happyOut100 x = unsafeCoerce# x
{-# INLINE happyOut100 #-}
happyIn101 :: (HsRhs) -> (HappyAbsSyn )
happyIn101 x = unsafeCoerce# x
{-# INLINE happyIn101 #-}
happyOut101 :: (HappyAbsSyn ) -> (HsRhs)
happyOut101 x = unsafeCoerce# x
{-# INLINE happyOut101 #-}
happyIn102 :: ([HsGuardedRhs]) -> (HappyAbsSyn )
happyIn102 x = unsafeCoerce# x
{-# INLINE happyIn102 #-}
happyOut102 :: (HappyAbsSyn ) -> ([HsGuardedRhs])
happyOut102 x = unsafeCoerce# x
{-# INLINE happyOut102 #-}
happyIn103 :: (HsGuardedRhs) -> (HappyAbsSyn )
happyIn103 x = unsafeCoerce# x
{-# INLINE happyIn103 #-}
happyOut103 :: (HappyAbsSyn ) -> (HsGuardedRhs)
happyOut103 x = unsafeCoerce# x
{-# INLINE happyOut103 #-}
happyIn104 :: ([HsStmt]) -> (HappyAbsSyn )
happyIn104 x = unsafeCoerce# x
{-# INLINE happyIn104 #-}
happyOut104 :: (HappyAbsSyn ) -> ([HsStmt])
happyOut104 x = unsafeCoerce# x
{-# INLINE happyOut104 #-}
happyIn105 :: ([HsStmt]) -> (HappyAbsSyn )
happyIn105 x = unsafeCoerce# x
{-# INLINE happyIn105 #-}
happyOut105 :: (HappyAbsSyn ) -> ([HsStmt])
happyOut105 x = unsafeCoerce# x
{-# INLINE happyOut105 #-}
happyIn106 :: ([HsStmt]) -> (HappyAbsSyn )
happyIn106 x = unsafeCoerce# x
{-# INLINE happyIn106 #-}
happyOut106 :: (HappyAbsSyn ) -> ([HsStmt])
happyOut106 x = unsafeCoerce# x
{-# INLINE happyOut106 #-}
happyIn107 :: ([HsFieldUpdate]) -> (HappyAbsSyn )
happyIn107 x = unsafeCoerce# x
{-# INLINE happyIn107 #-}
happyOut107 :: (HappyAbsSyn ) -> ([HsFieldUpdate])
happyOut107 x = unsafeCoerce# x
{-# INLINE happyOut107 #-}
happyIn108 :: (HsFieldUpdate) -> (HappyAbsSyn )
happyIn108 x = unsafeCoerce# x
{-# INLINE happyIn108 #-}
happyOut108 :: (HappyAbsSyn ) -> (HsFieldUpdate)
happyOut108 x = unsafeCoerce# x
{-# INLINE happyOut108 #-}
happyIn109 :: (HsExp) -> (HappyAbsSyn )
happyIn109 x = unsafeCoerce# x
{-# INLINE happyIn109 #-}
happyOut109 :: (HappyAbsSyn ) -> (HsExp)
happyOut109 x = unsafeCoerce# x
{-# INLINE happyOut109 #-}
happyIn110 :: (HsName) -> (HappyAbsSyn )
happyIn110 x = unsafeCoerce# x
{-# INLINE happyIn110 #-}
happyOut110 :: (HappyAbsSyn ) -> (HsName)
happyOut110 x = unsafeCoerce# x
{-# INLINE happyOut110 #-}
happyIn111 :: (HsName) -> (HappyAbsSyn )
happyIn111 x = unsafeCoerce# x
{-# INLINE happyIn111 #-}
happyOut111 :: (HappyAbsSyn ) -> (HsName)
happyOut111 x = unsafeCoerce# x
{-# INLINE happyOut111 #-}
happyIn112 :: (HsName) -> (HappyAbsSyn )
happyIn112 x = unsafeCoerce# x
{-# INLINE happyIn112 #-}
happyOut112 :: (HappyAbsSyn ) -> (HsName)
happyOut112 x = unsafeCoerce# x
{-# INLINE happyOut112 #-}
happyIn113 :: (HsName) -> (HappyAbsSyn )
happyIn113 x = unsafeCoerce# x
{-# INLINE happyIn113 #-}
happyOut113 :: (HappyAbsSyn ) -> (HsName)
happyOut113 x = unsafeCoerce# x
{-# INLINE happyOut113 #-}
happyIn114 :: (HsName) -> (HappyAbsSyn )
happyIn114 x = unsafeCoerce# x
{-# INLINE happyIn114 #-}
happyOut114 :: (HappyAbsSyn ) -> (HsName)
happyOut114 x = unsafeCoerce# x
{-# INLINE happyOut114 #-}
happyIn115 :: (HsName) -> (HappyAbsSyn )
happyIn115 x = unsafeCoerce# x
{-# INLINE happyIn115 #-}
happyOut115 :: (HappyAbsSyn ) -> (HsName)
happyOut115 x = unsafeCoerce# x
{-# INLINE happyOut115 #-}
happyIn116 :: (HsName) -> (HappyAbsSyn )
happyIn116 x = unsafeCoerce# x
{-# INLINE happyIn116 #-}
happyOut116 :: (HappyAbsSyn ) -> (HsName)
happyOut116 x = unsafeCoerce# x
{-# INLINE happyOut116 #-}
happyIn117 :: (HsName) -> (HappyAbsSyn )
happyIn117 x = unsafeCoerce# x
{-# INLINE happyIn117 #-}
happyOut117 :: (HappyAbsSyn ) -> (HsName)
happyOut117 x = unsafeCoerce# x
{-# INLINE happyOut117 #-}
happyIn118 :: (HsName) -> (HappyAbsSyn )
happyIn118 x = unsafeCoerce# x
{-# INLINE happyIn118 #-}
happyOut118 :: (HappyAbsSyn ) -> (HsName)
happyOut118 x = unsafeCoerce# x
{-# INLINE happyOut118 #-}
happyIn119 :: (HsName) -> (HappyAbsSyn )
happyIn119 x = unsafeCoerce# x
{-# INLINE happyIn119 #-}
happyOut119 :: (HappyAbsSyn ) -> (HsName)
happyOut119 x = unsafeCoerce# x
{-# INLINE happyOut119 #-}
happyIn120 :: (HsExp) -> (HappyAbsSyn )
happyIn120 x = unsafeCoerce# x
{-# INLINE happyIn120 #-}
happyOut120 :: (HappyAbsSyn ) -> (HsExp)
happyOut120 x = unsafeCoerce# x
{-# INLINE happyOut120 #-}
happyIn121 :: (HsExp) -> (HappyAbsSyn )
happyIn121 x = unsafeCoerce# x
{-# INLINE happyIn121 #-}
happyOut121 :: (HappyAbsSyn ) -> (HsExp)
happyOut121 x = unsafeCoerce# x
{-# INLINE happyOut121 #-}
happyIn122 :: (HsName) -> (HappyAbsSyn )
happyIn122 x = unsafeCoerce# x
{-# INLINE happyIn122 #-}
happyOut122 :: (HappyAbsSyn ) -> (HsName)
happyOut122 x = unsafeCoerce# x
{-# INLINE happyOut122 #-}
happyIn123 :: (HsName) -> (HappyAbsSyn )
happyIn123 x = unsafeCoerce# x
{-# INLINE happyIn123 #-}
happyOut123 :: (HappyAbsSyn ) -> (HsName)
happyOut123 x = unsafeCoerce# x
{-# INLINE happyOut123 #-}
happyIn124 :: (HsName) -> (HappyAbsSyn )
happyIn124 x = unsafeCoerce# x
{-# INLINE happyIn124 #-}
happyOut124 :: (HappyAbsSyn ) -> (HsName)
happyOut124 x = unsafeCoerce# x
{-# INLINE happyOut124 #-}
happyIn125 :: (HsName) -> (HappyAbsSyn )
happyIn125 x = unsafeCoerce# x
{-# INLINE happyIn125 #-}
happyOut125 :: (HappyAbsSyn ) -> (HsName)
happyOut125 x = unsafeCoerce# x
{-# INLINE happyOut125 #-}
happyIn126 :: (HsName) -> (HappyAbsSyn )
happyIn126 x = unsafeCoerce# x
{-# INLINE happyIn126 #-}
happyOut126 :: (HappyAbsSyn ) -> (HsName)
happyOut126 x = unsafeCoerce# x
{-# INLINE happyOut126 #-}
happyIn127 :: (HsName) -> (HappyAbsSyn )
happyIn127 x = unsafeCoerce# x
{-# INLINE happyIn127 #-}
happyOut127 :: (HappyAbsSyn ) -> (HsName)
happyOut127 x = unsafeCoerce# x
{-# INLINE happyOut127 #-}
happyIn128 :: (HsName) -> (HappyAbsSyn )
happyIn128 x = unsafeCoerce# x
{-# INLINE happyIn128 #-}
happyOut128 :: (HappyAbsSyn ) -> (HsName)
happyOut128 x = unsafeCoerce# x
{-# INLINE happyOut128 #-}
happyIn129 :: (HsName) -> (HappyAbsSyn )
happyIn129 x = unsafeCoerce# x
{-# INLINE happyIn129 #-}
happyOut129 :: (HappyAbsSyn ) -> (HsName)
happyOut129 x = unsafeCoerce# x
{-# INLINE happyOut129 #-}
happyIn130 :: (HsName) -> (HappyAbsSyn )
happyIn130 x = unsafeCoerce# x
{-# INLINE happyIn130 #-}
happyOut130 :: (HappyAbsSyn ) -> (HsName)
happyOut130 x = unsafeCoerce# x
{-# INLINE happyOut130 #-}
happyIn131 :: (HsName) -> (HappyAbsSyn )
happyIn131 x = unsafeCoerce# x
{-# INLINE happyIn131 #-}
happyOut131 :: (HappyAbsSyn ) -> (HsName)
happyOut131 x = unsafeCoerce# x
{-# INLINE happyOut131 #-}
happyIn132 :: (HsName) -> (HappyAbsSyn )
happyIn132 x = unsafeCoerce# x
{-# INLINE happyIn132 #-}
happyOut132 :: (HappyAbsSyn ) -> (HsName)
happyOut132 x = unsafeCoerce# x
{-# INLINE happyOut132 #-}
happyIn133 :: (HsExp) -> (HappyAbsSyn )
happyIn133 x = unsafeCoerce# x
{-# INLINE happyIn133 #-}
happyOut133 :: (HappyAbsSyn ) -> (HsExp)
happyOut133 x = unsafeCoerce# x
{-# INLINE happyOut133 #-}
happyIn134 :: (SrcLoc) -> (HappyAbsSyn )
happyIn134 x = unsafeCoerce# x
{-# INLINE happyIn134 #-}
happyOut134 :: (HappyAbsSyn ) -> (SrcLoc)
happyOut134 x = unsafeCoerce# x
{-# INLINE happyOut134 #-}
happyIn135 :: (()) -> (HappyAbsSyn )
happyIn135 x = unsafeCoerce# x
{-# INLINE happyIn135 #-}
happyOut135 :: (HappyAbsSyn ) -> (())
happyOut135 x = unsafeCoerce# x
{-# INLINE happyOut135 #-}
happyIn136 :: (()) -> (HappyAbsSyn )
happyIn136 x = unsafeCoerce# x
{-# INLINE happyIn136 #-}
happyOut136 :: (HappyAbsSyn ) -> (())
happyOut136 x = unsafeCoerce# x
{-# INLINE happyOut136 #-}
happyIn137 :: (Module) -> (HappyAbsSyn )
happyIn137 x = unsafeCoerce# x
{-# INLINE happyIn137 #-}
happyOut137 :: (HappyAbsSyn ) -> (Module)
happyOut137 x = unsafeCoerce# x
{-# INLINE happyOut137 #-}
happyIn138 :: (HsName) -> (HappyAbsSyn )
happyIn138 x = unsafeCoerce# x
{-# INLINE happyIn138 #-}
happyOut138 :: (HappyAbsSyn ) -> (HsName)
happyOut138 x = unsafeCoerce# x
{-# INLINE happyOut138 #-}
happyIn139 :: (HsName) -> (HappyAbsSyn )
happyIn139 x = unsafeCoerce# x
{-# INLINE happyIn139 #-}
happyOut139 :: (HappyAbsSyn ) -> (HsName)
happyOut139 x = unsafeCoerce# x
{-# INLINE happyOut139 #-}
happyIn140 :: (HsName) -> (HappyAbsSyn )
happyIn140 x = unsafeCoerce# x
{-# INLINE happyIn140 #-}
happyOut140 :: (HappyAbsSyn ) -> (HsName)
happyOut140 x = unsafeCoerce# x
{-# INLINE happyOut140 #-}
happyIn141 :: (HsName) -> (HappyAbsSyn )
happyIn141 x = unsafeCoerce# x
{-# INLINE happyIn141 #-}
happyOut141 :: (HappyAbsSyn ) -> (HsName)
happyOut141 x = unsafeCoerce# x
{-# INLINE happyOut141 #-}
happyIn142 :: (HsName) -> (HappyAbsSyn )
happyIn142 x = unsafeCoerce# x
{-# INLINE happyIn142 #-}
happyOut142 :: (HappyAbsSyn ) -> (HsName)
happyOut142 x = unsafeCoerce# x
{-# INLINE happyOut142 #-}
happyInTok :: (Token) -> (HappyAbsSyn )
happyInTok x = unsafeCoerce# x
{-# INLINE happyInTok #-}
happyOutTok :: (HappyAbsSyn ) -> (Token)
happyOutTok x = unsafeCoerce# x
{-# INLINE happyOutTok #-}


happyActOffsets :: HappyAddr
happyActOffsets = HappyA# "\x00\x00\xd3\x0a\x00\x00\x21\x00\x00\x00\x59\x13\x00\x00\x24\x0b\xa0\x04\x00\x00\x5f\x04\x00\x00\x89\x04\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x90\x04\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xd0\x04\xa9\x07\x58\x07\x46\x0b\x00\x00\x46\x0b\x00\x00\x00\x00\x82\x0a\x00\x00\xe9\x02\x00\x00\x82\x0a\xc8\x02\x00\x00\x00\x00\x00\x00\x00\x00\x5b\x04\x12\x00\x00\x00\x00\x00\x00\x00\x2e\x04\x00\x00\x00\x00\x21\x05\xd7\x02\x6e\x04\x72\x05\x72\x05\x8c\x04\x8a\x13\xbb\x02\x00\x00\x31\x0a\x31\x0a\x58\x04\x24\x0b\x46\x0b\x46\x0b\x88\x04\xd4\x01\x85\x04\x76\x04\x00\x00\x24\x02\xf1\x01\x00\x00\xdf\x01\x8a\x13\xc5\x01\x9e\x01\x00\x00\x00\x00\xe0\x09\x87\x04\x00\x00\x84\x04\x00\x00\x00\x00\x00\x00\x83\x04\x82\x04\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xa1\x05\x24\x0b\x81\x04\x00\x00\x00\x00\x00\x00\x7d\x04\x79\x04\x71\x04\x00\x00\x46\x0b\x29\x08\x6c\x04\x00\x00\x00\x00\xe0\x09\x00\x00\x00\x00\x00\x00\x5e\x04\x00\x00\xa1\x05\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x77\x0e\x63\x04\x57\x04\xe0\x09\x00\x00\xbe\x01\x00\x00\x56\x04\xca\x0e\x5d\x04\x54\x04\x00\x00\x00\x00\x6d\x13\x00\x00\xe0\x09\x00\x00\x00\x00\x07\x07\x00\x00\xe0\x09\x00\x00\x00\x00\xe0\x09\x00\x00\xe0\x09\xb6\x06\x8f\x09\x55\x04\xdd\x00\x00\x00\xae\x02\x52\x04\x00\x00\x4e\x04\x47\x04\x28\x00\x20\x04\x15\x04\x00\x00\x00\x00\x43\x04\x3b\x04\x00\x00\x00\x00\x00\x00\x3d\x04\x00\x00\x5f\x0b\x92\x01\x06\x02\x00\x00\x4f\x04\x28\x00\x3e\x09\x3c\x04\x00\x00\x00\x00\x35\x04\x33\x04\x00\x00\x30\x04\x00\x00\x00\x00\x5f\x0b\xb1\x00\xac\x02\x02\x04\x0e\x04\x52\x0e\x00\x00\x00\x00\x00\x00\x4d\x0e\x00\x00\x00\x00\x28\x00\x00\x00\x00\x00\x00\x00\x04\x04\x00\x00\x26\x0c\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xfc\x0b\x50\x0d\x24\x0d\x6d\x09\x6d\x09\x4d\x0e\xfb\x03\x4d\x0e\x1f\x04\x4d\x0e\x4d\x0e\x00\x00\x00\x00\x2a\x04\x00\x00\x00\x00\x2c\x04\x1c\x09\x00\x00\x00\x00\x00\x00\x4a\x02\x00\x00\x7f\x04\x00\x00\x2e\x04\x00\x00\xea\x03\x00\x00\xff\x0c\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x29\x08\x19\x02\x11\x04\x1c\x09\x00\x00\xc3\x05\x00\x00\x3e\x09\x00\x00\xed\x08\x00\x00\x00\x00\x9c\x08\x9c\x08\x00\x00\x9c\x08\x14\x04\x00\x00\x00\x00\x0a\x04\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x9c\x08\x00\x00\x29\x08\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xb6\x06\x4b\x08\x00\x00\x5f\x0b\x0c\x04\x00\x00\x0c\x04\x0b\x04\x00\x00\x07\x04\x00\x00\x00\x00\x00\x00\xe8\x0e\x4d\x0e\xce\x03\xf8\x03\x00\x00\xfa\x07\xfa\x07\x34\x00\x00\x00\x23\x0e\xed\x03\xf7\x03\x00\x00\x00\x00\x00\x00\xf9\x03\x00\x00\xc0\x02\x7b\x02\x00\x00\xf4\x03\x00\x00\xfa\x07\xe9\x03\x92\x13\x00\x00\xf2\x03\x46\x01\xfa\x03\x36\x02\x00\x00\xfb\x0d\x01\x04\xcf\x03\x00\x00\x23\x00\x20\x00\x00\x00\xfa\x0c\x88\x02\x00\x00\xb6\x03\xc7\x03\x00\x00\xcb\x08\xc6\x03\xd5\x03\x00\x00\xe8\x01\x55\x01\x00\x00\xe0\x00\xd9\x03\x9a\x01\x51\x01\xf6\x0d\x00\x00\xd6\x03\xca\x03\x00\x00\xd1\x0d\xd1\x0d\x36\x07\x00\x00\x36\x07\xc8\x03\x00\x00\x7a\x08\x00\x00\x00\x00\x00\x00\x00\x00\xc3\x03\x00\x00\x00\x00\xd1\x0d\x00\x00\xd1\x0d\xd1\x0d\x00\x00\x00\x00\x00\x00\x00\x00\xd1\x0d\x00\x00\xbe\x09\xd1\x0d\x00\x00\x6e\x02\xb1\x03\x00\x00\xbc\x03\x00\x00\x20\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x42\x00\xba\x03\x94\x03\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x90\x03\x00\x00\x00\x00\xbe\x03\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xf2\x05\xd1\x0d\x00\x00\x00\x00\x00\x00\x00\x00\xd0\x0c\xc2\x03\xa6\x0b\xcc\x0d\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x5e\x02\x00\x00\xc1\x03\x92\x03\x28\x00\xb6\x06\xb2\x03\x1e\x01\x00\x00\x00\x00\x7f\x03\xa3\x03\x00\x00\xfa\x07\xfa\x07\x00\x00\x00\x00\x00\x00\xfa\x07\x00\x00\x00\x00\xa6\x03\x00\x00\x00\x00\x00\x00\x43\x01\x00\x00\x00\x00\x00\x00\xbd\x0c\x00\x00\xaf\x03\xa9\x03\x9b\x03\x95\x03\x92\x13\xfa\x07\x00\x00\x00\x00\x9f\x0e\xa2\x03\x00\x00\xb2\x01\x00\x00\x5e\x02\x00\x00\x00\x00\x00\x00\xf7\x00\x4b\x00\x00\x00\x05\x02\x9e\x03\x20\x00\x78\x03\x1e\x00\x4d\x02\x14\x06\x14\x06\x00\x00\x8f\x03\x00\x00\x97\x03\x00\x00\x00\x00\x20\x00\x73\x03\x00\x00\xcc\x0d\x87\x03\xcc\x0d\x88\x03\x00\x00\x00\x00\x00\x00\x20\x00\x00\x00\x8b\x03\x6d\x03\x00\x00\x28\x00\x00\x00\x00\x00\x00\x00\x43\x06\x6f\x03\x00\x00\x00\x00\x00\x00\xa9\x0c\x00\x00\x00\x00\x00\x00\x00\x00\x3c\x01\x00\x00\x00\x00\x4b\x00\x00\x00\x00\x00\x00\x00\xa2\x0d\xd2\x03\x77\x03\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x81\x03\x00\x00\x50\x05\xfa\x07\x00\x00\x00\x00\x00\x00\x00\x00\x01\x02\x00\x00\x6e\x03\x00\x00\x00\x00\xfa\x07\x00\x00\x6d\x0b\x00\x00\xa4\x0c\x37\x03\x00\x00\xbe\x09\x00\x00\x00\x00\xf4\x01\x00\x00\x57\x03\x45\x03\xd1\x0b\x00\x00\x7c\x0c\x18\x00\x68\x03\x60\x03\xab\x0b\xa2\x0d\xd8\x07\x55\x03\x00\x00\x00\x00\x00\x00\x5e\x03\x00\x00\x00\x00\x00\x00\x00\x00\x65\x06\x5c\x03\xfa\x07\x00\x00\x00\x00\x00\x00\x00\x00\x98\x0e\x5a\x03\xd8\x07\x4d\x03\x00\x00\x52\x03\x87\x07\x51\x0c\x5d\x03\x00\x00\x00\x00\xa2\x0d\xa2\x0d\x00\x00\x00\x00\x00\x00\x00\x00\xa2\x0d\x43\x03\x00\x00\xfa\x07\x00\x00\x7a\x0d\x75\x0d\x00\x00\x00\x00\x75\x0d\x00\x00\xf0\x00\xbb\x00\x00\x00\x00\x00\x51\x03\x00\x00\x00\x00\x0c\x01\x00\x00\x00\x00\x00\x00\x00\x00\xac\x12\x00\x00\x47\x03\x00\x00\x00\x00\xfa\x06\x00\x00\x00\x00\x94\x06\x2b\x0c\x39\x03\x00\x00\x00\x00\x00\x00\x75\x0d\x00\x00\x00\x00\x00\x00\x00\x00"#

happyGotoOffsets :: HappyAddr
happyGotoOffsets = HappyA# "\x08\x00\xc6\x0f\xda\x02\x01\x00\x00\x00\x27\x0a\x00\x00\xa0\x13\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xbb\x0e\x9d\x0f\x52\x0f\x72\x13\xd9\x02\x3c\x0e\x00\x00\x00\x00\x7e\x12\x00\x00\x0f\x00\x00\x00\x55\x12\x0e\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x01\x00\x00\x00\x00\x00\x00\x00\x94\x00\x07\x00\x00\x00\x49\x00\xd8\x02\x00\x00\x02\x01\xcb\x00\x4a\x03\x34\x06\x0d\x00\x00\x00\x0b\x0f\xed\x0e\x00\x00\xa0\x13\xeb\x09\x9b\x13\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xe3\x05\x00\x00\x00\x00\x00\x00\x00\x00\xf0\x12\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x26\x02\x3c\x0e\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x77\x13\xd1\x01\x00\x00\x00\x00\x00\x00\x01\x13\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xec\x01\xd0\x02\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xdc\x02\x00\x00\x00\x00\x44\x12\x00\x00\x00\x00\x00\x00\x00\x00\x35\x00\x00\x00\x00\x00\x00\x00\x00\x00\x9f\x04\x00\x00\x1b\x12\x00\x00\x00\x00\x01\x13\x00\x00\x0a\x12\x00\x00\x00\x00\xe1\x11\x00\x00\xd0\x11\xa7\x11\x29\x0f\x00\x00\x00\x00\xcb\x02\x0c\x00\x00\x00\x00\x00\x00\x00\x00\x00\xc7\x02\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x3d\x03\x00\x00\x00\x00\x00\x00\xca\x02\x00\x00\xc6\x04\x00\x00\x21\x03\xb3\x02\xe0\xff\xb5\x02\x96\x11\x45\x00\x00\x00\x00\x00\x00\x00\x32\x03\x00\x00\x31\x03\x00\x00\x00\x00\x2d\x04\x17\x03\x0b\x00\x00\x00\xb2\x02\xce\x02\xaa\x02\xa9\x02\xa6\x02\xc4\x02\xa2\x02\x00\x00\x9c\x02\x00\x00\x00\x00\x00\x00\xd6\x02\x00\x00\xa5\x03\x00\x00\x00\x00\x93\x02\x00\x00\x00\x00\x00\x00\x37\x02\x60\x01\x6b\x03\x17\x00\x15\x00\xba\x02\x03\x03\x64\x03\x92\x02\xa0\x02\x90\x02\x91\x02\x8f\x02\x00\x00\xfe\xff\xfb\xff\xf2\x02\x75\x00\x00\x00\x00\x00\x00\x00\x31\x02\x00\x00\xb9\x01\x00\x00\x9c\x01\x00\x00\x00\x00\x00\x00\x03\x00\x00\x00\x00\x00\x8e\x02\x00\x00\xcd\x02\x33\x00\x31\x02\x00\x00\xd3\xff\x00\x00\xd6\x01\x00\x00\x6d\x11\x00\x00\x8c\x0f\x00\x00\x00\x00\xb7\x12\x8f\x12\x00\x00\x5c\x11\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x33\x11\x00\x00\x17\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x22\x11\x63\x0f\x00\x00\xdc\x03\xfa\x02\x00\x00\xf4\x02\x00\x00\x00\x00\xf0\x02\x00\x00\x00\x00\x00\x00\x69\x02\x83\x02\x00\x00\x95\x02\x00\x00\xf9\x10\xe8\x10\x00\x00\x00\x00\xa1\x03\x00\x00\xd5\x02\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x52\x02\x02\x00\x00\x00\xcf\x02\x00\x00\xbf\x10\x00\x00\x65\x00\x00\x00\xcc\x02\xb9\x02\x00\x00\x05\x00\x00\x00\x37\x01\x3f\x02\x64\x02\x2f\x02\x66\x02\xa1\x01\x00\x00\x9d\x03\x21\x02\x00\x00\x59\x02\xdf\xff\x00\x00\x29\x02\xdf\xff\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x89\x03\x00\x00\x00\x00\x00\x00\x00\x00\x48\x03\x30\x03\x2c\x00\x4f\x02\xf1\xff\x00\x00\x00\x00\xcd\xff\x00\x00\x00\x00\x22\x00\x00\x00\x00\x00\x00\x00\x00\x00\x27\x03\x00\x00\x19\x03\x0f\x03\x00\x00\x00\x00\x00\x00\x00\x00\x68\x02\x00\x00\x13\x02\x61\x02\x00\x00\x10\x00\x6a\x02\x03\x02\x00\x00\x00\x00\x59\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x2b\x01\x13\x01\x00\x00\x30\x02\xd7\x01\xf8\x01\x00\x00\x00\x00\x13\x00\x00\x00\x0b\x02\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xbe\x00\xf7\x02\x00\x00\x00\x00\x00\x00\x00\x00\xc3\x00\x00\x00\x2f\x00\xf3\x02\x00\x00\x00\x00\xb3\x01\x00\x00\x00\x00\x0a\x00\x00\x00\x00\x00\x00\x00\xa2\x01\xc8\x12\x00\x00\x09\x02\x00\x00\x00\x00\x00\x00\xb4\x01\x00\x00\xae\x10\x85\x10\x00\x00\x00\x00\x00\x00\x74\x10\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xae\x03\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x56\x00\x4b\x10\xed\x01\x00\x00\x1d\x01\x00\x00\x00\x00\x1d\x01\x00\x00\x09\x00\x25\x01\x00\x00\x00\x00\x4d\x01\xa9\x01\x00\x00\xab\x01\x00\x00\x90\x00\x84\x01\xbb\x01\xa2\x00\x52\x01\x2a\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x7f\x00\x76\x01\x00\x00\x54\x02\x00\x00\x44\x02\x00\x00\x00\x00\x00\x00\x00\x00\xf3\xff\x00\x00\x12\x01\x00\x00\x00\x00\xaf\x00\x00\x00\x00\x00\x00\x00\x63\x00\x00\x00\x00\x00\x00\x00\x00\x00\x50\x03\xfc\xff\xf2\xff\x00\x00\xdc\xff\x00\x00\x00\x00\x00\x00\xcf\x00\x00\x00\xb8\x00\x3a\x00\x72\x03\xc7\xff\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xd2\x00\x3a\x10\x00\x00\x00\x00\x57\x00\x00\x00\xfd\xff\x00\x00\x00\x00\x00\x00\x00\x00\x11\x10\x00\x00\xc1\xff\x00\x00\x86\x03\xab\x00\x00\x00\x4c\x00\x00\x00\x00\x00\x10\x01\x00\x00\xdf\xff\xdf\xff\x86\x03\x00\x00\x4c\x03\x11\x00\x00\x00\x00\x00\x2a\x02\x80\x03\x4f\x00\x5e\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x89\x0e\x00\x00\x00\x10\x00\x00\x00\x00\x00\x00\x00\x00\xe4\x00\x00\x00\x9a\x00\x2d\x00\x00\x00\x00\x00\xa4\x00\x78\x02\xad\xff\x00\x00\x00\x00\x7a\x03\xb6\x02\x00\x00\x00\x00\x00\x00\x00\x00\x6b\x01\x00\x00\x00\x00\xd7\x0f\x00\x00\xec\x02\xe6\x01\x00\x00\x00\x00\xe6\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xfa\xff\x00\x00\x00\x00\x00\x00\x00\x00\xc7\x00\x00\x00\x00\x00\xdb\x00\x04\x02\x00\x00\x00\x00\x00\x00\x00\x00\xfb\x00\x00\x00\x00\x00\x00\x00\x00\x00"#

happyDefActions :: HappyAddr
happyDefActions = HappyA# "\xa5\xfe\xa5\xfe\x00\x00\x00\x00\x02\xff\x30\xff\x2f\xff\x27\xff\x25\xff\x21\xff\x00\x00\x1f\xff\x20\xff\xe9\xfe\xe6\xfe\xd0\xfe\xe2\xfe\xc5\xfe\x1e\xff\x00\x00\xce\xfe\xcf\xfe\xc3\xfe\xc4\xfe\xac\xfe\xab\xfe\xa8\xfe\xaa\xfe\xa9\xfe\xa7\xfe\xa6\xfe\xa5\xfe\xa5\xfe\xa5\xfe\xa5\xfe\xa5\xfe\xa5\xfe\xcd\xfe\xc6\xfe\xa5\xfe\xcc\xfe\xf2\xff\xc9\xfe\xa5\xfe\xf2\xff\xca\xfe\xc8\xfe\xc7\xfe\xcb\xfe\x00\x00\xf2\xff\xfd\xff\xfa\xff\xa2\xfe\xf4\xff\xa5\xfe\xf3\xff\xa5\xfe\x00\x00\x01\xff\xf2\xff\xf2\xff\xf2\xff\x30\xff\xf2\xff\x28\xff\xa5\xfe\xa5\xfe\x00\x00\x29\xff\xa5\xfe\xa5\xfe\x23\xff\x0e\xff\x00\x00\x0d\xff\xeb\xfe\x00\x00\x00\x00\x1b\xff\x00\x00\x30\xff\x00\x00\x00\x00\xd2\xfe\xd1\xfe\xa5\xfe\xd8\xfe\xc2\xfe\x00\x00\xdc\xfe\xbf\xfe\xbd\xfe\xbc\xfe\xb2\xfe\xc0\xfe\xad\xfe\xc1\xfe\xec\xfe\x11\xff\x00\x00\xba\xfe\xb1\xfe\xb8\xfe\xb7\xfe\xb6\xfe\xb0\xfe\xaf\xfe\xae\xfe\x14\xff\xa5\xfe\x00\x00\x26\xff\xd4\xfe\xd3\xfe\xa5\xfe\xd8\xfe\xde\xfe\xbe\xfe\x00\x00\xbb\xfe\x00\x00\xa5\xfe\xba\xfe\xb9\xfe\xb5\xfe\xb4\xfe\xb3\xfe\x00\x00\x00\x00\x00\x00\xa5\xfe\x2e\xff\x00\x00\xee\xfe\x00\x00\x00\x00\x15\xff\x00\x00\xe5\xfe\xe1\xfe\x00\x00\x1c\xff\xa5\xfe\xea\xfe\x12\xff\xa5\xfe\x1d\xff\xa5\xfe\x19\xff\x1a\xff\xa5\xfe\x18\xff\xa5\xfe\x0c\xff\xa5\xfe\x24\xff\x00\x00\xa5\xfe\xf2\xff\xf2\xfe\xf0\xfe\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xa2\xff\x9e\xff\x00\x00\xf2\xff\xa0\xff\x9f\xff\x9c\xff\xa5\xfe\x9d\xff\xa5\xfe\x20\xff\x00\x00\xa5\xfe\x00\x00\x00\x00\xa5\xfe\xf0\xff\xa1\xfe\xa0\xfe\x00\x00\xf2\xff\xde\xff\xf2\xff\xbf\xff\xae\xff\xa5\xfe\x00\x00\xf2\xff\xc6\xfe\xa5\xfe\x00\x00\xa5\xfe\xa5\xfe\xa5\xfe\x00\x00\xa5\xfe\xfc\xff\x00\x00\xf8\xff\xa3\xfe\xa4\xfe\x41\xff\x6e\xff\x92\xff\x80\xff\x7f\xff\xa5\xfe\x9b\xfe\x74\xff\x7e\xff\x00\x00\x00\x00\x00\x00\xc8\xfe\xc7\xfe\x00\x00\xdb\xff\x00\x00\xa5\xfe\xcb\xfe\x00\x00\xa5\xfe\xa5\xfe\x00\x00\xa5\xfe\xa5\xfe\xc7\xff\x00\x00\xc5\xff\xc4\xff\xc3\xff\x00\x00\xf6\xff\xf3\xff\xf5\xff\xf3\xff\xf9\xff\x00\x00\xf1\xff\x00\x00\x2c\xff\x9a\xff\xa5\xfe\x9e\xfe\x66\xff\x00\x00\x00\x00\x00\x00\x00\x00\xa3\xff\xf3\xff\x9b\xff\xa5\xfe\xf4\xfe\xa5\xfe\xf5\xfe\x2a\xff\xa5\xfe\xa5\xfe\x13\xff\xa5\xfe\x08\xff\x04\xff\x0a\xff\x06\xff\x07\xff\x0f\xff\x17\xff\x10\xff\x16\xff\xdb\xfe\xa5\xfe\x22\xff\x00\x00\x03\xff\xd7\xfe\xdd\xfe\x31\xff\xef\xfe\xed\xfe\x0b\xff\xa5\xfe\x2d\xff\xa5\xfe\xf2\xff\xfd\xfe\xf2\xff\xf3\xfe\xf1\xfe\xf2\xff\xa1\xff\x97\xff\xe8\xfe\x00\x00\x00\x00\x38\xff\x35\xff\x33\xff\xa5\xfe\xa5\xfe\x00\x00\x96\xff\x68\xff\x39\xff\xec\xff\xea\xff\xe9\xff\x9d\xfe\xe8\xff\xee\xff\x00\x00\xf2\xff\xdf\xff\xf2\xff\xc0\xff\xa5\xfe\x00\x00\x00\x00\xc6\xff\xf2\xff\xf2\xff\x00\x00\x00\x00\xb0\xff\x00\x00\x00\x00\x46\xff\xa5\xfe\x50\xff\x00\x00\xb5\xff\x92\xff\x00\x00\xdc\xff\x3d\xff\xa5\xfe\x8e\xff\x00\x00\xa5\xfe\x00\x00\x71\xff\x00\x00\x00\x00\x7c\xff\x75\xff\x00\x00\x00\x00\x00\x00\x00\x00\x73\xff\x00\x00\x00\x00\x81\xff\x00\x00\x00\x00\x94\xff\x41\xff\x94\xff\x00\x00\x40\xff\x00\x00\x6f\xff\x93\xff\xa5\xfe\x72\xff\x00\x00\x70\xff\x7d\xff\x00\x00\x78\xff\x00\x00\x00\x00\x7a\xff\x7b\xff\x79\xff\x8f\xff\x00\x00\x8d\xff\x00\x00\x00\x00\xb7\xff\xf2\xff\xd9\xff\xa5\xfe\x8b\xff\x82\xff\x00\x00\x86\xff\x84\xff\x83\xff\x85\xff\x88\xff\x87\xff\xbe\xff\xa5\xfe\x00\x00\x00\x00\x49\xff\x41\xff\x41\xff\x6b\xff\xb6\xff\xa5\xfe\xa9\xff\xa7\xff\xaa\xff\xab\xff\xc8\xff\xd6\xfe\xd5\xfe\xc1\xff\xda\xfe\xe0\xfe\x00\x00\x00\x00\xb4\xff\xf7\xff\xfb\xff\xe4\xff\x00\x00\x00\x00\xed\xff\x00\x00\x67\xff\x98\xff\xa5\xfe\x36\xff\x34\xff\xf2\xff\x99\xff\x00\x00\x00\x00\x00\x00\xf3\xff\x00\x00\x00\x00\x05\xff\x09\xff\xfc\xfe\xf9\xfe\xf7\xfe\xa5\xfe\xa5\xfe\x00\xff\xfe\xfe\xff\xfe\xa5\xfe\xe7\xfe\x37\xff\x00\x00\x3a\xff\xeb\xff\xef\xff\x00\x00\xe2\xff\xe1\xff\xe0\xff\x00\x00\xe6\xff\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xa5\xfe\xa4\xff\xac\xff\x00\x00\x45\xff\x43\xff\x00\x00\xb9\xff\xf2\xff\xa5\xfe\x9c\xfe\x4f\xff\x00\x00\x50\xff\x64\xff\x5e\xff\x00\x00\x00\x00\x50\xff\xd7\xff\x00\x00\xf2\xff\xf2\xff\x90\xff\x00\x00\x91\xff\x00\x00\x69\xff\x6a\xff\x00\x00\x50\xff\x95\xff\x00\x00\x00\x00\x00\x00\xb2\xff\xba\xff\x76\xff\x77\xff\x00\x00\x3b\xff\xf2\xff\x00\x00\x47\xff\x00\x00\xda\xff\xdd\xff\xd8\xff\x00\x00\x00\x00\xbd\xff\x8a\xff\x89\xff\x00\x00\xa5\xfe\xa5\xfe\xbc\xff\xa5\xfe\x00\x00\x4b\xff\x4e\xff\x50\xff\x4a\xff\x41\xff\x41\xff\x00\x00\x00\x00\x00\x00\xc2\xff\xd9\xfe\xdf\xfe\xaf\xff\xe7\xff\x00\x00\xe5\xff\x00\x00\xa5\xfe\x2b\xff\xfa\xfe\xa5\xfe\xf8\xfe\xf2\xff\xfb\xfe\x00\x00\x32\xff\xe3\xff\xa5\xfe\xa5\xff\x00\x00\xa8\xff\x6c\xff\x49\xff\x44\xff\x42\xff\xbb\xff\x4d\xff\x00\x00\x65\xff\xa5\xfe\xa5\xfe\x5d\xff\x63\xff\x5c\xff\x00\x00\x00\x00\xc5\xfe\x00\x00\x00\x00\x00\x00\xec\xff\xd2\xff\xd1\xff\x9f\xfe\xd0\xff\xd5\xff\x3e\xff\x3f\xff\x3c\xff\xf3\xff\x00\x00\xa5\xfe\xb3\xff\xb1\xff\x8c\xff\x48\xff\x00\x00\x00\x00\xed\xff\xec\xff\x56\xff\x00\x00\x00\x00\x00\x00\x00\x00\x59\xff\x5a\xff\x00\x00\x00\x00\x5f\xff\x60\xff\x4c\xff\xb8\xff\x00\x00\x00\x00\xad\xff\xa5\xfe\xf6\xfe\x00\x00\x6d\xff\x5b\xff\x58\xff\x57\xff\x62\xff\x00\x00\x00\x00\x54\xff\xe3\xfe\x00\x00\xd3\xff\xd6\xff\x00\x00\xcb\xff\xca\xff\xc9\xff\xe4\xfe\x00\x00\xce\xff\x00\x00\xcf\xff\xcd\xff\x00\x00\xd4\xff\x61\xff\x00\x00\x00\x00\x00\x00\xa6\xff\x52\xff\x53\xff\x00\x00\x55\xff\xcc\xff\x51\xff"#

happyCheck :: HappyAddr
happyCheck = HappyA# "\xff\xff\x04\x00\x01\x00\x02\x00\x02\x00\x04\x00\x04\x00\x00\x00\x00\x00\x04\x00\x2b\x00\x08\x00\x09\x00\x04\x00\x04\x00\x04\x00\x04\x00\x04\x00\x04\x00\x04\x00\x04\x00\x39\x00\x36\x00\x1c\x00\x1d\x00\x28\x00\x1c\x00\x1d\x00\x2a\x00\x2b\x00\x06\x00\x2c\x00\x2d\x00\x24\x00\x10\x00\x03\x00\x04\x00\x78\x00\x2a\x00\x2b\x00\x00\x00\x1e\x00\x69\x00\x19\x00\x1a\x00\x24\x00\x24\x00\x1c\x00\x69\x00\x24\x00\x24\x00\x15\x00\x07\x00\x15\x00\x69\x00\x76\x00\x09\x00\x21\x00\x19\x00\x1a\x00\x69\x00\x76\x00\x7d\x00\x2a\x00\x2b\x00\x2a\x00\x2b\x00\x76\x00\x1c\x00\x03\x00\x04\x00\x24\x00\x14\x00\x76\x00\x05\x00\x06\x00\x03\x00\x2d\x00\x2e\x00\x2f\x00\x30\x00\x31\x00\x32\x00\x1f\x00\x28\x00\x0c\x00\x0d\x00\x15\x00\x78\x00\x47\x00\x27\x00\x39\x00\x3e\x00\x81\x00\x3b\x00\x16\x00\x81\x00\x12\x00\x13\x00\x1a\x00\x1b\x00\x07\x00\x86\x00\x76\x00\x47\x00\x5d\x00\x77\x00\x78\x00\x23\x00\x6a\x00\x25\x00\x26\x00\x27\x00\x26\x00\x63\x00\x81\x00\x7a\x00\x12\x00\x13\x00\x7d\x00\x75\x00\x76\x00\x77\x00\x78\x00\x81\x00\x81\x00\x19\x00\x81\x00\x83\x00\x70\x00\x48\x00\x49\x00\x83\x00\x83\x00\x3b\x00\x82\x00\x81\x00\x81\x00\x87\x00\x7a\x00\x83\x00\x83\x00\x83\x00\x83\x00\x83\x00\x83\x00\x83\x00\x83\x00\x81\x00\x4c\x00\x81\x00\x03\x00\x81\x00\x6a\x00\x51\x00\x52\x00\x53\x00\x6a\x00\x55\x00\x56\x00\x0c\x00\x0d\x00\x76\x00\x81\x00\x75\x00\x76\x00\x77\x00\x78\x00\x75\x00\x76\x00\x16\x00\x2c\x00\x2d\x00\x13\x00\x1a\x00\x1b\x00\x7b\x00\x68\x00\x7d\x00\x6a\x00\x7f\x00\x6c\x00\x87\x00\x23\x00\x69\x00\x25\x00\x26\x00\x27\x00\x2c\x00\x2d\x00\x75\x00\x76\x00\x77\x00\x78\x00\x76\x00\x6d\x00\x13\x00\x76\x00\x70\x00\x78\x00\x72\x00\x80\x00\x81\x00\x27\x00\x69\x00\x0a\x00\x0b\x00\x04\x00\x7a\x00\x20\x00\x6d\x00\x7d\x00\x85\x00\x70\x00\x1b\x00\x72\x00\x81\x00\x76\x00\x1f\x00\x78\x00\x15\x00\x0b\x00\x69\x00\x7a\x00\x4c\x00\x16\x00\x7d\x00\x3f\x00\x40\x00\x51\x00\x52\x00\x53\x00\x85\x00\x55\x00\x56\x00\x76\x00\x21\x00\x22\x00\x23\x00\x44\x00\x25\x00\x26\x00\x27\x00\x42\x00\x43\x00\x44\x00\x77\x00\x78\x00\x14\x00\x15\x00\x03\x00\x04\x00\x68\x00\x20\x00\x6a\x00\x1f\x00\x6c\x00\x49\x00\x27\x00\x69\x00\x24\x00\x28\x00\x04\x00\x77\x00\x78\x00\x75\x00\x76\x00\x77\x00\x78\x00\x16\x00\x6a\x00\x1f\x00\x76\x00\x42\x00\x78\x00\x23\x00\x80\x00\x81\x00\x04\x00\x4c\x00\x16\x00\x75\x00\x76\x00\x40\x00\x51\x00\x52\x00\x53\x00\x85\x00\x55\x00\x56\x00\x16\x00\x21\x00\x22\x00\x23\x00\x84\x00\x25\x00\x26\x00\x27\x00\x2f\x00\x1f\x00\x31\x00\x6a\x00\x04\x00\x6c\x00\x69\x00\x82\x00\x6b\x00\x68\x00\x76\x00\x6a\x00\x78\x00\x6c\x00\x75\x00\x76\x00\x77\x00\x78\x00\x6a\x00\x76\x00\x6c\x00\x78\x00\x75\x00\x76\x00\x77\x00\x78\x00\x26\x00\x6a\x00\x28\x00\x75\x00\x76\x00\x77\x00\x78\x00\x80\x00\x81\x00\x69\x00\x4c\x00\x6b\x00\x75\x00\x76\x00\x16\x00\x51\x00\x52\x00\x53\x00\x04\x00\x55\x00\x56\x00\x16\x00\x76\x00\x1f\x00\x78\x00\x38\x00\x39\x00\x19\x00\x29\x00\x1b\x00\x1f\x00\x38\x00\x39\x00\x2e\x00\x2f\x00\x16\x00\x31\x00\x32\x00\x68\x00\x34\x00\x6a\x00\x18\x00\x6c\x00\x45\x00\x1f\x00\x76\x00\x77\x00\x78\x00\x1f\x00\x4b\x00\x4c\x00\x75\x00\x76\x00\x77\x00\x78\x00\x51\x00\x52\x00\x53\x00\x67\x00\x55\x00\x56\x00\x6a\x00\x80\x00\x81\x00\x89\x00\x2c\x00\x2d\x00\x77\x00\x78\x00\x29\x00\x77\x00\x78\x00\x75\x00\x76\x00\x2e\x00\x2f\x00\x43\x00\x31\x00\x68\x00\x76\x00\x6a\x00\x35\x00\x6c\x00\x45\x00\x88\x00\x2e\x00\x2f\x00\x88\x00\x31\x00\x4b\x00\x4c\x00\x75\x00\x76\x00\x77\x00\x78\x00\x51\x00\x52\x00\x53\x00\x81\x00\x55\x00\x56\x00\x0d\x00\x80\x00\x81\x00\x81\x00\x76\x00\x77\x00\x78\x00\x16\x00\x1f\x00\x16\x00\x01\x00\x16\x00\x23\x00\x1a\x00\x1b\x00\x42\x00\x1f\x00\x68\x00\x29\x00\x6a\x00\x1f\x00\x6c\x00\x23\x00\x89\x00\x25\x00\x26\x00\x27\x00\x77\x00\x78\x00\x42\x00\x75\x00\x76\x00\x77\x00\x78\x00\x10\x00\x11\x00\x2c\x00\x2d\x00\x16\x00\x77\x00\x78\x00\x80\x00\x81\x00\x1b\x00\x88\x00\x76\x00\x77\x00\x78\x00\x1b\x00\x28\x00\x16\x00\x23\x00\x1f\x00\x25\x00\x26\x00\x27\x00\x76\x00\x77\x00\x78\x00\x1f\x00\x3a\x00\x34\x00\x35\x00\x4c\x00\x89\x00\x38\x00\x42\x00\x16\x00\x51\x00\x52\x00\x53\x00\x3e\x00\x55\x00\x56\x00\x1f\x00\x89\x00\x16\x00\x22\x00\x03\x00\x04\x00\x23\x00\x26\x00\x25\x00\x26\x00\x27\x00\x1f\x00\x4d\x00\x18\x00\x4f\x00\x50\x00\x51\x00\x68\x00\x4c\x00\x6a\x00\x1f\x00\x6c\x00\x18\x00\x51\x00\x52\x00\x53\x00\x20\x00\x55\x00\x56\x00\x1f\x00\x75\x00\x76\x00\x77\x00\x78\x00\x2f\x00\x62\x00\x31\x00\x77\x00\x78\x00\x19\x00\x1a\x00\x80\x00\x81\x00\x47\x00\x48\x00\x49\x00\x68\x00\x4c\x00\x6a\x00\x82\x00\x6c\x00\x20\x00\x51\x00\x52\x00\x53\x00\x1f\x00\x55\x00\x56\x00\x29\x00\x75\x00\x76\x00\x77\x00\x78\x00\x2e\x00\x2f\x00\x81\x00\x31\x00\x00\x00\x66\x00\x67\x00\x80\x00\x81\x00\x6a\x00\x18\x00\x24\x00\x68\x00\x26\x00\x6a\x00\x49\x00\x6c\x00\x1f\x00\x0e\x00\x41\x00\x75\x00\x76\x00\x42\x00\x43\x00\x44\x00\x75\x00\x76\x00\x77\x00\x78\x00\x19\x00\x03\x00\x04\x00\x1c\x00\x29\x00\x4f\x00\x50\x00\x80\x00\x81\x00\x2e\x00\x2f\x00\x30\x00\x31\x00\x76\x00\x77\x00\x78\x00\x35\x00\x29\x00\x75\x00\x76\x00\x77\x00\x78\x00\x2e\x00\x2f\x00\x30\x00\x31\x00\x60\x00\x61\x00\x62\x00\x35\x00\x29\x00\x24\x00\x89\x00\x26\x00\x27\x00\x2e\x00\x2f\x00\x44\x00\x31\x00\x32\x00\x19\x00\x1a\x00\x0f\x00\x76\x00\x77\x00\x78\x00\x29\x00\x4d\x00\x4e\x00\x4f\x00\x57\x00\x2e\x00\x2f\x00\x81\x00\x31\x00\x32\x00\x19\x00\x1a\x00\x76\x00\x29\x00\x03\x00\x04\x00\x89\x00\x57\x00\x2e\x00\x2f\x00\x29\x00\x31\x00\x32\x00\x19\x00\x1a\x00\x2e\x00\x2f\x00\x49\x00\x31\x00\x32\x00\x75\x00\x76\x00\x77\x00\x78\x00\x76\x00\x76\x00\x77\x00\x78\x00\x4a\x00\x7a\x00\x84\x00\x2e\x00\x2f\x00\x42\x00\x31\x00\x46\x00\x81\x00\x29\x00\x76\x00\x77\x00\x78\x00\x81\x00\x2e\x00\x2f\x00\x89\x00\x31\x00\x32\x00\x3e\x00\x78\x00\x81\x00\x29\x00\x76\x00\x77\x00\x78\x00\x04\x00\x2e\x00\x2f\x00\x89\x00\x31\x00\x32\x00\x03\x00\x04\x00\x19\x00\x1a\x00\x19\x00\x1a\x00\x29\x00\x76\x00\x77\x00\x78\x00\x89\x00\x2e\x00\x2f\x00\x04\x00\x31\x00\x32\x00\x04\x00\x19\x00\x1a\x00\x84\x00\x76\x00\x77\x00\x78\x00\x03\x00\x04\x00\x07\x00\x89\x00\x76\x00\x77\x00\x78\x00\x19\x00\x1a\x00\x29\x00\x4f\x00\x2f\x00\x7d\x00\x31\x00\x2e\x00\x2f\x00\x89\x00\x31\x00\x32\x00\x29\x00\x76\x00\x77\x00\x78\x00\x89\x00\x2e\x00\x2f\x00\x04\x00\x31\x00\x32\x00\x29\x00\x04\x00\x76\x00\x77\x00\x78\x00\x2e\x00\x2f\x00\x04\x00\x31\x00\x32\x00\x89\x00\x19\x00\x1a\x00\x37\x00\x29\x00\x76\x00\x77\x00\x78\x00\x17\x00\x2e\x00\x2f\x00\x89\x00\x31\x00\x32\x00\x81\x00\x81\x00\x0e\x00\x81\x00\x81\x00\x81\x00\x29\x00\x76\x00\x77\x00\x78\x00\x89\x00\x2e\x00\x2f\x00\x29\x00\x31\x00\x82\x00\x49\x00\x29\x00\x2e\x00\x2f\x00\x81\x00\x31\x00\x2e\x00\x2f\x00\x81\x00\x31\x00\x89\x00\x81\x00\x81\x00\x76\x00\x77\x00\x78\x00\x18\x00\x76\x00\x77\x00\x78\x00\x81\x00\x81\x00\x04\x00\x04\x00\x82\x00\x29\x00\x18\x00\x76\x00\x77\x00\x78\x00\x2e\x00\x2f\x00\x89\x00\x31\x00\x04\x00\x29\x00\x89\x00\x76\x00\x77\x00\x78\x00\x2e\x00\x2f\x00\x82\x00\x31\x00\x81\x00\x81\x00\x89\x00\x04\x00\x16\x00\x29\x00\x81\x00\x76\x00\x77\x00\x78\x00\x2e\x00\x2f\x00\x89\x00\x31\x00\x29\x00\x81\x00\x81\x00\x84\x00\x16\x00\x2e\x00\x2f\x00\x03\x00\x31\x00\x76\x00\x77\x00\x78\x00\x89\x00\x23\x00\x16\x00\x16\x00\x76\x00\x77\x00\x78\x00\x1f\x00\x76\x00\x77\x00\x78\x00\x16\x00\x29\x00\x16\x00\x15\x00\x1f\x00\x89\x00\x2e\x00\x2f\x00\x33\x00\x31\x00\x1a\x00\x2f\x00\x89\x00\x31\x00\x2e\x00\x2f\x00\x89\x00\x31\x00\x1a\x00\x4c\x00\x15\x00\x76\x00\x77\x00\x78\x00\x1b\x00\x3d\x00\x33\x00\x3b\x00\x3c\x00\x29\x00\x3e\x00\x76\x00\x77\x00\x78\x00\x2e\x00\x2f\x00\x29\x00\x31\x00\x28\x00\x16\x00\x89\x00\x2e\x00\x2f\x00\x24\x00\x31\x00\x76\x00\x77\x00\x78\x00\x2e\x00\x2f\x00\x89\x00\x31\x00\x19\x00\x33\x00\x76\x00\x77\x00\x78\x00\x2f\x00\x23\x00\x31\x00\x24\x00\x16\x00\x3b\x00\x2f\x00\x89\x00\x31\x00\x23\x00\x3b\x00\x16\x00\x2f\x00\x21\x00\x31\x00\x2f\x00\x89\x00\x31\x00\x6b\x00\x21\x00\x14\x00\x76\x00\x77\x00\x78\x00\x1f\x00\x76\x00\x77\x00\x78\x00\x16\x00\x76\x00\x77\x00\x78\x00\x26\x00\x24\x00\x4c\x00\x2f\x00\x1b\x00\x31\x00\x3d\x00\x2f\x00\x89\x00\x31\x00\x01\x00\x2f\x00\x89\x00\x31\x00\x16\x00\x16\x00\x89\x00\x76\x00\x77\x00\x78\x00\x1f\x00\x24\x00\x4f\x00\x4c\x00\x76\x00\x77\x00\x78\x00\x28\x00\x34\x00\x23\x00\x15\x00\x76\x00\x77\x00\x78\x00\x23\x00\x16\x00\x89\x00\x24\x00\x16\x00\x76\x00\x77\x00\x78\x00\x1e\x00\x89\x00\x26\x00\x76\x00\x77\x00\x78\x00\x33\x00\x33\x00\x89\x00\x76\x00\x77\x00\x78\x00\x76\x00\x77\x00\x78\x00\x4c\x00\x89\x00\x03\x00\x33\x00\x34\x00\x35\x00\x0e\x00\x89\x00\x38\x00\x19\x00\x23\x00\x19\x00\x15\x00\x89\x00\x3e\x00\x24\x00\x89\x00\x76\x00\x77\x00\x78\x00\x1f\x00\x76\x00\x77\x00\x78\x00\x4c\x00\x76\x00\x77\x00\x78\x00\x26\x00\x4d\x00\x19\x00\x4f\x00\x50\x00\x51\x00\x19\x00\x19\x00\x89\x00\x79\x00\x7a\x00\x7b\x00\x89\x00\x7d\x00\x22\x00\x7f\x00\x89\x00\x01\x00\x02\x00\x03\x00\x04\x00\x1f\x00\x23\x00\x09\x00\x4c\x00\x09\x00\x0a\x00\x0b\x00\x0c\x00\x0d\x00\x0e\x00\x0f\x00\x14\x00\x11\x00\x12\x00\x13\x00\x23\x00\x15\x00\x40\x00\x17\x00\x38\x00\x45\x00\x4d\x00\x19\x00\x6e\x00\x1d\x00\x19\x00\x71\x00\x20\x00\x73\x00\x1b\x00\x15\x00\x03\x00\x25\x00\x19\x00\x79\x00\x7a\x00\x7b\x00\x2a\x00\x7d\x00\x2c\x00\x7f\x00\x1f\x00\x81\x00\x1b\x00\x4a\x00\x19\x00\x41\x00\x34\x00\x35\x00\x36\x00\x37\x00\x38\x00\x39\x00\x3a\x00\x1b\x00\x3c\x00\x19\x00\x3e\x00\x3f\x00\x40\x00\x1a\x00\x42\x00\x43\x00\x44\x00\x45\x00\x46\x00\x21\x00\x48\x00\x1a\x00\x21\x00\x4b\x00\x24\x00\x4d\x00\x4e\x00\x4f\x00\x50\x00\x51\x00\x01\x00\x02\x00\x03\x00\x04\x00\x21\x00\x27\x00\x1a\x00\x16\x00\x09\x00\x0a\x00\x0b\x00\x0c\x00\x0d\x00\x0e\x00\x0f\x00\x16\x00\x11\x00\x12\x00\x13\x00\x16\x00\x15\x00\x1f\x00\x17\x00\x16\x00\x16\x00\x16\x00\x16\x00\x6e\x00\x1d\x00\x16\x00\x71\x00\x20\x00\x73\x00\x49\x00\x1a\x00\x1e\x00\x25\x00\x19\x00\x79\x00\x7a\x00\x7b\x00\x2a\x00\x7d\x00\x2c\x00\x7f\x00\x52\x00\x81\x00\x41\x00\x20\x00\x52\x00\x29\x00\x34\x00\x35\x00\x36\x00\x37\x00\x38\x00\x39\x00\x3a\x00\x1a\x00\x3c\x00\xff\xff\x3e\x00\x3f\x00\xff\xff\xff\xff\x42\x00\x43\x00\x44\x00\x45\x00\x46\x00\xff\xff\x48\x00\xff\xff\xff\xff\x4b\x00\xff\xff\x4d\x00\x4e\x00\x4f\x00\x50\x00\x51\x00\x01\x00\x02\x00\x03\x00\x04\x00\x05\x00\x06\x00\x07\x00\x08\x00\x09\x00\x0a\x00\x0b\x00\x0c\x00\x0d\x00\x0e\x00\x0f\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\x15\x00\x16\x00\x17\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\x1d\x00\xff\xff\x1f\x00\xff\xff\x21\x00\xff\xff\xff\xff\xff\xff\x25\x00\xff\xff\xff\xff\xff\xff\xff\xff\x2a\x00\xff\xff\x2c\x00\x2d\x00\x2e\x00\x2f\x00\x30\x00\x31\x00\x32\x00\x33\x00\x34\x00\x35\x00\x36\x00\xff\xff\x38\x00\xff\xff\xff\xff\xff\xff\x3c\x00\x6e\x00\x3e\x00\x3f\x00\x71\x00\xff\xff\x73\x00\xff\xff\xff\xff\xff\xff\x46\x00\xff\xff\x79\x00\x7a\x00\x7b\x00\xff\xff\x7d\x00\x4d\x00\x7f\x00\x4f\x00\x50\x00\x51\x00\x01\x00\x02\x00\x03\x00\x04\x00\xff\xff\xff\xff\xff\xff\xff\xff\x09\x00\x0a\x00\x0b\x00\x0c\x00\x0d\x00\x0e\x00\x0f\x00\xff\xff\x11\x00\x12\x00\x6e\x00\xff\xff\x15\x00\x71\x00\x17\x00\x73\x00\xff\xff\xff\xff\x1b\x00\xff\xff\x1d\x00\x79\x00\x7a\x00\x7b\x00\xff\xff\x7d\x00\xff\xff\x7f\x00\x25\x00\x81\x00\xff\xff\xff\xff\xff\xff\x2a\x00\xff\xff\x2c\x00\xff\xff\xff\xff\xff\xff\x01\x00\x02\x00\x03\x00\x04\x00\x34\x00\x35\x00\x36\x00\x37\x00\x38\x00\x39\x00\x3a\x00\xff\xff\x3c\x00\xff\xff\x3e\x00\x3f\x00\x40\x00\xff\xff\xff\xff\xff\xff\x15\x00\x45\x00\x46\x00\xff\xff\x48\x00\xff\xff\xff\xff\x4b\x00\xff\xff\x4d\x00\x4e\x00\x4f\x00\x50\x00\x51\x00\x01\x00\x02\x00\x03\x00\x04\x00\xff\xff\xff\xff\xff\xff\xff\xff\x09\x00\x0a\x00\x0b\x00\x0c\x00\x0d\x00\x0e\x00\x0f\x00\xff\xff\x11\x00\x34\x00\x35\x00\xff\xff\x15\x00\x38\x00\x17\x00\xff\xff\x19\x00\xff\xff\xff\xff\x3e\x00\x1d\x00\xff\xff\xff\xff\x20\x00\xff\xff\xff\xff\xff\xff\xff\xff\x25\x00\xff\xff\xff\xff\xff\xff\xff\xff\x2a\x00\x4d\x00\x2c\x00\x4f\x00\x50\x00\x51\x00\x01\x00\x02\x00\x03\x00\x04\x00\x34\x00\x35\x00\x36\x00\xff\xff\x38\x00\xff\xff\xff\xff\xff\xff\x3c\x00\xff\xff\x3e\x00\x3f\x00\xff\xff\xff\xff\x42\x00\x43\x00\x44\x00\xff\xff\x46\x00\xff\xff\xff\xff\xff\xff\xff\xff\x4b\x00\xff\xff\x4d\x00\xff\xff\x4f\x00\x50\x00\x51\x00\x01\x00\x02\x00\x03\x00\x04\x00\xff\xff\xff\xff\xff\xff\xff\xff\x09\x00\x0a\x00\x0b\x00\x0c\x00\x0d\x00\x0e\x00\x0f\x00\xff\xff\x11\x00\x34\x00\x35\x00\xff\xff\x15\x00\x38\x00\x17\x00\xff\xff\xff\xff\xff\xff\xff\xff\x3e\x00\x1d\x00\xff\xff\xff\xff\x20\x00\xff\xff\xff\xff\xff\xff\xff\xff\x25\x00\xff\xff\xff\xff\xff\xff\xff\xff\x2a\x00\x4d\x00\x2c\x00\x4f\x00\x50\x00\x51\x00\x01\x00\xff\xff\x03\x00\xff\xff\x34\x00\x35\x00\x36\x00\xff\xff\x38\x00\xff\xff\xff\xff\xff\xff\x3c\x00\xff\xff\x3e\x00\x3f\x00\xff\xff\xff\xff\x42\x00\x43\x00\x44\x00\xff\xff\x46\x00\xff\xff\xff\xff\xff\xff\xff\xff\x4b\x00\xff\xff\x4d\x00\xff\xff\x4f\x00\x50\x00\x51\x00\x01\x00\x02\x00\x03\x00\x04\x00\xff\xff\xff\xff\xff\xff\xff\xff\x09\x00\x0a\x00\x0b\x00\x0c\x00\x0d\x00\x0e\x00\x0f\x00\xff\xff\xff\xff\x34\x00\x35\x00\xff\xff\x15\x00\x38\x00\x17\x00\xff\xff\x19\x00\xff\xff\xff\xff\x3e\x00\x1d\x00\xff\xff\xff\xff\x20\x00\xff\xff\xff\xff\xff\xff\xff\xff\x25\x00\xff\xff\xff\xff\xff\xff\xff\xff\x2a\x00\x4d\x00\x2c\x00\x4f\x00\x50\x00\x51\x00\x01\x00\xff\xff\x03\x00\xff\xff\x34\x00\x35\x00\x36\x00\xff\xff\x38\x00\xff\xff\xff\xff\xff\xff\x3c\x00\x6e\x00\x3e\x00\x3f\x00\x71\x00\xff\xff\x73\x00\xff\xff\x15\x00\x16\x00\x46\x00\xff\xff\x79\x00\x7a\x00\x7b\x00\x4b\x00\x7d\x00\x4d\x00\x7f\x00\x4f\x00\x50\x00\x51\x00\x01\x00\x02\x00\x03\x00\x04\x00\xff\xff\xff\xff\xff\xff\xff\xff\x09\x00\x0a\x00\x0b\x00\x0c\x00\x0d\x00\x0e\x00\x0f\x00\xff\xff\xff\xff\x34\x00\x35\x00\xff\xff\x15\x00\x38\x00\x17\x00\xff\xff\xff\xff\xff\xff\xff\xff\x3e\x00\x1d\x00\xff\xff\xff\xff\x20\x00\xff\xff\xff\xff\xff\xff\xff\xff\x25\x00\xff\xff\xff\xff\xff\xff\xff\xff\x2a\x00\x4d\x00\x2c\x00\x4f\x00\x50\x00\x51\x00\x01\x00\x02\x00\xff\xff\xff\xff\x34\x00\x35\x00\x36\x00\xff\xff\x38\x00\xff\xff\xff\xff\xff\xff\x3c\x00\x6e\x00\x3e\x00\x3f\x00\x71\x00\xff\xff\x73\x00\xff\xff\x15\x00\xff\xff\x46\x00\xff\xff\x79\x00\x7a\x00\x7b\x00\x4b\x00\x7d\x00\x4d\x00\x7f\x00\x4f\x00\x50\x00\x51\x00\x01\x00\x02\x00\x03\x00\x04\x00\xff\xff\xff\xff\xff\xff\xff\xff\x09\x00\x0a\x00\x0b\x00\x0c\x00\x0d\x00\x0e\x00\x0f\x00\xff\xff\xff\xff\x34\x00\x35\x00\xff\xff\x15\x00\x38\x00\x17\x00\xff\xff\xff\xff\xff\xff\xff\xff\x3e\x00\x1d\x00\xff\xff\xff\xff\x20\x00\xff\xff\xff\xff\xff\xff\xff\xff\x25\x00\xff\xff\xff\xff\xff\xff\xff\xff\x2a\x00\x4d\x00\x2c\x00\x4f\x00\x50\x00\x51\x00\xff\xff\xff\xff\xff\xff\xff\xff\x34\x00\x35\x00\x36\x00\xff\xff\x38\x00\xff\xff\xff\xff\xff\xff\x3c\x00\xff\xff\x3e\x00\x3f\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\x01\x00\x46\x00\x03\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\x4d\x00\xff\xff\x4f\x00\x50\x00\x51\x00\x01\x00\x02\x00\x03\x00\x04\x00\xff\xff\xff\xff\xff\xff\x15\x00\x09\x00\x0a\x00\x0b\x00\x0c\x00\x0d\x00\x0e\x00\x0f\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\x15\x00\x16\x00\x17\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\x1d\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\x25\x00\xff\xff\x34\x00\x35\x00\xff\xff\x2a\x00\x38\x00\x2c\x00\xff\xff\xff\xff\xff\xff\x01\x00\x3e\x00\xff\xff\xff\xff\x34\x00\x35\x00\x36\x00\xff\xff\x38\x00\xff\xff\xff\xff\xff\xff\x3c\x00\x0e\x00\x3e\x00\x3f\x00\x4d\x00\xff\xff\x4f\x00\x50\x00\x51\x00\xff\xff\x46\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\x4d\x00\xff\xff\x4f\x00\x50\x00\x51\x00\x01\x00\x02\x00\x03\x00\x04\x00\xff\xff\xff\xff\xff\xff\xff\xff\x09\x00\x0a\x00\x0b\x00\x0c\x00\x0d\x00\x0e\x00\x0f\x00\xff\xff\xff\xff\x34\x00\x35\x00\xff\xff\x15\x00\x38\x00\x17\x00\xff\xff\xff\xff\xff\xff\xff\xff\x3e\x00\x1d\x00\x1e\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\x25\x00\xff\xff\xff\xff\xff\xff\xff\xff\x2a\x00\x4d\x00\x2c\x00\x4f\x00\x50\x00\x51\x00\x01\x00\x02\x00\xff\xff\xff\xff\x34\x00\x35\x00\x36\x00\xff\xff\x38\x00\xff\xff\xff\xff\xff\xff\x3c\x00\xff\xff\x3e\x00\x3f\x00\xff\xff\xff\xff\xff\xff\xff\xff\x15\x00\xff\xff\x46\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\x4d\x00\xff\xff\x4f\x00\x50\x00\x51\x00\x01\x00\x02\x00\x03\x00\x04\x00\xff\xff\xff\xff\xff\xff\xff\xff\x09\x00\x0a\x00\x0b\x00\x0c\x00\x0d\x00\x0e\x00\x0f\x00\xff\xff\xff\xff\x34\x00\x35\x00\xff\xff\x15\x00\x38\x00\x17\x00\x18\x00\xff\xff\xff\xff\xff\xff\x3e\x00\x1d\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\x25\x00\xff\xff\xff\xff\xff\xff\xff\xff\x2a\x00\x4d\x00\x2c\x00\x4f\x00\x50\x00\x51\x00\x01\x00\xff\xff\x03\x00\xff\xff\x34\x00\x35\x00\x36\x00\xff\xff\x38\x00\xff\xff\xff\xff\xff\xff\x3c\x00\xff\xff\x3e\x00\x3f\x00\xff\xff\xff\xff\xff\xff\xff\xff\x15\x00\xff\xff\x46\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\x4d\x00\xff\xff\x4f\x00\x50\x00\x51\x00\x01\x00\x02\x00\x03\x00\x04\x00\xff\xff\xff\xff\xff\xff\xff\xff\x09\x00\x0a\x00\x0b\x00\x0c\x00\x0d\x00\x0e\x00\x0f\x00\xff\xff\xff\xff\x34\x00\x35\x00\xff\xff\x15\x00\x38\x00\x17\x00\xff\xff\xff\xff\xff\xff\xff\xff\x3e\x00\x1d\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\x25\x00\xff\xff\xff\xff\xff\xff\xff\xff\x2a\x00\x4d\x00\x2c\x00\x4f\x00\x50\x00\x51\x00\x01\x00\x02\x00\xff\xff\xff\xff\x34\x00\x35\x00\x36\x00\xff\xff\x38\x00\xff\xff\xff\xff\xff\xff\x3c\x00\xff\xff\x3e\x00\x3f\x00\xff\xff\xff\xff\xff\xff\xff\xff\x15\x00\xff\xff\x46\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\x4d\x00\xff\xff\x4f\x00\x50\x00\x51\x00\x01\x00\x02\x00\x03\x00\x04\x00\xff\xff\xff\xff\xff\xff\xff\xff\x09\x00\x0a\x00\x0b\x00\x0c\x00\x0d\x00\x0e\x00\x0f\x00\xff\xff\xff\xff\x34\x00\x35\x00\xff\xff\x15\x00\x38\x00\x17\x00\xff\xff\xff\xff\xff\xff\xff\xff\x3e\x00\x1d\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\x25\x00\xff\xff\xff\xff\xff\xff\xff\xff\x2a\x00\x4d\x00\x2c\x00\x4f\x00\x50\x00\x51\x00\x01\x00\xff\xff\xff\xff\xff\xff\x34\x00\x35\x00\x36\x00\xff\xff\x38\x00\xff\xff\xff\xff\xff\xff\x3c\x00\xff\xff\x3e\x00\x3f\x00\xff\xff\xff\xff\xff\xff\xff\xff\x15\x00\xff\xff\x46\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\x4d\x00\xff\xff\x4f\x00\x50\x00\x51\x00\x01\x00\x02\x00\x03\x00\x04\x00\xff\xff\xff\xff\xff\xff\xff\xff\x09\x00\x0a\x00\x0b\x00\x0c\x00\x0d\x00\x0e\x00\x0f\x00\xff\xff\xff\xff\x34\x00\x35\x00\xff\xff\x15\x00\x38\x00\x17\x00\xff\xff\xff\xff\xff\xff\xff\xff\x3e\x00\x1d\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\x25\x00\xff\xff\xff\xff\xff\xff\xff\xff\x2a\x00\x4d\x00\x2c\x00\x4f\x00\x50\x00\x51\x00\x01\x00\xff\xff\xff\xff\xff\xff\x34\x00\x35\x00\x36\x00\xff\xff\x38\x00\xff\xff\xff\xff\xff\xff\x3c\x00\xff\xff\x3e\x00\x3f\x00\xff\xff\xff\xff\xff\xff\xff\xff\x15\x00\xff\xff\x46\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\x4d\x00\xff\xff\x4f\x00\x50\x00\x51\x00\x01\x00\x02\x00\x03\x00\x04\x00\xff\xff\xff\xff\xff\xff\xff\xff\x09\x00\x0a\x00\x0b\x00\x0c\x00\x0d\x00\x0e\x00\x0f\x00\xff\xff\xff\xff\x34\x00\x35\x00\xff\xff\x15\x00\x38\x00\x17\x00\xff\xff\xff\xff\xff\xff\xff\xff\x3e\x00\x1d\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\x25\x00\xff\xff\xff\xff\xff\xff\xff\xff\x2a\x00\x4d\x00\x2c\x00\x4f\x00\x50\x00\x51\x00\x01\x00\xff\xff\xff\xff\xff\xff\x34\x00\x35\x00\x36\x00\xff\xff\x38\x00\xff\xff\xff\xff\xff\xff\x3c\x00\xff\xff\x3e\x00\x3f\x00\xff\xff\xff\xff\xff\xff\xff\xff\x15\x00\xff\xff\x46\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\x4d\x00\xff\xff\x4f\x00\x50\x00\x51\x00\x01\x00\x02\x00\x03\x00\x04\x00\xff\xff\xff\xff\xff\xff\xff\xff\x09\x00\x0a\x00\x0b\x00\x0c\x00\x0d\x00\x0e\x00\x0f\x00\xff\xff\xff\xff\x34\x00\x35\x00\xff\xff\x15\x00\x38\x00\x17\x00\xff\xff\xff\xff\xff\xff\xff\xff\x3e\x00\x1d\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\x25\x00\xff\xff\xff\xff\xff\xff\xff\xff\x2a\x00\x4d\x00\x2c\x00\x4f\x00\x50\x00\x51\x00\x01\x00\xff\xff\xff\xff\xff\xff\x34\x00\x35\x00\x36\x00\xff\xff\x38\x00\xff\xff\xff\xff\xff\xff\x3c\x00\xff\xff\x3e\x00\x3f\x00\xff\xff\xff\xff\xff\xff\xff\xff\x15\x00\xff\xff\x46\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\x4d\x00\xff\xff\x4f\x00\x50\x00\x51\x00\x01\x00\x02\x00\x03\x00\x04\x00\xff\xff\xff\xff\xff\xff\xff\xff\x09\x00\x0a\x00\x0b\x00\x0c\x00\x0d\x00\x0e\x00\x0f\x00\xff\xff\xff\xff\x34\x00\x35\x00\xff\xff\x15\x00\x38\x00\x17\x00\xff\xff\xff\xff\xff\xff\xff\xff\x3e\x00\x1d\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\x25\x00\xff\xff\xff\xff\xff\xff\xff\xff\x2a\x00\x4d\x00\x2c\x00\x4f\x00\x50\x00\x51\x00\x01\x00\xff\xff\xff\xff\xff\xff\x34\x00\x35\x00\x36\x00\xff\xff\x38\x00\xff\xff\xff\xff\xff\xff\x3c\x00\xff\xff\x3e\x00\x3f\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\x46\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\x4d\x00\xff\xff\x4f\x00\x50\x00\x51\x00\x01\x00\x02\x00\x03\x00\x04\x00\xff\xff\xff\xff\xff\xff\xff\xff\x09\x00\x0a\x00\x0b\x00\x0c\x00\x0d\x00\x0e\x00\x0f\x00\xff\xff\xff\xff\x34\x00\x35\x00\xff\xff\x15\x00\x38\x00\x17\x00\xff\xff\xff\xff\xff\xff\xff\xff\x3e\x00\x1d\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\x25\x00\xff\xff\xff\xff\xff\xff\xff\xff\x2a\x00\x4d\x00\x2c\x00\x4f\x00\x50\x00\x51\x00\xff\xff\xff\xff\xff\xff\xff\xff\x34\x00\x35\x00\x36\x00\xff\xff\x38\x00\xff\xff\xff\xff\xff\xff\x3c\x00\xff\xff\x3e\x00\x3f\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\x46\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\x4d\x00\xff\xff\x4f\x00\x50\x00\x51\x00\x01\x00\x02\x00\x03\x00\x04\x00\xff\xff\xff\xff\xff\xff\xff\xff\x09\x00\x0a\x00\x0b\x00\x0c\x00\x0d\x00\x0e\x00\x0f\x00\x56\x00\xff\xff\xff\xff\xff\xff\xff\xff\x15\x00\xff\xff\x17\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\x1d\x00\xff\xff\xff\xff\xff\xff\xff\xff\x68\x00\xff\xff\x6a\x00\x25\x00\x6c\x00\xff\xff\xff\xff\xff\xff\x2a\x00\xff\xff\x2c\x00\xff\xff\xff\xff\x75\x00\x76\x00\x77\x00\x78\x00\xff\xff\x34\x00\x35\x00\x36\x00\xff\xff\x38\x00\xff\xff\x80\x00\x81\x00\x3c\x00\xff\xff\x3e\x00\x3f\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\x46\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\x4d\x00\xff\xff\x4f\x00\x50\x00\x51\x00\x01\x00\x02\x00\x03\x00\x04\x00\xff\xff\xff\xff\xff\xff\xff\xff\x09\x00\x0a\x00\x0b\x00\x0c\x00\x0d\x00\x0e\x00\x0f\x00\xff\xff\xff\xff\xff\xff\x6e\x00\xff\xff\x15\x00\x71\x00\x17\x00\x73\x00\xff\xff\xff\xff\xff\xff\xff\xff\x1d\x00\x79\x00\x7a\x00\x7b\x00\xff\xff\x7d\x00\xff\xff\x7f\x00\x25\x00\x81\x00\xff\xff\xff\xff\xff\xff\x2a\x00\xff\xff\x2c\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\x34\x00\x35\x00\x36\x00\xff\xff\x38\x00\xff\xff\xff\xff\xff\xff\x3c\x00\xff\xff\x3e\x00\x3f\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\x46\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\x4d\x00\xff\xff\x4f\x00\x50\x00\x51\x00\x01\x00\x02\x00\x03\x00\x04\x00\xff\xff\xff\xff\xff\xff\xff\xff\x09\x00\x0a\x00\x0b\x00\x0c\x00\x0d\x00\x0e\x00\x0f\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\x15\x00\xff\xff\x17\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\x1d\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\x25\x00\xff\xff\xff\xff\xff\xff\xff\xff\x2a\x00\xff\xff\x2c\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\x34\x00\x35\x00\x36\x00\xff\xff\x38\x00\xff\xff\xff\xff\xff\xff\x3c\x00\xff\xff\x3e\x00\x3f\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\x46\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\x4d\x00\xff\xff\x4f\x00\x50\x00\x51\x00\x01\x00\x02\x00\x03\x00\x04\x00\xff\xff\xff\xff\xff\xff\xff\xff\x09\x00\x0a\x00\x0b\x00\x0c\x00\x0d\x00\x0e\x00\x0f\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\x15\x00\xff\xff\x17\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\x1d\x00\xff\xff\xff\xff\x20\x00\xff\xff\xff\xff\x01\x00\x02\x00\x03\x00\x04\x00\xff\xff\xff\xff\xff\xff\x2a\x00\x09\x00\x0a\x00\x0b\x00\x0c\x00\x0d\x00\x0e\x00\x0f\x00\xff\xff\xff\xff\x34\x00\x35\x00\xff\xff\x15\x00\x38\x00\x17\x00\xff\xff\xff\xff\xff\xff\xff\xff\x3e\x00\x1d\x00\x05\x00\x06\x00\x07\x00\x08\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\x01\x00\xff\xff\x2a\x00\x4d\x00\x05\x00\x4f\x00\x50\x00\x51\x00\xff\xff\xff\xff\xff\xff\xff\xff\x34\x00\x35\x00\xff\xff\xff\xff\x38\x00\xff\xff\x21\x00\xff\xff\x15\x00\xff\xff\x3e\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\x2c\x00\x2d\x00\x2e\x00\x2f\x00\x30\x00\x31\x00\x32\x00\x33\x00\x4d\x00\xff\xff\x4f\x00\x50\x00\x51\x00\xff\xff\x2c\x00\x2d\x00\x2e\x00\x2f\x00\x30\x00\x31\x00\x32\x00\x33\x00\x34\x00\x35\x00\xff\xff\xff\xff\x38\x00\xff\xff\x01\x00\x02\x00\x03\x00\x04\x00\x3e\x00\x01\x00\xff\xff\x03\x00\x04\x00\xff\xff\x06\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\x4d\x00\x15\x00\x4f\x00\x50\x00\x51\x00\xff\xff\x15\x00\x16\x00\x17\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\x1d\x00\xff\xff\x1f\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\x01\x00\x28\x00\x03\x00\x04\x00\xff\xff\x06\x00\xff\xff\xff\xff\x34\x00\x35\x00\xff\xff\xff\xff\x38\x00\x34\x00\x35\x00\xff\xff\xff\xff\x38\x00\x3e\x00\xff\xff\x15\x00\xff\xff\x17\x00\x3e\x00\xff\xff\xff\xff\xff\xff\x47\x00\x1d\x00\xff\xff\xff\xff\xff\xff\x21\x00\x4d\x00\xff\xff\x4f\x00\x50\x00\x51\x00\x4d\x00\xff\xff\x4f\x00\x50\x00\x51\x00\x01\x00\x2d\x00\x03\x00\x04\x00\xff\xff\xff\xff\xff\xff\xff\xff\x34\x00\x35\x00\xff\xff\xff\xff\x38\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\x3e\x00\xff\xff\x15\x00\x16\x00\x17\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\x1d\x00\xff\xff\x1f\x00\xff\xff\xff\xff\x4d\x00\xff\xff\x4f\x00\x50\x00\x51\x00\xff\xff\x28\x00\xff\xff\xff\xff\x01\x00\xff\xff\x03\x00\x04\x00\xff\xff\x01\x00\xff\xff\x03\x00\x04\x00\x34\x00\x35\x00\xff\xff\xff\xff\x38\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\x3e\x00\x15\x00\xff\xff\x17\x00\xff\xff\xff\xff\x15\x00\xff\xff\x17\x00\x1d\x00\xff\xff\xff\xff\xff\xff\xff\xff\x1d\x00\x4d\x00\xff\xff\x4f\x00\x50\x00\x51\x00\x28\x00\xff\xff\xff\xff\x2b\x00\x01\x00\xff\xff\x03\x00\x04\x00\xff\xff\xff\xff\x2d\x00\xff\xff\x34\x00\x35\x00\xff\xff\xff\xff\x38\x00\x34\x00\x35\x00\xff\xff\xff\xff\x38\x00\x3e\x00\xff\xff\x15\x00\xff\xff\x17\x00\x3e\x00\xff\xff\xff\xff\xff\xff\xff\xff\x1d\x00\xff\xff\xff\xff\xff\xff\xff\xff\x4d\x00\xff\xff\x4f\x00\x50\x00\x51\x00\x4d\x00\xff\xff\x4f\x00\x50\x00\x51\x00\x01\x00\x2d\x00\x03\x00\x04\x00\xff\xff\xff\xff\xff\xff\xff\xff\x34\x00\x35\x00\xff\xff\xff\xff\x38\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\x3e\x00\xff\xff\x15\x00\xff\xff\x17\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\x1d\x00\xff\xff\xff\xff\xff\xff\xff\xff\x4d\x00\xff\xff\x4f\x00\x50\x00\x51\x00\xff\xff\xff\xff\x01\x00\xff\xff\x03\x00\x04\x00\x2d\x00\x01\x00\xff\xff\x03\x00\x04\x00\xff\xff\xff\xff\x34\x00\x35\x00\xff\xff\xff\xff\x38\x00\xff\xff\xff\xff\xff\xff\xff\xff\x15\x00\x3e\x00\x17\x00\xff\xff\xff\xff\x15\x00\xff\xff\x17\x00\x1d\x00\x05\x00\x06\x00\x07\x00\x08\x00\x1d\x00\xff\xff\xff\xff\x4d\x00\xff\xff\x4f\x00\x50\x00\x51\x00\xff\xff\x2b\x00\xff\xff\x01\x00\x02\x00\x03\x00\x04\x00\xff\xff\x2d\x00\xff\xff\x34\x00\x35\x00\xff\xff\xff\xff\x38\x00\x34\x00\x35\x00\xff\xff\xff\xff\x38\x00\x3e\x00\xff\xff\xff\xff\x15\x00\x16\x00\x3e\x00\xff\xff\x2c\x00\x2d\x00\x2e\x00\x2f\x00\x30\x00\x31\x00\x32\x00\x33\x00\x4d\x00\x22\x00\x4f\x00\x50\x00\x51\x00\x4d\x00\xff\xff\x4f\x00\x50\x00\x51\x00\x01\x00\xff\xff\x03\x00\x04\x00\xff\xff\x01\x00\x02\x00\x03\x00\x04\x00\x34\x00\x35\x00\xff\xff\xff\xff\x38\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\x3e\x00\x15\x00\xff\xff\x17\x00\xff\xff\xff\xff\x15\x00\x16\x00\xff\xff\x1d\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\x4d\x00\xff\xff\x4f\x00\x50\x00\x51\x00\x28\x00\xff\xff\xff\xff\x01\x00\xff\xff\x03\x00\x04\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\x34\x00\x35\x00\xff\xff\xff\xff\x38\x00\x34\x00\x35\x00\xff\xff\xff\xff\x38\x00\x3e\x00\x15\x00\xff\xff\x17\x00\xff\xff\x3e\x00\xff\xff\xff\xff\xff\xff\x1d\x00\x1e\x00\xff\xff\xff\xff\xff\xff\x47\x00\x4d\x00\xff\xff\x4f\x00\x50\x00\x51\x00\x4d\x00\xff\xff\x4f\x00\x50\x00\x51\x00\x01\x00\xff\xff\x03\x00\x04\x00\xff\xff\xff\xff\xff\xff\x34\x00\x35\x00\xff\xff\xff\xff\x38\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\x3e\x00\xff\xff\xff\xff\x15\x00\xff\xff\x17\x00\x18\x00\xff\xff\xff\xff\xff\xff\xff\xff\x1d\x00\xff\xff\xff\xff\xff\xff\x4d\x00\xff\xff\x4f\x00\x50\x00\x51\x00\x01\x00\xff\xff\x03\x00\x04\x00\xff\xff\x01\x00\xff\xff\x03\x00\x04\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\x34\x00\x35\x00\xff\xff\xff\xff\x38\x00\xff\xff\x15\x00\xff\xff\x17\x00\xff\xff\x3e\x00\x15\x00\xff\xff\x17\x00\x1d\x00\xff\xff\xff\xff\xff\xff\xff\xff\x1d\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\x4d\x00\xff\xff\x4f\x00\x50\x00\x51\x00\xff\xff\x01\x00\xff\xff\x03\x00\x04\x00\xff\xff\xff\xff\x34\x00\x35\x00\xff\xff\xff\xff\x38\x00\x34\x00\x35\x00\xff\xff\xff\xff\x38\x00\x3e\x00\xff\xff\xff\xff\xff\xff\x15\x00\x3e\x00\x17\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\x1d\x00\xff\xff\xff\xff\x4d\x00\xff\xff\x4f\x00\x50\x00\x51\x00\x4d\x00\xff\xff\x4f\x00\x50\x00\x51\x00\xff\xff\x01\x00\xff\xff\x03\x00\x04\x00\xff\xff\x01\x00\xff\xff\x03\x00\x04\x00\x34\x00\x35\x00\xff\xff\xff\xff\x38\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\x3e\x00\x15\x00\xff\xff\x17\x00\xff\xff\xff\xff\x15\x00\xff\xff\x17\x00\x1d\x00\xff\xff\xff\xff\xff\xff\xff\xff\x1d\x00\x4d\x00\xff\xff\x4f\x00\x50\x00\x51\x00\xff\xff\xff\xff\xff\xff\x01\x00\xff\xff\x03\x00\x04\x00\xff\xff\x01\x00\xff\xff\x03\x00\x04\x00\x34\x00\x35\x00\xff\xff\xff\xff\x38\x00\x34\x00\x35\x00\xff\xff\xff\xff\x38\x00\x3e\x00\x15\x00\xff\xff\x17\x00\xff\xff\x3e\x00\x15\x00\xff\xff\x17\x00\x1d\x00\xff\xff\xff\xff\xff\xff\xff\xff\x1d\x00\x4d\x00\xff\xff\x4f\x00\x50\x00\x51\x00\x4d\x00\xff\xff\x4f\x00\x50\x00\x51\x00\xff\xff\x01\x00\xff\xff\x03\x00\x04\x00\xff\xff\xff\xff\x34\x00\x35\x00\xff\xff\xff\xff\x38\x00\x34\x00\x35\x00\xff\xff\xff\xff\x38\x00\x3e\x00\xff\xff\xff\xff\xff\xff\x15\x00\x3e\x00\x17\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\x1d\x00\xff\xff\xff\xff\x4d\x00\xff\xff\x4f\x00\x50\x00\x51\x00\x4d\x00\xff\xff\x4f\x00\x50\x00\x51\x00\xff\xff\x01\x00\xff\xff\x03\x00\x04\x00\xff\xff\x01\x00\xff\xff\x03\x00\x04\x00\x34\x00\x35\x00\xff\xff\xff\xff\x38\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\x3e\x00\x15\x00\xff\xff\x17\x00\xff\xff\xff\xff\x15\x00\xff\xff\x17\x00\x1d\x00\xff\xff\xff\xff\xff\xff\xff\xff\x1d\x00\x4d\x00\xff\xff\x4f\x00\x50\x00\x51\x00\xff\xff\xff\xff\xff\xff\x01\x00\xff\xff\x03\x00\x04\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\x34\x00\x35\x00\xff\xff\xff\xff\x38\x00\x34\x00\x35\x00\xff\xff\xff\xff\x38\x00\x3e\x00\x15\x00\xff\xff\x17\x00\x53\x00\x3e\x00\x55\x00\x56\x00\xff\xff\x1d\x00\xff\xff\xff\xff\xff\xff\xff\xff\x01\x00\x4d\x00\x03\x00\x4f\x00\x50\x00\x51\x00\x4d\x00\x01\x00\x4f\x00\x50\x00\x51\x00\x68\x00\xff\xff\x6a\x00\xff\xff\x6c\x00\xff\xff\xff\xff\x34\x00\x35\x00\x15\x00\x16\x00\x38\x00\xff\xff\x75\x00\x76\x00\x77\x00\x78\x00\x3e\x00\xff\xff\xff\xff\xff\xff\xff\xff\x22\x00\xff\xff\x80\x00\x81\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\x24\x00\x4d\x00\xff\xff\x4f\x00\x50\x00\x51\x00\xff\xff\xff\xff\xff\xff\x34\x00\x35\x00\xff\xff\x05\x00\x38\x00\x07\x00\xff\xff\x34\x00\x35\x00\x4c\x00\x3e\x00\x38\x00\xff\xff\xff\xff\x51\x00\x52\x00\x53\x00\x3e\x00\x55\x00\x56\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\x4d\x00\xff\xff\x4f\x00\x50\x00\x51\x00\xff\xff\xff\xff\x4d\x00\x05\x00\x4f\x00\x50\x00\x51\x00\x68\x00\xff\xff\x6a\x00\xff\xff\x6c\x00\x2c\x00\x2d\x00\x2e\x00\x2f\x00\x30\x00\x31\x00\x32\x00\x33\x00\x75\x00\x76\x00\x77\x00\x78\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\x80\x00\x81\x00\x50\x00\x51\x00\x52\x00\x53\x00\xff\xff\x55\x00\x56\x00\x57\x00\x58\x00\x2c\x00\x2d\x00\x2e\x00\x2f\x00\x30\x00\x31\x00\x32\x00\x33\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\x68\x00\xff\xff\x6a\x00\xff\xff\x6c\x00\xff\xff\xff\xff\x6f\x00\xff\xff\x71\x00\xff\xff\xff\xff\x74\x00\x75\x00\x76\x00\x77\x00\x78\x00\x79\x00\x7a\x00\x7b\x00\x7c\x00\x7d\x00\x7e\x00\x7f\x00\x80\x00\x81\x00\x50\x00\x51\x00\x52\x00\x53\x00\xff\xff\x55\x00\x56\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\x5c\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\x64\x00\x65\x00\xff\xff\xff\xff\x68\x00\xff\xff\x6a\x00\xff\xff\x6c\x00\xff\xff\x50\x00\x51\x00\x52\x00\x53\x00\xff\xff\x55\x00\x56\x00\x75\x00\x76\x00\x77\x00\x78\x00\xff\xff\x5c\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\x80\x00\x81\x00\x64\x00\x65\x00\xff\xff\xff\xff\x68\x00\xff\xff\x6a\x00\xff\xff\x6c\x00\xff\xff\x50\x00\x51\x00\x52\x00\x53\x00\xff\xff\x55\x00\x56\x00\x75\x00\x76\x00\x77\x00\x78\x00\x5b\x00\x5c\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\x80\x00\x81\x00\xff\xff\xff\xff\xff\xff\xff\xff\x68\x00\xff\xff\x6a\x00\xff\xff\x6c\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\x75\x00\x76\x00\x77\x00\x78\x00\x50\x00\x51\x00\x52\x00\x53\x00\xff\xff\x55\x00\x56\x00\x80\x00\x81\x00\x59\x00\x5a\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\x50\x00\x51\x00\x52\x00\x53\x00\xff\xff\x55\x00\x56\x00\x68\x00\xff\xff\x6a\x00\xff\xff\x6c\x00\x5c\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\x75\x00\x76\x00\x77\x00\x78\x00\x68\x00\xff\xff\x6a\x00\xff\xff\x6c\x00\xff\xff\xff\xff\x80\x00\x81\x00\xff\xff\xff\xff\xff\xff\xff\xff\x75\x00\x76\x00\x77\x00\x78\x00\x50\x00\x51\x00\x52\x00\x53\x00\xff\xff\x55\x00\x56\x00\x80\x00\x81\x00\xff\xff\xff\xff\xff\xff\x5c\x00\xff\xff\xff\xff\xff\xff\xff\xff\x50\x00\x51\x00\x52\x00\x53\x00\xff\xff\x55\x00\x56\x00\x68\x00\x58\x00\x6a\x00\xff\xff\x6c\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\x75\x00\x76\x00\x77\x00\x78\x00\x68\x00\xff\xff\x6a\x00\xff\xff\x6c\x00\xff\xff\xff\xff\x80\x00\x81\x00\xff\xff\xff\xff\xff\xff\xff\xff\x75\x00\x76\x00\x77\x00\x78\x00\x50\x00\x51\x00\x52\x00\x53\x00\xff\xff\x55\x00\x56\x00\x80\x00\x81\x00\xff\xff\xff\xff\xff\xff\x5c\x00\xff\xff\xff\xff\xff\xff\xff\xff\x50\x00\x51\x00\x52\x00\x53\x00\xff\xff\x55\x00\x56\x00\x68\x00\xff\xff\x6a\x00\xff\xff\x6c\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\x75\x00\x76\x00\x77\x00\x78\x00\x68\x00\xff\xff\x6a\x00\xff\xff\x6c\x00\xff\xff\xff\xff\x80\x00\x81\x00\xff\xff\xff\xff\xff\xff\xff\xff\x75\x00\x76\x00\x77\x00\x78\x00\x50\x00\x51\x00\x52\x00\x53\x00\xff\xff\x55\x00\x56\x00\x80\x00\x81\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\x50\x00\x51\x00\x52\x00\x53\x00\xff\xff\x55\x00\x56\x00\x68\x00\xff\xff\x6a\x00\xff\xff\x6c\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\x75\x00\x76\x00\x77\x00\x78\x00\x68\x00\xff\xff\x6a\x00\xff\xff\x6c\x00\xff\xff\xff\xff\x80\x00\x81\x00\xff\xff\xff\xff\xff\xff\xff\xff\x75\x00\x76\x00\x77\x00\x78\x00\x50\x00\x51\x00\x52\x00\x53\x00\xff\xff\x55\x00\x56\x00\x80\x00\x81\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\x50\x00\x51\x00\x52\x00\x53\x00\xff\xff\x55\x00\x56\x00\x68\x00\xff\xff\x6a\x00\xff\xff\x6c\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\x75\x00\x76\x00\x77\x00\x78\x00\x68\x00\xff\xff\x6a\x00\xff\xff\x6c\x00\xff\xff\xff\xff\x80\x00\x81\x00\xff\xff\xff\xff\xff\xff\xff\xff\x75\x00\x76\x00\x77\x00\x78\x00\x50\x00\x51\x00\x52\x00\x53\x00\xff\xff\x55\x00\x56\x00\x80\x00\x81\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\x50\x00\x51\x00\x52\x00\x53\x00\xff\xff\x55\x00\x56\x00\x68\x00\xff\xff\x6a\x00\xff\xff\x6c\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\x75\x00\x76\x00\x77\x00\x78\x00\x68\x00\xff\xff\x6a\x00\xff\xff\x6c\x00\xff\xff\xff\xff\x80\x00\x81\x00\xff\xff\xff\xff\xff\xff\xff\xff\x75\x00\x76\x00\x77\x00\x78\x00\x50\x00\x51\x00\x52\x00\x53\x00\xff\xff\x55\x00\x56\x00\x80\x00\x81\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\x50\x00\x51\x00\x52\x00\x53\x00\xff\xff\x55\x00\x56\x00\x68\x00\xff\xff\x6a\x00\xff\xff\x6c\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\x75\x00\x76\x00\x77\x00\x78\x00\x68\x00\xff\xff\x6a\x00\xff\xff\x6c\x00\xff\xff\xff\xff\x80\x00\x81\x00\xff\xff\xff\xff\xff\xff\xff\xff\x75\x00\x76\x00\x77\x00\x78\x00\x50\x00\x51\x00\x52\x00\x53\x00\xff\xff\x55\x00\x56\x00\x80\x00\x81\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\x50\x00\x51\x00\x52\x00\x53\x00\xff\xff\x55\x00\x56\x00\x68\x00\xff\xff\x6a\x00\xff\xff\x6c\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\x75\x00\x76\x00\x77\x00\x78\x00\x68\x00\xff\xff\x6a\x00\xff\xff\x6c\x00\xff\xff\xff\xff\x80\x00\x81\x00\xff\xff\xff\xff\xff\xff\xff\xff\x75\x00\x76\x00\x77\x00\x78\x00\x50\x00\x51\x00\x52\x00\x53\x00\xff\xff\x55\x00\x56\x00\x80\x00\x81\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\x50\x00\x51\x00\x52\x00\x53\x00\xff\xff\x55\x00\x56\x00\x68\x00\xff\xff\x6a\x00\xff\xff\x6c\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\x75\x00\x76\x00\x77\x00\x78\x00\x68\x00\xff\xff\x6a\x00\xff\xff\x6c\x00\xff\xff\xff\xff\x80\x00\x81\x00\xff\xff\xff\xff\xff\xff\xff\xff\x75\x00\x76\x00\x77\x00\x78\x00\x50\x00\x51\x00\x52\x00\x53\x00\xff\xff\x55\x00\x56\x00\x80\x00\x81\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\x50\x00\x51\x00\x52\x00\x53\x00\xff\xff\x55\x00\x56\x00\x68\x00\xff\xff\x6a\x00\xff\xff\x6c\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\x75\x00\x76\x00\x77\x00\x78\x00\x68\x00\xff\xff\x6a\x00\xff\xff\x6c\x00\xff\xff\xff\xff\x80\x00\x81\x00\xff\xff\xff\xff\xff\xff\xff\xff\x75\x00\x76\x00\x77\x00\x78\x00\x50\x00\x51\x00\x52\x00\x53\x00\xff\xff\x55\x00\x56\x00\x80\x00\x81\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\x50\x00\x51\x00\x52\x00\x53\x00\xff\xff\x55\x00\x56\x00\x68\x00\xff\xff\x6a\x00\xff\xff\x6c\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\x75\x00\x76\x00\x77\x00\x78\x00\x68\x00\xff\xff\x6a\x00\xff\xff\x6c\x00\xff\xff\xff\xff\x80\x00\x81\x00\xff\xff\xff\xff\xff\xff\xff\xff\x75\x00\x76\x00\x77\x00\x78\x00\x50\x00\x51\x00\x52\x00\x53\x00\xff\xff\x55\x00\x56\x00\x80\x00\x81\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\x50\x00\x51\x00\x52\x00\x53\x00\xff\xff\x55\x00\x56\x00\x68\x00\xff\xff\x6a\x00\xff\xff\x6c\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\x75\x00\x76\x00\x77\x00\x78\x00\x68\x00\xff\xff\x6a\x00\xff\xff\x6c\x00\xff\xff\xff\xff\x80\x00\x81\x00\xff\xff\xff\xff\xff\xff\xff\xff\x75\x00\x76\x00\x77\x00\x78\x00\x50\x00\x51\x00\x52\x00\x53\x00\xff\xff\x55\x00\x56\x00\x80\x00\x81\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\x50\x00\x51\x00\x52\x00\x53\x00\xff\xff\x55\x00\x56\x00\x68\x00\xff\xff\x6a\x00\xff\xff\x6c\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\x75\x00\x76\x00\x77\x00\x78\x00\x68\x00\xff\xff\x6a\x00\xff\xff\x6c\x00\xff\xff\xff\xff\x80\x00\x81\x00\xff\xff\xff\xff\xff\xff\xff\xff\x75\x00\x76\x00\x77\x00\x78\x00\x50\x00\x51\x00\x52\x00\x53\x00\xff\xff\x55\x00\x56\x00\x80\x00\x81\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\x50\x00\x51\x00\x52\x00\x53\x00\xff\xff\x55\x00\x56\x00\x68\x00\xff\xff\x6a\x00\xff\xff\x6c\x00\x05\x00\x06\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\x75\x00\x76\x00\x77\x00\x78\x00\x68\x00\xff\xff\x6a\x00\xff\xff\x6c\x00\xff\xff\xff\xff\x80\x00\x81\x00\xff\xff\xff\xff\xff\xff\xff\xff\x75\x00\x76\x00\x77\x00\x78\x00\x50\x00\x51\x00\x52\x00\x53\x00\xff\xff\x55\x00\x56\x00\x80\x00\x81\x00\xff\xff\x2c\x00\x2d\x00\x2e\x00\x2f\x00\x30\x00\x31\x00\x32\x00\x33\x00\x51\x00\x52\x00\x53\x00\xff\xff\x55\x00\x56\x00\x68\x00\xff\xff\x6a\x00\xff\xff\x6c\x00\xff\xff\xff\xff\x5e\x00\x5f\x00\xff\xff\xff\xff\xff\xff\xff\xff\x75\x00\x76\x00\x77\x00\x78\x00\x68\x00\xff\xff\x6a\x00\xff\xff\x6c\x00\xff\xff\xff\xff\x80\x00\x81\x00\xff\xff\xff\xff\xff\xff\xff\xff\x75\x00\x76\x00\x77\x00\x78\x00\x51\x00\x52\x00\x53\x00\xff\xff\x55\x00\x56\x00\xff\xff\x80\x00\x81\x00\xff\xff\xff\xff\xff\xff\xff\xff\x5e\x00\x5f\x00\xff\xff\xff\xff\x51\x00\x52\x00\x53\x00\xff\xff\x55\x00\x56\x00\x68\x00\xff\xff\x6a\x00\xff\xff\x6c\x00\xff\xff\xff\xff\xff\xff\x5f\x00\xff\xff\xff\xff\xff\xff\xff\xff\x75\x00\x76\x00\x77\x00\x78\x00\x68\x00\xff\xff\x6a\x00\xff\xff\x6c\x00\xff\xff\xff\xff\x80\x00\x81\x00\xff\xff\xff\xff\xff\xff\xff\xff\x75\x00\x76\x00\x77\x00\x78\x00\x51\x00\x52\x00\x53\x00\xff\xff\x55\x00\x56\x00\xff\xff\x80\x00\x81\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\x52\x00\x53\x00\xff\xff\x55\x00\x56\x00\x68\x00\xff\xff\x6a\x00\xff\xff\x6c\x00\xff\xff\x05\x00\x06\x00\x07\x00\x08\x00\xff\xff\xff\xff\xff\xff\x75\x00\x76\x00\x77\x00\x78\x00\x68\x00\xff\xff\x6a\x00\xff\xff\x6c\x00\xff\xff\xff\xff\x80\x00\x81\x00\x05\x00\x06\x00\x07\x00\x08\x00\x75\x00\x76\x00\x77\x00\x78\x00\x21\x00\xff\xff\x23\x00\xff\xff\xff\xff\xff\xff\x27\x00\x80\x00\x81\x00\x16\x00\xff\xff\x2c\x00\x2d\x00\x2e\x00\x2f\x00\x30\x00\x31\x00\x32\x00\x33\x00\xff\xff\x21\x00\x05\x00\x06\x00\x07\x00\x08\x00\xff\xff\xff\xff\xff\xff\xff\xff\x05\x00\x06\x00\x2c\x00\x2d\x00\x2e\x00\x2f\x00\x30\x00\x31\x00\x32\x00\x33\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\x21\x00\xff\xff\x23\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\x21\x00\xff\xff\xff\xff\x2c\x00\x2d\x00\x2e\x00\x2f\x00\x30\x00\x31\x00\x32\x00\x33\x00\x2c\x00\x2d\x00\x2e\x00\x2f\x00\x30\x00\x31\x00\x32\x00\x33\x00\x54\x00\x55\x00\x56\x00\xff\xff\xff\xff\xff\xff\x55\x00\x56\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\x68\x00\xff\xff\x6a\x00\xff\xff\x6c\x00\x68\x00\xff\xff\x6a\x00\xff\xff\x6c\x00\xff\xff\xff\xff\xff\xff\x75\x00\x76\x00\x77\x00\x78\x00\xff\xff\x75\x00\x76\x00\x77\x00\x78\x00\x55\x00\x56\x00\x80\x00\x81\x00\xff\xff\x55\x00\x56\x00\x80\x00\x81\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\x68\x00\xff\xff\x6a\x00\xff\xff\x6c\x00\x68\x00\xff\xff\x6a\x00\xff\xff\x6c\x00\xff\xff\xff\xff\xff\xff\x75\x00\x76\x00\x77\x00\x78\x00\xff\xff\x75\x00\x76\x00\x77\x00\x78\x00\xff\xff\xff\xff\x80\x00\x81\x00\xff\xff\xff\xff\xff\xff\x80\x00\x81\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff"#

happyTable :: HappyAddr
happyTable = HappyA# "\x00\x00\x35\x00\x33\x00\x34\x00\xa8\x01\x35\x00\x35\x00\xcb\x00\x31\x00\x99\x01\x7e\x01\x37\x01\x38\x01\x35\x00\x35\x00\x35\x00\x35\x00\x35\x00\x35\x00\x35\x00\x35\x00\x38\x02\xf9\x00\x46\x01\x47\x01\xf8\x01\x46\x01\x49\x01\x39\x02\x57\x01\x60\x00\x4e\x02\x87\x01\x29\x02\x38\x00\x17\x00\x18\x00\xd5\x01\x3a\x02\x57\x01\xcf\x00\xe6\x00\x66\x02\x39\x00\x3a\x00\x15\x02\xc7\x01\xd9\x01\x2e\x02\xa5\x00\x3b\x00\x08\x02\x74\x02\x8a\x01\xf6\x01\x2b\x01\xca\x01\x5d\x02\x39\x00\x3a\x00\x2a\x01\x2b\x01\xb5\x01\x56\x01\x57\x01\x59\x01\x57\x01\x2b\x01\xd0\x00\x17\x00\x18\x00\x92\x01\xb0\x01\x2b\x01\xf4\x00\xf5\x00\xba\x00\x8b\x01\x8c\x01\x8d\x01\x8e\x01\x8f\x01\x90\x01\x00\x01\x6d\x01\xbb\x00\xbc\x00\xe4\x01\xfa\x00\x3b\x00\x33\x01\xf5\x01\x09\x02\xe6\x01\x93\x01\xa8\x00\x58\x01\x57\x02\x45\x02\xbd\x00\xbe\x00\x55\x02\xfb\x00\x6e\x01\x3b\x00\x07\x01\x88\x01\x11\x00\xbf\x00\x39\x01\xac\x00\xad\x00\xae\x00\x11\x02\x41\x00\x58\x01\x59\x02\x44\x02\x45\x02\xb5\x01\x0e\x00\x0f\x00\x3a\x01\x11\x00\x48\x01\x58\x01\x9e\x01\x48\x01\x3c\x00\x5b\x02\x33\x02\xdd\x01\x36\x00\x36\x00\x93\x01\x9a\x01\x32\x00\x32\x00\x3b\x01\xa2\x01\x3c\x00\x3c\x00\xe7\x00\x08\x01\x3c\x00\x3c\x00\x42\x00\xec\x01\x48\x01\xaf\x00\x58\x01\xcc\x00\x58\x01\x39\x01\xc0\x00\x06\x00\x07\x00\x34\x01\x08\x00\x09\x00\xbb\x00\xbc\x00\x6e\x01\xe6\x01\x0e\x00\x0f\x00\x3a\x01\x11\x00\x0e\x00\x0f\x00\xa8\x00\xfc\x01\x87\x01\x75\x02\xbd\x00\xbe\x00\x59\x00\x0b\x00\x5b\x00\xb1\x00\x76\x00\x0d\x00\x3b\x01\xbf\x00\x46\x02\xac\x00\xad\x00\xae\x00\x0a\x02\x87\x01\x0e\x00\x0f\x00\x10\x00\x11\x00\x6e\x01\x9f\x01\xeb\x00\x2b\x01\xa0\x01\x47\x02\x1b\x02\x12\x00\xc1\x00\x70\x02\x46\x02\xcc\x01\xcd\x01\xa7\x00\xa2\x01\x6e\x00\x9f\x01\xa3\x01\x48\x02\xa0\x01\x84\x02\xa1\x01\x2a\x02\x2b\x01\x85\x02\x47\x02\x8c\x02\x2c\x02\x43\x01\xa2\x01\xaf\x00\xa8\x00\xa3\x01\x71\x02\x72\x02\xc0\x00\x06\x00\x07\x00\x48\x02\x08\x00\x09\x00\x2b\x01\xa9\x00\xaa\x00\xab\x00\x64\x02\xac\x00\xad\x00\xae\x00\xec\x00\xed\x00\xee\x00\x88\x01\x11\x00\x77\x02\x78\x02\x17\x00\x18\x00\x0b\x00\x6e\x00\xb1\x00\x7a\x01\x0d\x00\x34\x02\x70\x02\x46\x02\x7b\x01\x0c\x01\xa7\x00\x88\x01\x11\x00\x0e\x00\x0f\x00\x10\x00\x11\x00\x14\x02\x34\x01\x00\x01\x2b\x01\x35\x02\x47\x02\x86\x02\x12\x00\xc1\x00\x4c\x02\xaf\x00\xa8\x00\x0e\x00\x0f\x00\x8b\x02\xb0\x00\x06\x00\x07\x00\x48\x02\x08\x00\x09\x00\x81\x02\xb5\x00\xaa\x00\xab\x00\x04\x02\xac\x00\xad\x00\xae\x00\x8d\x02\x82\x02\xd4\x00\xce\x01\xff\x01\xcf\x01\x79\x02\x4a\x02\x7a\x02\x0b\x00\xd4\x01\xb1\x00\xd5\x01\x0d\x00\x0e\x00\x0f\x00\x10\x00\x11\x00\xce\x01\x2b\x01\xcf\x01\x7b\x02\x0e\x00\x0f\x00\x10\x00\x11\x00\xc1\x01\x34\x01\xc2\x01\x0e\x00\x0f\x00\x10\x00\x11\x00\x12\x00\xb2\x00\x79\x02\xaf\x00\x7a\x02\x0e\x00\x0f\x00\x37\x02\xb0\x00\x06\x00\x07\x00\xff\x01\x08\x00\x09\x00\x22\x02\x2b\x01\x38\x02\x7b\x02\x14\x02\xe5\x01\x39\x00\xd1\x00\x9d\x01\x23\x02\xe4\x01\xe5\x01\xd2\x00\xd3\x00\x76\x01\xd4\x00\x97\x01\x0b\x00\x98\x01\xb1\x00\x7c\x01\x0d\x00\x00\x02\x92\x00\xd6\x00\xd7\x00\x11\x00\x78\x01\x01\x02\x02\x02\x0e\x00\x0f\x00\x10\x00\x11\x00\xb0\x00\x06\x00\x07\x00\x1d\x01\x08\x00\x09\x00\x87\x00\x12\x00\xb2\x00\xd8\x00\xe7\x01\x87\x01\xe1\x01\x11\x00\x5c\x01\xe1\x01\x11\x00\x0e\x00\x0f\x00\x52\x01\xd3\x00\x11\x02\xd4\x00\x0b\x00\x6e\x01\x0c\x00\x5d\x01\x0d\x00\x00\x02\x63\x02\x6b\x02\xd3\x00\xe2\x01\xd4\x00\x03\x02\x02\x02\x0e\x00\x0f\x00\x10\x00\x11\x00\xb0\x00\x06\x00\x07\x00\xe6\x01\x08\x00\x09\x00\x3f\x01\x12\x00\x13\x00\xe6\x01\xd6\x00\xd7\x00\x11\x00\x77\x01\x96\xff\xa8\x00\x15\x00\x8f\x00\x96\xff\x40\x01\xbe\x00\xfb\x01\x78\x01\x0b\x00\x6f\x00\x0c\x00\x90\x00\x0d\x00\xbf\x00\xd8\x00\xac\x00\xad\x00\xae\x00\xe1\x01\x11\x00\x09\x02\x0e\x00\x0f\x00\x10\x00\x11\x00\x05\x02\x06\x02\x86\x01\x87\x01\xa8\x00\x88\x01\x11\x00\x12\x00\x13\x00\x41\x01\x12\x02\xd6\x00\xd7\x00\x11\x00\x18\x01\x17\x02\x91\x00\xbf\x00\x19\x01\xac\x00\xad\x00\xae\x00\xd6\x00\xd7\x00\x11\x00\x92\x00\x0c\x02\x26\x00\x27\x00\xaf\x00\xd8\x00\x29\x00\x0f\x02\xa8\x00\xc0\x00\x06\x00\x07\x00\x2b\x00\x08\x00\x09\x00\x9a\x00\xd8\x00\x94\x00\x9b\x00\x17\x00\x18\x00\x29\x01\x9c\x00\xac\x00\xad\x00\xae\x00\x95\x00\x2e\x00\x7d\x01\x2f\x00\x30\x00\x31\x00\x0b\x00\xaf\x00\xb1\x00\x7a\x01\x0d\x00\x96\x00\xc0\x00\x06\x00\x07\x00\x19\x02\x08\x00\x09\x00\x90\x00\x0e\x00\x0f\x00\x10\x00\x11\x00\x67\x01\x27\x02\xd4\x00\x88\x01\x11\x00\x39\x00\x3e\x00\x12\x00\xc1\x00\xdb\x01\xdc\x01\xdd\x01\x0b\x00\xaf\x00\xb1\x00\xc4\x01\x0d\x00\x6e\x00\xb0\x00\x06\x00\x07\x00\xd7\x01\x08\x00\x09\x00\x88\x02\x0e\x00\x0f\x00\x10\x00\x11\x00\x52\x01\xd3\x00\xc8\x01\xd4\x00\xcf\x00\x85\x00\x86\x00\x12\x00\xc1\x00\x87\x00\x97\x00\x32\x01\x0b\x00\x33\x01\xb1\x00\xda\x01\x0d\x00\x95\x00\xf2\xff\x89\x02\x0e\x00\x0f\x00\xec\x00\xed\x00\xee\x00\x0e\x00\x0f\x00\x10\x00\x11\x00\x39\x00\xb9\x00\xba\x00\xd0\x00\x5f\x01\x0e\x02\x0f\x02\x12\x00\xb2\x00\x52\x01\xd3\x00\x60\x01\xd4\x00\xd6\x00\xd7\x00\x11\x00\x61\x01\x5f\x01\x81\x00\x0f\x00\x82\x00\x11\x00\x52\x01\xd3\x00\x60\x01\xd4\x00\xbd\x01\xbe\x01\xbf\x01\x61\x01\xd1\x00\x32\x01\xd8\x00\x33\x01\x43\x01\xd2\x00\xd3\x00\xde\x01\xd4\x00\x50\x02\x39\x00\x3e\x00\xea\x01\xd6\x00\xd7\x00\x11\x00\xd1\x00\x2e\x01\x2f\x01\x30\x01\x62\x01\xd2\x00\xd3\x00\xe9\x01\xd4\x00\xfa\x01\x39\x00\xee\x01\xef\x01\xd1\x00\xb9\x00\xba\x00\xd8\x00\x62\x01\xd2\x00\xd3\x00\xd1\x00\xd4\x00\xee\x01\x39\x00\x3a\x00\xd2\x00\xd3\x00\x6c\x01\xd4\x00\xf0\x01\x8a\x00\x0f\x00\x82\x00\x11\x00\x80\x01\xd6\x00\xd7\x00\x11\x00\x83\x01\x59\x02\x85\x01\x6e\x02\xd3\x00\x90\x01\xd4\x00\x94\x01\x63\x01\xd1\x00\xd6\x00\xd7\x00\x11\x00\x93\x01\xd2\x00\xd3\x00\xd8\x00\xd4\x00\xb4\x01\x6f\x02\x96\x01\x63\x01\xd1\x00\xd6\x00\xd7\x00\x11\x00\x99\x01\xd2\x00\xd3\x00\xd8\x00\xd4\x00\x4d\x01\xb9\x00\xba\x00\x39\x00\xe9\x00\x39\x00\x0a\x01\xd1\x00\xd6\x00\xd7\x00\x11\x00\xd8\x00\xd2\x00\xd3\x00\x9d\x01\xd4\x00\x4e\x01\xa7\x01\x39\x00\x3e\x00\xa9\x01\xd6\x00\xd7\x00\x11\x00\xb9\x00\xba\x00\xab\x01\xd8\x00\xd6\x00\xd7\x00\x11\x00\x39\x00\x3e\x00\xd1\x00\xb2\x01\x6c\x02\xb5\x01\xd4\x00\xd2\x00\xd3\x00\xd8\x00\xd4\x00\x55\x01\xd1\x00\xd6\x00\xd7\x00\x11\x00\xd8\x00\xd2\x00\xd3\x00\xb6\x01\xd4\x00\xd5\x00\xd1\x00\xb7\x01\xd6\x00\xd7\x00\x11\x00\xd2\x00\xd3\x00\xb9\x01\xd4\x00\xe1\x00\xd8\x00\x39\x00\x44\x00\x35\x01\xd1\x00\xd6\x00\xd7\x00\x11\x00\x44\x01\xd2\x00\xd3\x00\xd8\x00\xd4\x00\x1c\x01\x36\x01\x4b\x01\x53\x01\x4c\x01\x4f\x01\x66\x01\x86\x02\xd6\x00\xd7\x00\x11\x00\xd8\x00\x52\x01\xd3\x00\xc9\x01\xd4\x00\xcd\x00\x6a\x01\xd3\x01\x52\x01\xd3\x00\xd0\x00\xd4\x00\x52\x01\xd3\x00\xde\x00\xd4\x00\xd8\x00\xdf\x00\xe0\x00\xd6\x00\xd7\x00\x11\x00\xe9\x00\xd6\x00\xd7\x00\x11\x00\xe3\x00\xfc\x00\xef\x00\xf1\x00\xf8\x00\xf1\x01\xe9\x00\xd6\x00\xd7\x00\x11\x00\x52\x01\xd3\x00\xd8\x00\xd4\x00\x00\x01\xf2\x01\xd8\x00\xd6\x00\xd7\x00\x11\x00\x52\x01\xd3\x00\x04\x01\xd4\x00\xfe\x00\x0a\x01\xd8\x00\xa6\x00\x88\x02\xf3\x01\x80\x00\xd6\x00\xd7\x00\x11\x00\x52\x01\xd3\x00\xd8\x00\xd4\x00\x70\x01\x46\x00\x03\x00\xb7\x00\x80\x02\x52\x01\xd3\x00\x17\x00\xd4\x00\xd6\x00\xd7\x00\x11\x00\xd8\x00\x6b\x02\x83\x02\x74\x02\xd6\x00\xd7\x00\x11\x00\x57\x02\xd6\x00\xd7\x00\x11\x00\x77\x02\x71\x01\x53\x02\x55\x02\x57\x02\xd8\x00\x52\x01\xd3\x00\x62\x02\xd4\x00\xe4\xfe\x5d\x02\xd8\x00\xd4\x00\x3b\x02\xd3\x00\xd8\x00\xd4\x00\x5b\x02\xe0\x01\x44\x02\xd6\x00\xd7\x00\x11\x00\x4c\x02\x5e\x02\x63\x02\x3c\x02\x3d\x02\x51\x01\x3e\x02\xd6\x00\xd7\x00\x11\x00\x52\x01\xd3\x00\x5a\x01\xd4\x00\x69\x02\x8d\x00\xd8\x00\x52\x01\xd3\x00\x2e\x02\xd4\x00\xd6\x00\xd7\x00\x11\x00\x31\x02\xd3\x00\xd8\x00\xd4\x00\x4e\x02\x32\x02\xd6\x00\xd7\x00\x11\x00\x6d\x02\xfa\x01\xd4\x00\x50\x02\xfe\x01\x93\x01\x58\x02\xd8\x00\xd4\x00\xff\x01\x93\x01\x0c\x02\x67\x01\x1d\x02\xd4\x00\x74\x01\xd8\x00\xd4\x00\x3f\x02\x1e\x02\x1f\x02\xd6\x00\xd7\x00\x11\x00\x18\x02\xd6\x00\xd7\x00\x11\x00\x20\x02\xd6\x00\xd7\x00\x40\x02\xc1\x01\x24\x02\x29\x02\x67\x01\xc3\x01\xd4\x00\xc6\x01\xae\x01\xd8\x00\xd4\x00\x15\x00\x67\x01\xd8\x00\xd4\x00\xc7\x01\xcc\x01\xd8\x00\xd6\x00\xd7\x00\x11\x00\xd7\x01\xe1\x01\xd9\x01\xe0\x01\xd6\x00\xd7\x00\x11\x00\xe9\x01\xec\x01\xf5\x01\x30\x02\xd6\x00\xd7\x00\x11\x00\xf8\x01\x74\x01\xd8\x00\x73\x01\x79\x01\xd6\x00\xd7\x00\x11\x00\x7e\x01\xd8\x00\x96\x01\xd6\x00\xd7\x00\x11\x00\x80\x01\x83\x01\xd8\x00\xd6\x00\xd7\x00\x11\x00\xd6\x00\xd7\x00\x11\x00\x85\x01\xd8\x00\x17\x00\x31\x02\x26\x00\x27\x00\x9c\x01\xd8\x00\x29\x00\x39\x00\xa6\x01\xf1\x00\xab\x01\xd8\x00\x2b\x00\xae\x01\xd8\x00\xd6\x00\xd7\x00\x11\x00\xad\x01\xd6\x00\xd7\x00\x11\x00\xb4\x01\xd6\x00\xd7\x00\x11\x00\x33\x01\x2e\x00\x39\x00\x2f\x00\x30\x00\x31\x00\x02\xff\xb9\x01\xd8\x00\x20\x02\x58\x00\x59\x00\xd8\x00\x5b\x00\x20\x01\x76\x00\xd8\x00\x15\x00\x16\x00\x17\x00\x18\x00\x21\x01\x2e\x01\x46\x01\x3f\x01\x19\x00\x1a\x00\x1b\x00\x1c\x00\x1d\x00\x1e\x00\x1f\x00\x4b\x01\xb4\x00\xc3\x00\xa5\xfe\x51\x01\x20\x00\x6c\x01\x21\x00\xe5\x00\xe6\x00\x55\x01\xf1\x00\x71\x00\x22\x00\xf3\x00\x72\x00\xa5\xfe\x73\x00\xf4\x00\xf7\x00\x17\x00\x23\x00\x02\x01\x74\x00\x58\x00\x75\x00\x24\x00\x5b\x00\x25\x00\x76\x00\x00\x01\xba\x01\x03\x01\x04\x01\x06\x01\xb7\x00\x26\x00\xc4\x00\x28\x00\xc5\x00\x29\x00\xc6\x00\xc7\x00\x07\x01\x2a\x00\x02\xff\x2b\x00\x2c\x00\xc8\x00\x70\x00\xa5\xfe\xa5\xfe\xa5\xfe\xc9\x00\x41\x00\x16\x01\xca\x00\x70\x00\x1b\x01\xb5\x00\x17\x01\x2e\x00\xcb\x00\x2f\x00\x30\x00\x31\x00\x15\x00\x16\x00\x17\x00\x18\x00\x1c\x01\x84\x00\x70\x00\xb3\xfe\x19\x00\x1a\x00\x1b\x00\x1c\x00\x1d\x00\x1e\x00\x1f\x00\xb4\xfe\xb4\x00\xc3\x00\xa5\xfe\xb5\xfe\x20\x00\x98\x00\x21\x00\xb9\xfe\xbb\xfe\xbe\xfe\x8c\x00\x71\x00\x22\x00\x8d\x00\x72\x00\xa5\xfe\x73\x00\xa0\x00\x70\x00\x99\x00\x23\x00\x39\x00\x74\x00\x58\x00\x75\x00\x24\x00\x5b\x00\x25\x00\x76\x00\xff\xff\xee\x00\xb7\x00\x6e\x00\xff\xff\x6f\x00\x26\x00\xc4\x00\x28\x00\xc5\x00\x29\x00\xc6\x00\xc7\x00\x70\x00\x2a\x00\x00\x00\x2b\x00\x2c\x00\x00\x00\x00\x00\xa5\xfe\xa5\xfe\xa5\xfe\xc9\x00\x41\x00\x00\x00\xca\x00\x00\x00\x00\x00\xb5\x00\x00\x00\x2e\x00\xcb\x00\x2f\x00\x30\x00\x31\x00\x15\x00\x16\x00\x17\x00\x18\x00\x5f\x00\x60\x00\x61\x00\x62\x00\x19\x00\x1a\x00\x1b\x00\x1c\x00\x1d\x00\x1e\x00\x1f\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x20\x00\x63\x00\x21\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x22\x00\x00\x00\x64\x00\x00\x00\x65\x00\x00\x00\x00\x00\x00\x00\x23\x00\x00\x00\x00\x00\x00\x00\x00\x00\x24\x00\x00\x00\x66\x00\x67\x00\x68\x00\x69\x00\x6a\x00\x6b\x00\x6c\x00\x6d\x00\x26\x00\x27\x00\x28\x00\x00\x00\x29\x00\x00\x00\x00\x00\x00\x00\x2a\x00\x71\x00\x2b\x00\x2c\x00\x72\x00\x00\x00\x73\x00\x00\x00\x00\x00\x00\x00\x41\x00\x00\x00\x74\x00\x58\x00\x75\x00\x00\x00\x5b\x00\x2e\x00\x76\x00\x2f\x00\x30\x00\x31\x00\x15\x00\x16\x00\x17\x00\x18\x00\x00\x00\x00\x00\x00\x00\x00\x00\x19\x00\x1a\x00\x1b\x00\x1c\x00\x1d\x00\x1e\x00\x1f\x00\x00\x00\xb4\x00\xc3\x00\x71\x00\x00\x00\x20\x00\x72\x00\x21\x00\x73\x00\x00\x00\x00\x00\xf4\xff\x00\x00\x22\x00\x74\x00\x58\x00\x75\x00\x00\x00\x5b\x00\x00\x00\x76\x00\x23\x00\xfd\x00\x00\x00\x00\x00\x00\x00\x24\x00\x00\x00\x25\x00\x00\x00\x00\x00\x00\x00\x15\x00\x16\x00\x17\x00\x18\x00\x26\x00\xc4\x00\x28\x00\xc5\x00\x29\x00\xc6\x00\xc7\x00\x00\x00\x2a\x00\x00\x00\x2b\x00\x2c\x00\xc8\x00\x00\x00\x00\x00\x00\x00\xd1\x01\xc9\x00\x41\x00\x00\x00\xca\x00\x00\x00\x00\x00\xb5\x00\x00\x00\x2e\x00\xcb\x00\x2f\x00\x30\x00\x31\x00\x15\x00\x16\x00\x17\x00\x18\x00\x00\x00\x00\x00\x00\x00\x00\x00\x19\x00\x1a\x00\x1b\x00\x1c\x00\x1d\x00\x1e\x00\x1f\x00\x00\x00\xb4\x00\x26\x00\x27\x00\x00\x00\x20\x00\x29\x00\x21\x00\x00\x00\x39\x00\x00\x00\x00\x00\x2b\x00\x22\x00\x00\x00\x00\x00\xa5\xfe\x00\x00\x00\x00\x00\x00\x00\x00\x23\x00\x00\x00\x00\x00\x00\x00\x00\x00\x24\x00\x2e\x00\x25\x00\x2f\x00\x30\x00\x31\x00\x15\x00\x16\x00\x17\x00\x18\x00\x26\x00\x27\x00\x28\x00\x00\x00\x29\x00\x00\x00\x00\x00\x00\x00\x2a\x00\x00\x00\x2b\x00\x2c\x00\x00\x00\x00\x00\xa5\xfe\xa5\xfe\xa5\xfe\x00\x00\x41\x00\x00\x00\x00\x00\x00\x00\x00\x00\xb5\x00\x00\x00\x2e\x00\x00\x00\x2f\x00\x30\x00\x31\x00\x15\x00\x16\x00\x17\x00\x18\x00\x00\x00\x00\x00\x00\x00\x00\x00\x19\x00\x1a\x00\x1b\x00\x1c\x00\x1d\x00\x1e\x00\x1f\x00\x00\x00\xb4\x00\x26\x00\x27\x00\x00\x00\x20\x00\x29\x00\x21\x00\x00\x00\x00\x00\x00\x00\x00\x00\x2b\x00\x22\x00\x00\x00\x00\x00\xa5\xfe\x00\x00\x00\x00\x00\x00\x00\x00\x23\x00\x00\x00\x00\x00\x00\x00\x00\x00\x24\x00\x2e\x00\x25\x00\x2f\x00\x30\x00\x31\x00\x15\x00\x00\x00\x17\x00\x00\x00\x26\x00\x27\x00\x28\x00\x00\x00\x29\x00\x00\x00\x00\x00\x00\x00\x2a\x00\x00\x00\x2b\x00\x2c\x00\x00\x00\x00\x00\xa5\xfe\xa5\xfe\xa5\xfe\x00\x00\x41\x00\x00\x00\x00\x00\x00\x00\x00\x00\xb5\x00\x00\x00\x2e\x00\x00\x00\x2f\x00\x30\x00\x31\x00\x15\x00\x16\x00\x17\x00\x18\x00\x00\x00\x00\x00\x00\x00\x00\x00\x19\x00\x1a\x00\x1b\x00\x1c\x00\x1d\x00\x1e\x00\x1f\x00\x00\x00\x00\x00\x26\x00\x27\x00\x00\x00\x20\x00\x29\x00\x21\x00\x00\x00\x39\x00\x00\x00\x00\x00\x2b\x00\x22\x00\x00\x00\x00\x00\xa5\xfe\x00\x00\x00\x00\x00\x00\x00\x00\x23\x00\x00\x00\x00\x00\x00\x00\x00\x00\x24\x00\x2e\x00\x25\x00\x2f\x00\x30\x00\x31\x00\x15\x00\x00\x00\x17\x00\x00\x00\x26\x00\x27\x00\x28\x00\x00\x00\x29\x00\x00\x00\x00\x00\x00\x00\x2a\x00\x71\x00\x2b\x00\x2c\x00\x72\x00\x00\x00\x92\x00\x00\x00\x2d\x01\x4a\x02\x41\x00\x00\x00\x74\x00\x58\x00\x75\x00\xb5\x00\x5b\x00\x2e\x00\x76\x00\x2f\x00\x30\x00\x31\x00\x15\x00\x16\x00\x17\x00\x18\x00\x00\x00\x00\x00\x00\x00\x00\x00\x19\x00\x1a\x00\x1b\x00\x1c\x00\x1d\x00\x1e\x00\x1f\x00\x00\x00\x00\x00\x26\x00\x27\x00\x00\x00\x20\x00\x29\x00\x21\x00\x00\x00\x00\x00\x00\x00\x00\x00\x2b\x00\x22\x00\x00\x00\x00\x00\xa5\xfe\x00\x00\x00\x00\x00\x00\x00\x00\x23\x00\x00\x00\x00\x00\x00\x00\x00\x00\x24\x00\x2e\x00\x25\x00\x2f\x00\x30\x00\x31\x00\x15\x00\x16\x00\x00\x00\x00\x00\x26\x00\x27\x00\x28\x00\x00\x00\x29\x00\x00\x00\x00\x00\x00\x00\x2a\x00\x71\x00\x2b\x00\x2c\x00\x72\x00\x00\x00\x73\x00\x00\x00\x89\x00\x00\x00\x41\x00\x00\x00\x74\x00\x58\x00\x75\x00\xb5\x00\x5b\x00\x2e\x00\x76\x00\x2f\x00\x30\x00\x31\x00\x15\x00\x16\x00\x17\x00\x18\x00\x00\x00\x00\x00\x00\x00\x00\x00\x19\x00\x1a\x00\x1b\x00\x1c\x00\x1d\x00\x1e\x00\x1f\x00\x00\x00\x00\x00\x26\x00\x27\x00\x00\x00\x20\x00\x29\x00\x21\x00\x00\x00\x00\x00\x00\x00\x00\x00\x2b\x00\x22\x00\x00\x00\x00\x00\xa5\xfe\x00\x00\x00\x00\x00\x00\x00\x00\x23\x00\x00\x00\x00\x00\x00\x00\x00\x00\x24\x00\x2e\x00\x25\x00\x2f\x00\x30\x00\x31\x00\x00\x00\x00\x00\x00\x00\x00\x00\x26\x00\x27\x00\x28\x00\x00\x00\x29\x00\x00\x00\x00\x00\x00\x00\x2a\x00\x00\x00\x2b\x00\x2c\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x15\x00\x41\x00\x17\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x2e\x00\x00\x00\x2f\x00\x30\x00\x31\x00\x15\x00\x16\x00\x17\x00\x18\x00\x00\x00\x00\x00\x00\x00\x7d\x02\x19\x00\x1a\x00\x1b\x00\x1c\x00\x1d\x00\x1e\x00\x1f\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x20\x00\x13\x01\x21\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x22\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x23\x00\x00\x00\x26\x00\x27\x00\x00\x00\x24\x00\x29\x00\x25\x00\x00\x00\x00\x00\x00\x00\x15\x00\x2b\x00\x00\x00\x00\x00\x26\x00\x27\x00\x28\x00\x00\x00\x29\x00\x00\x00\x00\x00\x00\x00\x2a\x00\x70\x01\x2b\x00\x2c\x00\x2e\x00\x00\x00\x2f\x00\x30\x00\x31\x00\x00\x00\x41\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x2e\x00\x00\x00\x2f\x00\x30\x00\x31\x00\x15\x00\x16\x00\x17\x00\x18\x00\x00\x00\x00\x00\x00\x00\x00\x00\x19\x00\x1a\x00\x1b\x00\x1c\x00\x1d\x00\x1e\x00\x1f\x00\x00\x00\x00\x00\x26\x00\x27\x00\x00\x00\x20\x00\x29\x00\x21\x00\x00\x00\x00\x00\x00\x00\x00\x00\x2b\x00\x22\x00\x4d\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x23\x00\x00\x00\x00\x00\x00\x00\x00\x00\x24\x00\x2e\x00\x25\x00\x2f\x00\x30\x00\x31\x00\x15\x00\x16\x00\x00\x00\x00\x00\x26\x00\x27\x00\x28\x00\x00\x00\x29\x00\x00\x00\x00\x00\x00\x00\x2a\x00\x00\x00\x2b\x00\x2c\x00\x00\x00\x00\x00\x00\x00\x00\x00\x89\x00\x00\x00\x41\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x2e\x00\x00\x00\x2f\x00\x30\x00\x31\x00\x15\x00\x16\x00\x17\x00\x18\x00\x00\x00\x00\x00\x00\x00\x00\x00\x19\x00\x1a\x00\x1b\x00\x1c\x00\x1d\x00\x1e\x00\x1f\x00\x00\x00\x00\x00\x26\x00\x27\x00\x00\x00\x20\x00\x29\x00\x21\x00\x50\x00\x00\x00\x00\x00\x00\x00\x2b\x00\x22\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x23\x00\x00\x00\x00\x00\x00\x00\x00\x00\x24\x00\x2e\x00\x25\x00\x2f\x00\x30\x00\x31\x00\x15\x00\x00\x00\x17\x00\x00\x00\x26\x00\x27\x00\x28\x00\x00\x00\x29\x00\x00\x00\x00\x00\x00\x00\x2a\x00\x00\x00\x2b\x00\x2c\x00\x00\x00\x00\x00\x00\x00\x00\x00\x2d\x01\x00\x00\x41\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x2e\x00\x00\x00\x2f\x00\x30\x00\x31\x00\x15\x00\x16\x00\x17\x00\x18\x00\x00\x00\x00\x00\x00\x00\x00\x00\x19\x00\x1a\x00\x1b\x00\x1c\x00\x1d\x00\x1e\x00\x1f\x00\x00\x00\x00\x00\x26\x00\x27\x00\x00\x00\x20\x00\x29\x00\x21\x00\x00\x00\x00\x00\x00\x00\x00\x00\x2b\x00\x22\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x23\x00\x00\x00\x00\x00\x00\x00\x00\x00\x24\x00\x2e\x00\x25\x00\x2f\x00\x30\x00\x31\x00\x15\x00\x16\x00\x00\x00\x00\x00\x26\x00\x27\x00\x28\x00\x00\x00\x29\x00\x00\x00\x00\x00\x00\x00\x2a\x00\x00\x00\x2b\x00\x2c\x00\x00\x00\x00\x00\x00\x00\x00\x00\x89\x00\x00\x00\x41\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x2e\x00\x00\x00\x2f\x00\x30\x00\x31\x00\x15\x00\x16\x00\x17\x00\x18\x00\x00\x00\x00\x00\x00\x00\x00\x00\x19\x00\x1a\x00\x1b\x00\x1c\x00\x1d\x00\x1e\x00\x1f\x00\x00\x00\x00\x00\x26\x00\x27\x00\x00\x00\x20\x00\x29\x00\x21\x00\x00\x00\x00\x00\x00\x00\x00\x00\x2b\x00\x22\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x23\x00\x00\x00\x00\x00\x00\x00\x00\x00\x24\x00\x2e\x00\x25\x00\x2f\x00\x30\x00\x31\x00\x15\x00\x00\x00\x00\x00\x00\x00\x26\x00\x27\x00\x28\x00\x00\x00\x29\x00\x00\x00\x00\x00\x00\x00\x2a\x00\x00\x00\x2b\x00\x2c\x00\x00\x00\x00\x00\x00\x00\x00\x00\x2d\x01\x00\x00\x2d\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x2e\x00\x00\x00\x2f\x00\x30\x00\x31\x00\x15\x00\x16\x00\x17\x00\x18\x00\x00\x00\x00\x00\x00\x00\x00\x00\x19\x00\x1a\x00\x1b\x00\x1c\x00\x1d\x00\x1e\x00\x1f\x00\x00\x00\x00\x00\x26\x00\x27\x00\x00\x00\x20\x00\x29\x00\x21\x00\x00\x00\x00\x00\x00\x00\x00\x00\x2b\x00\x22\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x23\x00\x00\x00\x00\x00\x00\x00\x00\x00\x24\x00\x2e\x00\x25\x00\x2f\x00\x30\x00\x31\x00\x15\x00\x00\x00\x00\x00\x00\x00\x26\x00\x27\x00\x28\x00\x00\x00\x29\x00\x00\x00\x00\x00\x00\x00\x2a\x00\x00\x00\x2b\x00\x2c\x00\x00\x00\x00\x00\x00\x00\x00\x00\x82\x01\x00\x00\x41\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x2e\x00\x00\x00\x2f\x00\x30\x00\x31\x00\x15\x00\x16\x00\x17\x00\x18\x00\x00\x00\x00\x00\x00\x00\x00\x00\x19\x00\x1a\x00\x1b\x00\x1c\x00\x1d\x00\x1e\x00\x1f\x00\x00\x00\x00\x00\x26\x00\x27\x00\x00\x00\x20\x00\x29\x00\x21\x00\x00\x00\x00\x00\x00\x00\x00\x00\x2b\x00\x22\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x23\x00\x00\x00\x00\x00\x00\x00\x00\x00\x24\x00\x2e\x00\x25\x00\x2f\x00\x30\x00\x31\x00\x15\x00\x00\x00\x00\x00\x00\x00\x26\x00\x27\x00\x28\x00\x00\x00\x29\x00\x00\x00\x00\x00\x00\x00\x2a\x00\x00\x00\x2b\x00\x2c\x00\x00\x00\x00\x00\x00\x00\x00\x00\x2d\x01\x00\x00\x2d\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x2e\x00\x00\x00\x2f\x00\x30\x00\x31\x00\x15\x00\x16\x00\x17\x00\x18\x00\x00\x00\x00\x00\x00\x00\x00\x00\x19\x00\x1a\x00\x1b\x00\x1c\x00\x1d\x00\x1e\x00\x1f\x00\x00\x00\x00\x00\x26\x00\x27\x00\x00\x00\x20\x00\x29\x00\x21\x00\x00\x00\x00\x00\x00\x00\x00\x00\x2b\x00\x22\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x23\x00\x00\x00\x00\x00\x00\x00\x00\x00\x24\x00\x2e\x00\x25\x00\x2f\x00\x30\x00\x31\x00\xa5\xfe\x00\x00\x00\x00\x00\x00\x26\x00\x27\x00\x28\x00\x00\x00\x29\x00\x00\x00\x00\x00\x00\x00\x2a\x00\x00\x00\x2b\x00\x2c\x00\x00\x00\x00\x00\x00\x00\x00\x00\xa5\xfe\x00\x00\x41\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x2e\x00\x00\x00\x2f\x00\x30\x00\x31\x00\x15\x00\x16\x00\x17\x00\x18\x00\x00\x00\x00\x00\x00\x00\x00\x00\x19\x00\x1a\x00\x1b\x00\x1c\x00\x1d\x00\x1e\x00\x1f\x00\x00\x00\x00\x00\xa5\xfe\xa5\xfe\x00\x00\x20\x00\xa5\xfe\x21\x00\x00\x00\x00\x00\x00\x00\x00\x00\xa5\xfe\x22\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x23\x00\x00\x00\x00\x00\x00\x00\x00\x00\x24\x00\xa5\xfe\x25\x00\xa5\xfe\xa5\xfe\xa5\xfe\x15\x00\x00\x00\x00\x00\x00\x00\x26\x00\x27\x00\x28\x00\x00\x00\x29\x00\x00\x00\x00\x00\x00\x00\x2a\x00\x00\x00\x2b\x00\x2c\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x2d\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x2e\x00\x00\x00\x2f\x00\x30\x00\x31\x00\x15\x00\x16\x00\x17\x00\x18\x00\x00\x00\x00\x00\x00\x00\x00\x00\x19\x00\x1a\x00\x1b\x00\x1c\x00\x1d\x00\x1e\x00\x1f\x00\x00\x00\x00\x00\x26\x00\x27\x00\x00\x00\x20\x00\x29\x00\x21\x00\x00\x00\x00\x00\x00\x00\x00\x00\x2b\x00\x22\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x23\x00\x00\x00\x00\x00\x00\x00\x00\x00\x24\x00\x2e\x00\x25\x00\x2f\x00\x30\x00\x31\x00\x00\x00\x00\x00\x00\x00\x00\x00\x26\x00\x27\x00\x28\x00\x00\x00\x29\x00\x00\x00\x00\x00\x00\x00\x2a\x00\x00\x00\x2b\x00\x2c\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x41\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x2e\x00\x00\x00\x2f\x00\x30\x00\x31\x00\x15\x00\x16\x00\x17\x00\x18\x00\x00\x00\x00\x00\x00\x00\x00\x00\x19\x00\x1a\x00\x1b\x00\x1c\x00\x1d\x00\x1e\x00\x1f\x00\x9e\x00\x00\x00\x00\x00\x00\x00\x00\x00\x20\x00\x00\x00\x21\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x22\x00\x00\x00\x00\x00\x00\x00\x00\x00\x0b\x00\x00\x00\x0c\x00\x23\x00\x0d\x00\x00\x00\x00\x00\x00\x00\x24\x00\x00\x00\x25\x00\x00\x00\x00\x00\x0e\x00\x0f\x00\x10\x00\x11\x00\x00\x00\x26\x00\x27\x00\x28\x00\x00\x00\x29\x00\x00\x00\x12\x00\x13\x00\x2a\x00\x00\x00\x2b\x00\x2c\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x2d\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x2e\x00\x00\x00\x2f\x00\x30\x00\x31\x00\x15\x00\x16\x00\x17\x00\x18\x00\x00\x00\x00\x00\x00\x00\x00\x00\x19\x00\x1a\x00\x1b\x00\x1c\x00\x1d\x00\x1e\x00\x1f\x00\x00\x00\x00\x00\x00\x00\x71\x00\x00\x00\x20\x00\x72\x00\x21\x00\x73\x00\x00\x00\x00\x00\x00\x00\x00\x00\x22\x00\x74\x00\x58\x00\x75\x00\x00\x00\x5b\x00\x00\x00\x76\x00\x23\x00\x77\x00\x00\x00\x00\x00\x00\x00\x24\x00\x00\x00\x25\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x26\x00\x27\x00\x28\x00\x00\x00\x29\x00\x00\x00\x00\x00\x00\x00\x2a\x00\x00\x00\x2b\x00\x2c\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x41\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x2e\x00\x00\x00\x2f\x00\x30\x00\x31\x00\x15\x00\x16\x00\x17\x00\x18\x00\x00\x00\x00\x00\x00\x00\x00\x00\x19\x00\x1a\x00\x1b\x00\x1c\x00\x1d\x00\x1e\x00\x1f\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x20\x00\x00\x00\x21\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x22\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x23\x00\x00\x00\x00\x00\x00\x00\x00\x00\x24\x00\x00\x00\x25\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x26\x00\x27\x00\x28\x00\x00\x00\x29\x00\x00\x00\x00\x00\x00\x00\x2a\x00\x00\x00\x2b\x00\x2c\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x2d\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x2e\x00\x00\x00\x2f\x00\x30\x00\x31\x00\x15\x00\x16\x00\x17\x00\x18\x00\x00\x00\x00\x00\x00\x00\x00\x00\x19\x00\x1a\x00\x1b\x00\x1c\x00\x1d\x00\x1e\x00\x1f\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x20\x00\x00\x00\x21\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x22\x00\x00\x00\x00\x00\xa5\xfe\x00\x00\x00\x00\x15\x00\x16\x00\x17\x00\x18\x00\x00\x00\x00\x00\x00\x00\x24\x00\x19\x00\x1a\x00\x1b\x00\x1c\x00\x1d\x00\x1e\x00\x1f\x00\x00\x00\x00\x00\x26\x00\x27\x00\x00\x00\x20\x00\x29\x00\x21\x00\x00\x00\x00\x00\x00\x00\x00\x00\x2b\x00\x22\x00\x79\x00\x60\x00\x61\x00\x62\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x15\x00\x00\x00\x24\x00\x2e\x00\x79\x00\x2f\x00\x30\x00\x31\x00\x00\x00\x00\x00\x00\x00\x00\x00\x26\x00\x27\x00\x00\x00\x00\x00\x29\x00\x00\x00\x7a\x00\x00\x00\x2d\x01\x00\x00\x2b\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x7c\x00\x7d\x00\x68\x00\x69\x00\x6a\x00\x7e\x00\x7f\x00\x80\x00\x2e\x00\x00\x00\x2f\x00\x30\x00\x31\x00\x00\x00\x7c\x00\x7d\x00\x68\x00\x69\x00\x6a\x00\x7e\x00\x7f\x00\x80\x00\x26\x00\x27\x00\x00\x00\x00\x00\x29\x00\x00\x00\x15\x00\x16\x00\x17\x00\x18\x00\x2b\x00\x15\x00\x00\x00\x17\x00\x18\x00\x00\x00\x60\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x2e\x00\x89\x00\x2f\x00\x30\x00\x31\x00\x00\x00\xda\x00\x65\x01\xdb\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xdc\x00\x00\x00\x64\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x15\x00\x66\x01\x17\x00\x18\x00\x00\x00\x57\xff\x00\x00\x00\x00\x26\x00\x27\x00\x00\x00\x00\x00\x29\x00\x26\x00\x27\x00\x00\x00\x00\x00\x29\x00\x2b\x00\x00\x00\xda\x00\x00\x00\xdb\x00\x2b\x00\x00\x00\x00\x00\x00\x00\x3e\x01\xdc\x00\x00\x00\x00\x00\x00\x00\x57\xff\x2e\x00\x00\x00\x2f\x00\x30\x00\x31\x00\x2e\x00\x00\x00\xdd\x00\xde\x00\x31\x00\x15\x00\x61\x02\x17\x00\x18\x00\x00\x00\x00\x00\x00\x00\x00\x00\x26\x00\x27\x00\x00\x00\x00\x00\x29\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x2b\x00\x00\x00\xda\x00\x65\x01\xdb\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xdc\x00\x00\x00\x64\x00\x00\x00\x00\x00\x2e\x00\x00\x00\x2f\x00\x30\x00\x31\x00\x00\x00\x66\x01\x00\x00\x00\x00\x15\x00\x00\x00\x17\x00\x18\x00\x00\x00\x15\x00\x00\x00\x17\x00\x18\x00\x26\x00\x27\x00\x00\x00\x00\x00\x29\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x2b\x00\xda\x00\x00\x00\xdb\x00\x00\x00\x00\x00\xda\x00\x00\x00\xdb\x00\xdc\x00\x00\x00\x00\x00\x00\x00\x00\x00\xdc\x00\x2e\x00\x00\x00\xdd\x00\xde\x00\x31\x00\x69\x01\x00\x00\x00\x00\x6a\x01\x15\x00\x00\x00\x17\x00\x18\x00\x00\x00\x00\x00\x8b\x02\x00\x00\x26\x00\x27\x00\x00\x00\x00\x00\x29\x00\x26\x00\x27\x00\x00\x00\x00\x00\x29\x00\x2b\x00\x00\x00\xda\x00\x00\x00\xdb\x00\x2b\x00\x00\x00\x00\x00\x00\x00\x00\x00\xdc\x00\x00\x00\x00\x00\x00\x00\x00\x00\x2e\x00\x00\x00\x2f\x00\x30\x00\x31\x00\x2e\x00\x00\x00\xdd\x00\xde\x00\x31\x00\x15\x00\x43\x02\x17\x00\x18\x00\x00\x00\x00\x00\x00\x00\x00\x00\x26\x00\x27\x00\x00\x00\x00\x00\x29\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x2b\x00\x00\x00\xda\x00\x00\x00\xdb\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xdc\x00\x00\x00\x00\x00\x00\x00\x00\x00\x2e\x00\x00\x00\x2f\x00\x30\x00\x31\x00\x00\x00\x00\x00\x15\x00\x00\x00\x17\x00\x18\x00\x60\x02\x15\x00\x00\x00\x17\x00\x18\x00\x00\x00\x00\x00\x26\x00\x27\x00\x00\x00\x00\x00\x29\x00\x00\x00\x00\x00\x00\x00\x00\x00\xda\x00\x2b\x00\xdb\x00\x00\x00\x00\x00\x42\x02\x00\x00\xdb\x00\xdc\x00\x79\x00\x60\x00\x61\x00\x62\x00\xdc\x00\x00\x00\x00\x00\x2e\x00\x00\x00\x2f\x00\x30\x00\x31\x00\x00\x00\x66\x02\x00\x00\x15\x00\x16\x00\x17\x00\x18\x00\x00\x00\x43\x02\x00\x00\x26\x00\x27\x00\x00\x00\x00\x00\x29\x00\x26\x00\x27\x00\x00\x00\x00\x00\x29\x00\x2b\x00\x00\x00\x00\x00\xd1\x01\xd2\x01\x2b\x00\x00\x00\x7c\x00\x7d\x00\x68\x00\x69\x00\x6a\x00\x7e\x00\x7f\x00\x80\x00\x2e\x00\xd3\x01\x2f\x00\x30\x00\x31\x00\x2e\x00\x00\x00\x2f\x00\x30\x00\x31\x00\x15\x00\x00\x00\x17\x00\x18\x00\x00\x00\x15\x00\x16\x00\x17\x00\x18\x00\x26\x00\x27\x00\x00\x00\x00\x00\x29\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x2b\x00\xda\x00\x00\x00\xdb\x00\x00\x00\x00\x00\x89\x00\x3d\x01\x00\x00\xdc\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x2e\x00\x00\x00\x2f\x00\x30\x00\x31\x00\x69\x01\x00\x00\x00\x00\x15\x00\x00\x00\x17\x00\x18\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x26\x00\x27\x00\x00\x00\x00\x00\x29\x00\x26\x00\x27\x00\x00\x00\x00\x00\x29\x00\x2b\x00\xda\x00\x00\x00\xdb\x00\x00\x00\x2b\x00\x00\x00\x00\x00\x00\x00\xdc\x00\x5c\x01\x00\x00\x00\x00\x00\x00\x3e\x01\x2e\x00\x00\x00\x2f\x00\x30\x00\x31\x00\x2e\x00\x00\x00\x2f\x00\x30\x00\x31\x00\x15\x00\x00\x00\x17\x00\x18\x00\x00\x00\x00\x00\x00\x00\x26\x00\x27\x00\x00\x00\x00\x00\x29\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x2b\x00\x00\x00\x00\x00\xda\x00\x00\x00\xdb\x00\x5f\x01\x00\x00\x00\x00\x00\x00\x00\x00\xdc\x00\x00\x00\x00\x00\x00\x00\x2e\x00\x00\x00\xdd\x00\xde\x00\x31\x00\x15\x00\x00\x00\x17\x00\x18\x00\x00\x00\x15\x00\x00\x00\x17\x00\x18\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x26\x00\x27\x00\x00\x00\x00\x00\x29\x00\x00\x00\xda\x00\x00\x00\xdb\x00\x00\x00\x2b\x00\xda\x00\x00\x00\xdb\x00\xdc\x00\x00\x00\x00\x00\x00\x00\x00\x00\xdc\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x2e\x00\x00\x00\xdd\x00\xde\x00\x31\x00\x00\x00\x15\x00\x00\x00\x17\x00\x18\x00\x00\x00\x00\x00\x26\x00\x27\x00\x00\x00\x00\x00\x29\x00\x26\x00\x27\x00\x00\x00\x00\x00\x29\x00\x2b\x00\x00\x00\x00\x00\x00\x00\xda\x00\x2b\x00\xdb\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xdc\x00\x00\x00\x00\x00\x2e\x00\x00\x00\x2f\x00\x30\x00\x31\x00\x2e\x00\x00\x00\xdd\x00\xde\x00\x31\x00\x00\x00\x15\x00\x00\x00\x17\x00\x18\x00\x00\x00\x15\x00\x00\x00\x17\x00\x18\x00\x26\x00\x27\x00\x00\x00\x00\x00\x29\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x2b\x00\xda\x00\x00\x00\xdb\x00\x00\x00\x00\x00\xda\x00\x00\x00\xdb\x00\xdc\x00\x00\x00\x00\x00\x00\x00\x00\x00\xdc\x00\x2e\x00\x00\x00\x2f\x00\x30\x00\x31\x00\x00\x00\x00\x00\x00\x00\x15\x00\x00\x00\x17\x00\x18\x00\x00\x00\x15\x00\x00\x00\x17\x00\x18\x00\x26\x00\x27\x00\x00\x00\x00\x00\x29\x00\x26\x00\x27\x00\x00\x00\x00\x00\x29\x00\x2b\x00\xda\x00\x00\x00\xdb\x00\x00\x00\x2b\x00\xda\x00\x00\x00\xdb\x00\xdc\x00\x00\x00\x00\x00\x00\x00\x00\x00\xdc\x00\x2e\x00\x00\x00\xdd\x00\xde\x00\x31\x00\x2e\x00\x00\x00\xdd\x00\xde\x00\x31\x00\x00\x00\x15\x00\x00\x00\x17\x00\x18\x00\x00\x00\x00\x00\x26\x00\x27\x00\x00\x00\x00\x00\x29\x00\x26\x00\x27\x00\x00\x00\x00\x00\x29\x00\x2b\x00\x00\x00\x00\x00\x00\x00\xda\x00\x2b\x00\xdb\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xdc\x00\x00\x00\x00\x00\x2e\x00\x00\x00\x2f\x00\x30\x00\x31\x00\x2e\x00\x00\x00\xdd\x00\xde\x00\x31\x00\x00\x00\x15\x00\x00\x00\x17\x00\x18\x00\x00\x00\x15\x00\x00\x00\x17\x00\x18\x00\x26\x00\x27\x00\x00\x00\x00\x00\x29\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x2b\x00\xda\x00\x00\x00\xdb\x00\x00\x00\x00\x00\xda\x00\x00\x00\xdb\x00\xdc\x00\x00\x00\x00\x00\x00\x00\x00\x00\xdc\x00\x2e\x00\x00\x00\x2f\x00\x30\x00\x31\x00\x00\x00\x00\x00\x00\x00\x15\x00\x00\x00\x17\x00\x18\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x26\x00\x27\x00\x00\x00\x00\x00\x29\x00\x26\x00\x27\x00\x00\x00\x00\x00\x29\x00\x2b\x00\xda\x00\x00\x00\xdb\x00\x45\x00\x2b\x00\x08\x00\x09\x00\x00\x00\xdc\x00\x00\x00\x00\x00\x00\x00\x00\x00\x15\x00\x2e\x00\x17\x00\xdd\x00\xde\x00\x31\x00\x2e\x00\x15\x00\xdd\x00\xde\x00\xe3\x00\x0b\x00\x00\x00\x0c\x00\x00\x00\x0d\x00\x00\x00\x00\x00\x26\x00\x27\x00\x7d\x02\x7e\x02\x29\x00\x00\x00\x0e\x00\x0f\x00\x10\x00\x11\x00\x2b\x00\x00\x00\x00\x00\x00\x00\x00\x00\x7f\x02\x00\x00\x12\x00\x13\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x19\x02\x2e\x00\x00\x00\xdd\x00\xde\x00\x31\x00\x00\x00\x00\x00\x00\x00\x26\x00\x27\x00\x00\x00\x79\x00\x29\x00\x61\x00\x00\x00\x26\x00\x27\x00\x53\x02\x2b\x00\x29\x00\x00\x00\x00\x00\xb0\x00\x06\x00\x07\x00\x2b\x00\x08\x00\x09\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x2e\x00\x00\x00\x2f\x00\x30\x00\x31\x00\x00\x00\x00\x00\x2e\x00\x79\x00\x2f\x00\x30\x00\x31\x00\x0b\x00\x00\x00\x0c\x00\x00\x00\x0d\x00\x7c\x00\x7d\x00\x68\x00\x69\x00\x6a\x00\x7e\x00\x7f\x00\x80\x00\x0e\x00\x0f\x00\x10\x00\x11\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x12\x00\x13\x00\x50\x00\x51\x00\x06\x00\x07\x00\x00\x00\x08\x00\x09\x00\x52\x00\x53\x00\x7c\x00\x7d\x00\x68\x00\x69\x00\x6a\x00\x7e\x00\x7f\x00\x80\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x0b\x00\x00\x00\x0c\x00\x00\x00\x0d\x00\x00\x00\x00\x00\x54\x00\x00\x00\x55\x00\x00\x00\x00\x00\x56\x00\x0e\x00\x0f\x00\x10\x00\x11\x00\x57\x00\x58\x00\x59\x00\x5a\x00\x5b\x00\x5c\x00\x5d\x00\x12\x00\x13\x00\xa0\x00\x05\x00\x06\x00\x07\x00\x00\x00\x08\x00\x09\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xa1\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xa2\x00\xa3\x00\x00\x00\x00\x00\x0b\x00\x00\x00\x0c\x00\x00\x00\x0d\x00\x00\x00\xa0\x00\x05\x00\x06\x00\x07\x00\x00\x00\x08\x00\x09\x00\x0e\x00\x0f\x00\x10\x00\x11\x00\x00\x00\xa1\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x12\x00\x13\x00\xa4\x00\xa3\x00\x00\x00\x00\x00\x0b\x00\x00\x00\x0c\x00\x00\x00\x0d\x00\x00\x00\x04\x00\x05\x00\x06\x00\x07\x00\x00\x00\x08\x00\x09\x00\x0e\x00\x0f\x00\x10\x00\x11\x00\x0c\x01\x0d\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x12\x00\x13\x00\x00\x00\x00\x00\x00\x00\x00\x00\x0b\x00\x00\x00\x0c\x00\x00\x00\x0d\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x0e\x00\x0f\x00\x10\x00\x11\x00\x49\x00\x3f\x00\x06\x00\x07\x00\x00\x00\x08\x00\x09\x00\x12\x00\x13\x00\x4a\x00\x4b\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x04\x00\x05\x00\x06\x00\x07\x00\x00\x00\x08\x00\x09\x00\x0b\x00\x00\x00\x0c\x00\x00\x00\x0d\x00\xbb\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x0e\x00\x0f\x00\x10\x00\x11\x00\x0b\x00\x00\x00\x0c\x00\x00\x00\x0d\x00\x00\x00\x00\x00\x12\x00\x13\x00\x00\x00\x00\x00\x00\x00\x00\x00\x0e\x00\x0f\x00\x10\x00\x11\x00\x26\x01\x05\x00\x06\x00\x07\x00\x00\x00\x08\x00\x09\x00\x12\x00\x13\x00\x00\x00\x00\x00\x00\x00\x27\x01\x00\x00\x00\x00\x00\x00\x00\x00\x4d\x00\x3f\x00\x06\x00\x07\x00\x00\x00\x08\x00\x09\x00\x0b\x00\x4e\x00\x0c\x00\x00\x00\x0d\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x0e\x00\x0f\x00\x10\x00\x11\x00\x0b\x00\x00\x00\x0c\x00\x00\x00\x0d\x00\x00\x00\x00\x00\x12\x00\x13\x00\x00\x00\x00\x00\x00\x00\x00\x00\x0e\x00\x0f\x00\x10\x00\x11\x00\x04\x00\x05\x00\x06\x00\x07\x00\x00\x00\x08\x00\x09\x00\x12\x00\x13\x00\x00\x00\x00\x00\x00\x00\x0a\x00\x00\x00\x00\x00\x00\x00\x00\x00\x69\x02\x3f\x00\x06\x00\x07\x00\x00\x00\x08\x00\x09\x00\x0b\x00\x00\x00\x0c\x00\x00\x00\x0d\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x0e\x00\x0f\x00\x10\x00\x11\x00\x0b\x00\x00\x00\x0c\x00\x00\x00\x0d\x00\x00\x00\x00\x00\x12\x00\x13\x00\x00\x00\x00\x00\x00\x00\x00\x00\x0e\x00\x0f\x00\x10\x00\x11\x00\x51\x02\x3f\x00\x06\x00\x07\x00\x00\x00\x08\x00\x09\x00\x12\x00\x13\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x67\x02\x3f\x00\x06\x00\x07\x00\x00\x00\x08\x00\x09\x00\x0b\x00\x00\x00\x0c\x00\x00\x00\x0d\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x0e\x00\x0f\x00\x10\x00\x11\x00\x0b\x00\x00\x00\x0c\x00\x00\x00\x0d\x00\x00\x00\x00\x00\x12\x00\x13\x00\x00\x00\x00\x00\x00\x00\x00\x00\x0e\x00\x0f\x00\x10\x00\x11\x00\x2b\x02\x3f\x00\x06\x00\x07\x00\x00\x00\x08\x00\x09\x00\x12\x00\x13\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x1a\x02\x3f\x00\x06\x00\x07\x00\x00\x00\x08\x00\x09\x00\x0b\x00\x00\x00\x0c\x00\x00\x00\x0d\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x0e\x00\x0f\x00\x10\x00\x11\x00\x0b\x00\x00\x00\x0c\x00\x00\x00\x0d\x00\x00\x00\x00\x00\x12\x00\x13\x00\x00\x00\x00\x00\x00\x00\x00\x00\x0e\x00\x0f\x00\x10\x00\x11\x00\x24\x02\x3f\x00\x06\x00\x07\x00\x00\x00\x08\x00\x09\x00\x12\x00\x13\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x25\x02\x3f\x00\x06\x00\x07\x00\x00\x00\x08\x00\x09\x00\x0b\x00\x00\x00\x0c\x00\x00\x00\x0d\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x0e\x00\x0f\x00\x10\x00\x11\x00\x0b\x00\x00\x00\x0c\x00\x00\x00\x0d\x00\x00\x00\x00\x00\x12\x00\x13\x00\x00\x00\x00\x00\x00\x00\x00\x00\x0e\x00\x0f\x00\x10\x00\x11\x00\x26\x02\x3f\x00\x06\x00\x07\x00\x00\x00\x08\x00\x09\x00\x12\x00\x13\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xa6\x01\x3f\x00\x06\x00\x07\x00\x00\x00\x08\x00\x09\x00\x0b\x00\x00\x00\x0c\x00\x00\x00\x0d\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x0e\x00\x0f\x00\x10\x00\x11\x00\x0b\x00\x00\x00\x0c\x00\x00\x00\x0d\x00\x00\x00\x00\x00\x12\x00\x13\x00\x00\x00\x00\x00\x00\x00\x00\x00\x0e\x00\x0f\x00\x10\x00\x11\x00\xb0\x01\x3f\x00\x06\x00\x07\x00\x00\x00\x08\x00\x09\x00\x12\x00\x13\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xb1\x01\x3f\x00\x06\x00\x07\x00\x00\x00\x08\x00\x09\x00\x0b\x00\x00\x00\x0c\x00\x00\x00\x0d\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x0e\x00\x0f\x00\x10\x00\x11\x00\x0b\x00\x00\x00\x0c\x00\x00\x00\x0d\x00\x00\x00\x00\x00\x12\x00\x13\x00\x00\x00\x00\x00\x00\x00\x00\x00\x0e\x00\x0f\x00\x10\x00\x11\x00\xbc\x01\x3f\x00\x06\x00\x07\x00\x00\x00\x08\x00\x09\x00\x12\x00\x13\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x1e\x01\x3f\x00\x06\x00\x07\x00\x00\x00\x08\x00\x09\x00\x0b\x00\x00\x00\x0c\x00\x00\x00\x0d\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x0e\x00\x0f\x00\x10\x00\x11\x00\x0b\x00\x00\x00\x0c\x00\x00\x00\x0d\x00\x00\x00\x00\x00\x12\x00\x13\x00\x00\x00\x00\x00\x00\x00\x00\x00\x0e\x00\x0f\x00\x10\x00\x11\x00\x21\x01\x3f\x00\x06\x00\x07\x00\x00\x00\x08\x00\x09\x00\x12\x00\x13\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x28\x01\x3f\x00\x06\x00\x07\x00\x00\x00\x08\x00\x09\x00\x0b\x00\x00\x00\x0c\x00\x00\x00\x0d\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x0e\x00\x0f\x00\x10\x00\x11\x00\x0b\x00\x00\x00\x0c\x00\x00\x00\x0d\x00\x00\x00\x00\x00\x12\x00\x13\x00\x00\x00\x00\x00\x00\x00\x00\x00\x0e\x00\x0f\x00\x10\x00\x11\x00\xf7\x00\x3f\x00\x06\x00\x07\x00\x00\x00\x08\x00\x09\x00\x12\x00\x13\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x0e\x01\x3f\x00\x06\x00\x07\x00\x00\x00\x08\x00\x09\x00\x0b\x00\x00\x00\x0c\x00\x00\x00\x0d\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x0e\x00\x0f\x00\x10\x00\x11\x00\x0b\x00\x00\x00\x0c\x00\x00\x00\x0d\x00\x00\x00\x00\x00\x12\x00\x13\x00\x00\x00\x00\x00\x00\x00\x00\x00\x0e\x00\x0f\x00\x10\x00\x11\x00\x0f\x01\x3f\x00\x06\x00\x07\x00\x00\x00\x08\x00\x09\x00\x12\x00\x13\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x10\x01\x3f\x00\x06\x00\x07\x00\x00\x00\x08\x00\x09\x00\x0b\x00\x00\x00\x0c\x00\x00\x00\x0d\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x0e\x00\x0f\x00\x10\x00\x11\x00\x0b\x00\x00\x00\x0c\x00\x00\x00\x0d\x00\x00\x00\x00\x00\x12\x00\x13\x00\x00\x00\x00\x00\x00\x00\x00\x00\x0e\x00\x0f\x00\x10\x00\x11\x00\x11\x01\x3f\x00\x06\x00\x07\x00\x00\x00\x08\x00\x09\x00\x12\x00\x13\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x13\x01\x3f\x00\x06\x00\x07\x00\x00\x00\x08\x00\x09\x00\x0b\x00\x00\x00\x0c\x00\x00\x00\x0d\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x0e\x00\x0f\x00\x10\x00\x11\x00\x0b\x00\x00\x00\x0c\x00\x00\x00\x0d\x00\x00\x00\x00\x00\x12\x00\x13\x00\x00\x00\x00\x00\x00\x00\x00\x00\x0e\x00\x0f\x00\x10\x00\x11\x00\x19\x01\x3f\x00\x06\x00\x07\x00\x00\x00\x08\x00\x09\x00\x12\x00\x13\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x3e\x00\x3f\x00\x06\x00\x07\x00\x00\x00\x08\x00\x09\x00\x0b\x00\x00\x00\x0c\x00\x00\x00\x0d\x00\x79\x00\x60\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x0e\x00\x0f\x00\x10\x00\x11\x00\x0b\x00\x00\x00\x0c\x00\x00\x00\x0d\x00\x00\x00\x00\x00\x12\x00\x13\x00\x00\x00\x00\x00\x00\x00\x00\x00\x0e\x00\x0f\x00\x10\x00\x11\x00\x44\x00\x3f\x00\x06\x00\x07\x00\x00\x00\x08\x00\x09\x00\x12\x00\x13\x00\x00\x00\x7c\x00\x7d\x00\x68\x00\x69\x00\x6a\x00\x7e\x00\x7f\x00\x80\x00\x22\x01\x06\x00\x07\x00\x00\x00\x08\x00\x09\x00\x0b\x00\x00\x00\x0c\x00\x00\x00\x0d\x00\x00\x00\x00\x00\x23\x01\x24\x01\x00\x00\x00\x00\x00\x00\x00\x00\x0e\x00\x0f\x00\x10\x00\x11\x00\x0b\x00\x00\x00\x0c\x00\x00\x00\x0d\x00\x00\x00\x00\x00\x12\x00\x13\x00\x00\x00\x00\x00\x00\x00\x00\x00\x0e\x00\x0f\x00\x10\x00\x11\x00\x22\x01\x06\x00\x07\x00\x00\x00\x08\x00\x09\x00\x00\x00\x12\x00\x13\x00\x00\x00\x00\x00\x00\x00\x00\x00\x25\x01\x24\x01\x00\x00\x00\x00\x22\x01\x06\x00\x07\x00\x00\x00\x08\x00\x09\x00\x0b\x00\x00\x00\x0c\x00\x00\x00\x0d\x00\x00\x00\x00\x00\x00\x00\xc3\x01\x00\x00\x00\x00\x00\x00\x00\x00\x0e\x00\x0f\x00\x10\x00\x11\x00\x0b\x00\x00\x00\x0c\x00\x00\x00\x0d\x00\x00\x00\x00\x00\x12\x00\x13\x00\x00\x00\x00\x00\x00\x00\x00\x00\x0e\x00\x0f\x00\x10\x00\x11\x00\x8d\x00\x06\x00\x07\x00\x00\x00\x08\x00\x09\x00\x00\x00\x12\x00\x13\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x84\x00\x07\x00\x00\x00\x08\x00\x09\x00\x0b\x00\x00\x00\x0c\x00\x00\x00\x0d\x00\x00\x00\x79\x00\x60\x00\x61\x00\x62\x00\x00\x00\x00\x00\x00\x00\x0e\x00\x0f\x00\x10\x00\x11\x00\x0b\x00\x00\x00\x0c\x00\x00\x00\x0d\x00\x00\x00\x00\x00\x12\x00\x13\x00\x79\x00\x60\x00\x61\x00\x62\x00\x0e\x00\x0f\x00\x10\x00\x11\x00\x7a\x00\x00\x00\x7b\x00\x00\x00\x00\x00\x00\x00\xa5\xfe\x12\x00\x13\x00\x15\x01\x00\x00\x7c\x00\x7d\x00\x68\x00\x69\x00\x6a\x00\x7e\x00\x7f\x00\x80\x00\x00\x00\x7a\x00\x79\x00\x60\x00\x61\x00\x62\x00\x00\x00\x00\x00\x00\x00\x00\x00\x79\x00\x60\x00\x7c\x00\x7d\x00\x68\x00\x69\x00\x6a\x00\x7e\x00\x7f\x00\x80\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x7a\x00\x00\x00\x7b\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xa5\x01\x00\x00\x00\x00\x7c\x00\x7d\x00\x68\x00\x69\x00\x6a\x00\x7e\x00\x7f\x00\x80\x00\x7c\x00\x7d\x00\x68\x00\x69\x00\x6a\x00\x7e\x00\x7f\x00\x80\x00\x47\x00\x48\x00\x09\x00\x00\x00\x00\x00\x00\x00\x89\x00\x09\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x0b\x00\x00\x00\x0c\x00\x00\x00\x0d\x00\x0b\x00\x00\x00\x0c\x00\x00\x00\x0d\x00\x00\x00\x00\x00\x00\x00\x0e\x00\x0f\x00\x10\x00\x11\x00\x00\x00\x0e\x00\x0f\x00\x10\x00\x11\x00\x9c\x00\x09\x00\x12\x00\x13\x00\x00\x00\x70\x00\x09\x00\x12\x00\x13\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x0b\x00\x00\x00\x0c\x00\x00\x00\x0d\x00\x0b\x00\x00\x00\x0c\x00\x00\x00\x0d\x00\x00\x00\x00\x00\x00\x00\x0e\x00\x0f\x00\x10\x00\x11\x00\x00\x00\x0e\x00\x0f\x00\x10\x00\x11\x00\x00\x00\x00\x00\x12\x00\x9d\x00\x00\x00\x00\x00\x00\x00\x12\x00\x13\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00"#

happyReduceArr = array (2, 356) [
	(2 , happyReduce_2),
	(3 , happyReduce_3),
	(4 , happyReduce_4),
	(5 , happyReduce_5),
	(6 , happyReduce_6),
	(7 , happyReduce_7),
	(8 , happyReduce_8),
	(9 , happyReduce_9),
	(10 , happyReduce_10),
	(11 , happyReduce_11),
	(12 , happyReduce_12),
	(13 , happyReduce_13),
	(14 , happyReduce_14),
	(15 , happyReduce_15),
	(16 , happyReduce_16),
	(17 , happyReduce_17),
	(18 , happyReduce_18),
	(19 , happyReduce_19),
	(20 , happyReduce_20),
	(21 , happyReduce_21),
	(22 , happyReduce_22),
	(23 , happyReduce_23),
	(24 , happyReduce_24),
	(25 , happyReduce_25),
	(26 , happyReduce_26),
	(27 , happyReduce_27),
	(28 , happyReduce_28),
	(29 , happyReduce_29),
	(30 , happyReduce_30),
	(31 , happyReduce_31),
	(32 , happyReduce_32),
	(33 , happyReduce_33),
	(34 , happyReduce_34),
	(35 , happyReduce_35),
	(36 , happyReduce_36),
	(37 , happyReduce_37),
	(38 , happyReduce_38),
	(39 , happyReduce_39),
	(40 , happyReduce_40),
	(41 , happyReduce_41),
	(42 , happyReduce_42),
	(43 , happyReduce_43),
	(44 , happyReduce_44),
	(45 , happyReduce_45),
	(46 , happyReduce_46),
	(47 , happyReduce_47),
	(48 , happyReduce_48),
	(49 , happyReduce_49),
	(50 , happyReduce_50),
	(51 , happyReduce_51),
	(52 , happyReduce_52),
	(53 , happyReduce_53),
	(54 , happyReduce_54),
	(55 , happyReduce_55),
	(56 , happyReduce_56),
	(57 , happyReduce_57),
	(58 , happyReduce_58),
	(59 , happyReduce_59),
	(60 , happyReduce_60),
	(61 , happyReduce_61),
	(62 , happyReduce_62),
	(63 , happyReduce_63),
	(64 , happyReduce_64),
	(65 , happyReduce_65),
	(66 , happyReduce_66),
	(67 , happyReduce_67),
	(68 , happyReduce_68),
	(69 , happyReduce_69),
	(70 , happyReduce_70),
	(71 , happyReduce_71),
	(72 , happyReduce_72),
	(73 , happyReduce_73),
	(74 , happyReduce_74),
	(75 , happyReduce_75),
	(76 , happyReduce_76),
	(77 , happyReduce_77),
	(78 , happyReduce_78),
	(79 , happyReduce_79),
	(80 , happyReduce_80),
	(81 , happyReduce_81),
	(82 , happyReduce_82),
	(83 , happyReduce_83),
	(84 , happyReduce_84),
	(85 , happyReduce_85),
	(86 , happyReduce_86),
	(87 , happyReduce_87),
	(88 , happyReduce_88),
	(89 , happyReduce_89),
	(90 , happyReduce_90),
	(91 , happyReduce_91),
	(92 , happyReduce_92),
	(93 , happyReduce_93),
	(94 , happyReduce_94),
	(95 , happyReduce_95),
	(96 , happyReduce_96),
	(97 , happyReduce_97),
	(98 , happyReduce_98),
	(99 , happyReduce_99),
	(100 , happyReduce_100),
	(101 , happyReduce_101),
	(102 , happyReduce_102),
	(103 , happyReduce_103),
	(104 , happyReduce_104),
	(105 , happyReduce_105),
	(106 , happyReduce_106),
	(107 , happyReduce_107),
	(108 , happyReduce_108),
	(109 , happyReduce_109),
	(110 , happyReduce_110),
	(111 , happyReduce_111),
	(112 , happyReduce_112),
	(113 , happyReduce_113),
	(114 , happyReduce_114),
	(115 , happyReduce_115),
	(116 , happyReduce_116),
	(117 , happyReduce_117),
	(118 , happyReduce_118),
	(119 , happyReduce_119),
	(120 , happyReduce_120),
	(121 , happyReduce_121),
	(122 , happyReduce_122),
	(123 , happyReduce_123),
	(124 , happyReduce_124),
	(125 , happyReduce_125),
	(126 , happyReduce_126),
	(127 , happyReduce_127),
	(128 , happyReduce_128),
	(129 , happyReduce_129),
	(130 , happyReduce_130),
	(131 , happyReduce_131),
	(132 , happyReduce_132),
	(133 , happyReduce_133),
	(134 , happyReduce_134),
	(135 , happyReduce_135),
	(136 , happyReduce_136),
	(137 , happyReduce_137),
	(138 , happyReduce_138),
	(139 , happyReduce_139),
	(140 , happyReduce_140),
	(141 , happyReduce_141),
	(142 , happyReduce_142),
	(143 , happyReduce_143),
	(144 , happyReduce_144),
	(145 , happyReduce_145),
	(146 , happyReduce_146),
	(147 , happyReduce_147),
	(148 , happyReduce_148),
	(149 , happyReduce_149),
	(150 , happyReduce_150),
	(151 , happyReduce_151),
	(152 , happyReduce_152),
	(153 , happyReduce_153),
	(154 , happyReduce_154),
	(155 , happyReduce_155),
	(156 , happyReduce_156),
	(157 , happyReduce_157),
	(158 , happyReduce_158),
	(159 , happyReduce_159),
	(160 , happyReduce_160),
	(161 , happyReduce_161),
	(162 , happyReduce_162),
	(163 , happyReduce_163),
	(164 , happyReduce_164),
	(165 , happyReduce_165),
	(166 , happyReduce_166),
	(167 , happyReduce_167),
	(168 , happyReduce_168),
	(169 , happyReduce_169),
	(170 , happyReduce_170),
	(171 , happyReduce_171),
	(172 , happyReduce_172),
	(173 , happyReduce_173),
	(174 , happyReduce_174),
	(175 , happyReduce_175),
	(176 , happyReduce_176),
	(177 , happyReduce_177),
	(178 , happyReduce_178),
	(179 , happyReduce_179),
	(180 , happyReduce_180),
	(181 , happyReduce_181),
	(182 , happyReduce_182),
	(183 , happyReduce_183),
	(184 , happyReduce_184),
	(185 , happyReduce_185),
	(186 , happyReduce_186),
	(187 , happyReduce_187),
	(188 , happyReduce_188),
	(189 , happyReduce_189),
	(190 , happyReduce_190),
	(191 , happyReduce_191),
	(192 , happyReduce_192),
	(193 , happyReduce_193),
	(194 , happyReduce_194),
	(195 , happyReduce_195),
	(196 , happyReduce_196),
	(197 , happyReduce_197),
	(198 , happyReduce_198),
	(199 , happyReduce_199),
	(200 , happyReduce_200),
	(201 , happyReduce_201),
	(202 , happyReduce_202),
	(203 , happyReduce_203),
	(204 , happyReduce_204),
	(205 , happyReduce_205),
	(206 , happyReduce_206),
	(207 , happyReduce_207),
	(208 , happyReduce_208),
	(209 , happyReduce_209),
	(210 , happyReduce_210),
	(211 , happyReduce_211),
	(212 , happyReduce_212),
	(213 , happyReduce_213),
	(214 , happyReduce_214),
	(215 , happyReduce_215),
	(216 , happyReduce_216),
	(217 , happyReduce_217),
	(218 , happyReduce_218),
	(219 , happyReduce_219),
	(220 , happyReduce_220),
	(221 , happyReduce_221),
	(222 , happyReduce_222),
	(223 , happyReduce_223),
	(224 , happyReduce_224),
	(225 , happyReduce_225),
	(226 , happyReduce_226),
	(227 , happyReduce_227),
	(228 , happyReduce_228),
	(229 , happyReduce_229),
	(230 , happyReduce_230),
	(231 , happyReduce_231),
	(232 , happyReduce_232),
	(233 , happyReduce_233),
	(234 , happyReduce_234),
	(235 , happyReduce_235),
	(236 , happyReduce_236),
	(237 , happyReduce_237),
	(238 , happyReduce_238),
	(239 , happyReduce_239),
	(240 , happyReduce_240),
	(241 , happyReduce_241),
	(242 , happyReduce_242),
	(243 , happyReduce_243),
	(244 , happyReduce_244),
	(245 , happyReduce_245),
	(246 , happyReduce_246),
	(247 , happyReduce_247),
	(248 , happyReduce_248),
	(249 , happyReduce_249),
	(250 , happyReduce_250),
	(251 , happyReduce_251),
	(252 , happyReduce_252),
	(253 , happyReduce_253),
	(254 , happyReduce_254),
	(255 , happyReduce_255),
	(256 , happyReduce_256),
	(257 , happyReduce_257),
	(258 , happyReduce_258),
	(259 , happyReduce_259),
	(260 , happyReduce_260),
	(261 , happyReduce_261),
	(262 , happyReduce_262),
	(263 , happyReduce_263),
	(264 , happyReduce_264),
	(265 , happyReduce_265),
	(266 , happyReduce_266),
	(267 , happyReduce_267),
	(268 , happyReduce_268),
	(269 , happyReduce_269),
	(270 , happyReduce_270),
	(271 , happyReduce_271),
	(272 , happyReduce_272),
	(273 , happyReduce_273),
	(274 , happyReduce_274),
	(275 , happyReduce_275),
	(276 , happyReduce_276),
	(277 , happyReduce_277),
	(278 , happyReduce_278),
	(279 , happyReduce_279),
	(280 , happyReduce_280),
	(281 , happyReduce_281),
	(282 , happyReduce_282),
	(283 , happyReduce_283),
	(284 , happyReduce_284),
	(285 , happyReduce_285),
	(286 , happyReduce_286),
	(287 , happyReduce_287),
	(288 , happyReduce_288),
	(289 , happyReduce_289),
	(290 , happyReduce_290),
	(291 , happyReduce_291),
	(292 , happyReduce_292),
	(293 , happyReduce_293),
	(294 , happyReduce_294),
	(295 , happyReduce_295),
	(296 , happyReduce_296),
	(297 , happyReduce_297),
	(298 , happyReduce_298),
	(299 , happyReduce_299),
	(300 , happyReduce_300),
	(301 , happyReduce_301),
	(302 , happyReduce_302),
	(303 , happyReduce_303),
	(304 , happyReduce_304),
	(305 , happyReduce_305),
	(306 , happyReduce_306),
	(307 , happyReduce_307),
	(308 , happyReduce_308),
	(309 , happyReduce_309),
	(310 , happyReduce_310),
	(311 , happyReduce_311),
	(312 , happyReduce_312),
	(313 , happyReduce_313),
	(314 , happyReduce_314),
	(315 , happyReduce_315),
	(316 , happyReduce_316),
	(317 , happyReduce_317),
	(318 , happyReduce_318),
	(319 , happyReduce_319),
	(320 , happyReduce_320),
	(321 , happyReduce_321),
	(322 , happyReduce_322),
	(323 , happyReduce_323),
	(324 , happyReduce_324),
	(325 , happyReduce_325),
	(326 , happyReduce_326),
	(327 , happyReduce_327),
	(328 , happyReduce_328),
	(329 , happyReduce_329),
	(330 , happyReduce_330),
	(331 , happyReduce_331),
	(332 , happyReduce_332),
	(333 , happyReduce_333),
	(334 , happyReduce_334),
	(335 , happyReduce_335),
	(336 , happyReduce_336),
	(337 , happyReduce_337),
	(338 , happyReduce_338),
	(339 , happyReduce_339),
	(340 , happyReduce_340),
	(341 , happyReduce_341),
	(342 , happyReduce_342),
	(343 , happyReduce_343),
	(344 , happyReduce_344),
	(345 , happyReduce_345),
	(346 , happyReduce_346),
	(347 , happyReduce_347),
	(348 , happyReduce_348),
	(349 , happyReduce_349),
	(350 , happyReduce_350),
	(351 , happyReduce_351),
	(352 , happyReduce_352),
	(353 , happyReduce_353),
	(354 , happyReduce_354),
	(355 , happyReduce_355),
	(356 , happyReduce_356)
	]

happy_n_terms = 83 :: Int
happy_n_nonterms = 138 :: Int

happyReduce_2 = happySpecReduce_2  0# happyReduction_2
happyReduction_2 happy_x_2
	happy_x_1
	 =  case happyOut134 happy_x_1 of { happy_var_1 -> 
	case happyOut6 happy_x_2 of { happy_var_2 -> 
	happyIn5
		 (happy_var_2 { hsModuleSrcLoc = happy_var_1, hsModuleOptions = [] }
	)}}

happyReduce_3 = happySpecReduce_3  0# happyReduction_3
happyReduction_3 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut134 happy_x_1 of { happy_var_1 -> 
	case happyOutTok happy_x_2 of { (PragmaOptions happy_var_2) -> 
	case happyOut5 happy_x_3 of { happy_var_3 -> 
	happyIn5
		 (happy_var_3 { hsModuleSrcLoc = happy_var_1, hsModuleOptions = hsModuleOptions happy_var_3 ++ happy_var_2 }
	)}}}

happyReduce_4 = happyReduce 5# 1# happyReduction_4
happyReduction_4 (happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut137 happy_x_2 of { happy_var_2 -> 
	case happyOut10 happy_x_3 of { happy_var_3 -> 
	case happyOut7 happy_x_5 of { happy_var_5 -> 
	happyIn6
		 (HsModule { hsModuleName = happy_var_2, hsModuleExports = happy_var_3, hsModuleImports = (fst happy_var_5), hsModuleDecls = (snd happy_var_5) }
	) `HappyStk` happyRest}}}

happyReduce_5 = happySpecReduce_1  1# happyReduction_5
happyReduction_5 happy_x_1
	 =  case happyOut7 happy_x_1 of { happy_var_1 -> 
	happyIn6
		 (HsModule { hsModuleName = main_mod, hsModuleExports = Just [HsEVar (UnQual (HsIdent "main"))], hsModuleImports = (fst happy_var_1), hsModuleDecls = (snd happy_var_1) }
	)}

happyReduce_6 = happySpecReduce_3  2# happyReduction_6
happyReduction_6 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut8 happy_x_2 of { happy_var_2 -> 
	happyIn7
		 (happy_var_2
	)}

happyReduce_7 = happySpecReduce_3  2# happyReduction_7
happyReduction_7 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut8 happy_x_2 of { happy_var_2 -> 
	happyIn7
		 (happy_var_2
	)}

happyReduce_8 = happyReduce 4# 3# happyReduction_8
happyReduction_8 (happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut17 happy_x_1 of { happy_var_1 -> 
	case happyOut31 happy_x_3 of { happy_var_3 -> 
	happyIn8
		 ((reverse happy_var_1, fixupHsDecls (reverse happy_var_3))
	) `HappyStk` happyRest}}

happyReduce_9 = happySpecReduce_2  3# happyReduction_9
happyReduction_9 happy_x_2
	happy_x_1
	 =  case happyOut31 happy_x_1 of { happy_var_1 -> 
	happyIn8
		 (([], fixupHsDecls (reverse happy_var_1))
	)}

happyReduce_10 = happySpecReduce_2  3# happyReduction_10
happyReduction_10 happy_x_2
	happy_x_1
	 =  case happyOut17 happy_x_1 of { happy_var_1 -> 
	happyIn8
		 ((reverse happy_var_1, [])
	)}

happyReduce_11 = happySpecReduce_0  3# happyReduction_11
happyReduction_11  =  happyIn8
		 (([], [])
	)

happyReduce_12 = happySpecReduce_1  4# happyReduction_12
happyReduction_12 happy_x_1
	 =  happyIn9
		 (()
	)

happyReduce_13 = happySpecReduce_0  4# happyReduction_13
happyReduction_13  =  happyIn9
		 (()
	)

happyReduce_14 = happySpecReduce_1  5# happyReduction_14
happyReduction_14 happy_x_1
	 =  case happyOut11 happy_x_1 of { happy_var_1 -> 
	happyIn10
		 (Just happy_var_1
	)}

happyReduce_15 = happySpecReduce_0  5# happyReduction_15
happyReduction_15  =  happyIn10
		 (Nothing
	)

happyReduce_16 = happyReduce 4# 6# happyReduction_16
happyReduction_16 (happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut13 happy_x_2 of { happy_var_2 -> 
	happyIn11
		 (reverse happy_var_2
	) `HappyStk` happyRest}

happyReduce_17 = happySpecReduce_2  6# happyReduction_17
happyReduction_17 happy_x_2
	happy_x_1
	 =  happyIn11
		 ([]
	)

happyReduce_18 = happySpecReduce_1  7# happyReduction_18
happyReduction_18 happy_x_1
	 =  happyIn12
		 (()
	)

happyReduce_19 = happySpecReduce_0  7# happyReduction_19
happyReduction_19  =  happyIn12
		 (()
	)

happyReduce_20 = happySpecReduce_3  8# happyReduction_20
happyReduction_20 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut13 happy_x_1 of { happy_var_1 -> 
	case happyOut14 happy_x_3 of { happy_var_3 -> 
	happyIn13
		 (happy_var_3 : happy_var_1
	)}}

happyReduce_21 = happySpecReduce_1  8# happyReduction_21
happyReduction_21 happy_x_1
	 =  case happyOut14 happy_x_1 of { happy_var_1 -> 
	happyIn13
		 ([happy_var_1]
	)}

happyReduce_22 = happySpecReduce_1  9# happyReduction_22
happyReduction_22 happy_x_1
	 =  case happyOut111 happy_x_1 of { happy_var_1 -> 
	happyIn14
		 (HsEVar happy_var_1
	)}

happyReduce_23 = happySpecReduce_1  9# happyReduction_23
happyReduction_23 happy_x_1
	 =  case happyOut140 happy_x_1 of { happy_var_1 -> 
	happyIn14
		 (HsEAbs happy_var_1
	)}

happyReduce_24 = happyReduce 4# 9# happyReduction_24
happyReduction_24 (happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut140 happy_x_1 of { happy_var_1 -> 
	happyIn14
		 (HsEThingAll happy_var_1
	) `HappyStk` happyRest}

happyReduce_25 = happySpecReduce_3  9# happyReduction_25
happyReduction_25 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut140 happy_x_1 of { happy_var_1 -> 
	happyIn14
		 (HsEThingWith happy_var_1 []
	)}

happyReduce_26 = happyReduce 4# 9# happyReduction_26
happyReduction_26 (happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut140 happy_x_1 of { happy_var_1 -> 
	case happyOut15 happy_x_3 of { happy_var_3 -> 
	happyIn14
		 (HsEThingWith happy_var_1 (reverse happy_var_3)
	) `HappyStk` happyRest}}

happyReduce_27 = happySpecReduce_2  9# happyReduction_27
happyReduction_27 happy_x_2
	happy_x_1
	 =  case happyOut137 happy_x_2 of { happy_var_2 -> 
	happyIn14
		 (HsEModuleContents happy_var_2
	)}

happyReduce_28 = happySpecReduce_3  10# happyReduction_28
happyReduction_28 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut15 happy_x_1 of { happy_var_1 -> 
	case happyOut16 happy_x_3 of { happy_var_3 -> 
	happyIn15
		 (happy_var_3 : happy_var_1
	)}}

happyReduce_29 = happySpecReduce_1  10# happyReduction_29
happyReduction_29 happy_x_1
	 =  case happyOut16 happy_x_1 of { happy_var_1 -> 
	happyIn15
		 ([happy_var_1]
	)}

happyReduce_30 = happySpecReduce_1  11# happyReduction_30
happyReduction_30 happy_x_1
	 =  case happyOut111 happy_x_1 of { happy_var_1 -> 
	happyIn16
		 (happy_var_1
	)}

happyReduce_31 = happySpecReduce_1  11# happyReduction_31
happyReduction_31 happy_x_1
	 =  case happyOut113 happy_x_1 of { happy_var_1 -> 
	happyIn16
		 (happy_var_1
	)}

happyReduce_32 = happySpecReduce_3  12# happyReduction_32
happyReduction_32 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut17 happy_x_1 of { happy_var_1 -> 
	case happyOut18 happy_x_3 of { happy_var_3 -> 
	happyIn17
		 (happy_var_3 : happy_var_1
	)}}

happyReduce_33 = happySpecReduce_1  12# happyReduction_33
happyReduction_33 happy_x_1
	 =  case happyOut18 happy_x_1 of { happy_var_1 -> 
	happyIn17
		 ([happy_var_1]
	)}

happyReduce_34 = happyReduce 6# 13# happyReduction_34
happyReduction_34 (happy_x_6 `HappyStk`
	happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut134 happy_x_2 of { happy_var_2 -> 
	case happyOut19 happy_x_3 of { happy_var_3 -> 
	case happyOut137 happy_x_4 of { happy_var_4 -> 
	case happyOut20 happy_x_5 of { happy_var_5 -> 
	case happyOut21 happy_x_6 of { happy_var_6 -> 
	happyIn18
		 (HsImportDecl happy_var_2 happy_var_4 happy_var_3 happy_var_5 happy_var_6
	) `HappyStk` happyRest}}}}}

happyReduce_35 = happySpecReduce_1  14# happyReduction_35
happyReduction_35 happy_x_1
	 =  happyIn19
		 (True
	)

happyReduce_36 = happySpecReduce_0  14# happyReduction_36
happyReduction_36  =  happyIn19
		 (False
	)

happyReduce_37 = happySpecReduce_2  15# happyReduction_37
happyReduction_37 happy_x_2
	happy_x_1
	 =  case happyOut137 happy_x_2 of { happy_var_2 -> 
	happyIn20
		 (Just happy_var_2
	)}

happyReduce_38 = happySpecReduce_0  15# happyReduction_38
happyReduction_38  =  happyIn20
		 (Nothing
	)

happyReduce_39 = happySpecReduce_1  16# happyReduction_39
happyReduction_39 happy_x_1
	 =  case happyOut22 happy_x_1 of { happy_var_1 -> 
	happyIn21
		 (Just happy_var_1
	)}

happyReduce_40 = happySpecReduce_0  16# happyReduction_40
happyReduction_40  =  happyIn21
		 (Nothing
	)

happyReduce_41 = happyReduce 4# 17# happyReduction_41
happyReduction_41 (happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut23 happy_x_2 of { happy_var_2 -> 
	happyIn22
		 ((False, reverse happy_var_2)
	) `HappyStk` happyRest}

happyReduce_42 = happySpecReduce_2  17# happyReduction_42
happyReduction_42 happy_x_2
	happy_x_1
	 =  happyIn22
		 ((False, [])
	)

happyReduce_43 = happyReduce 5# 17# happyReduction_43
happyReduction_43 (happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut23 happy_x_3 of { happy_var_3 -> 
	happyIn22
		 ((True,  reverse happy_var_3)
	) `HappyStk` happyRest}

happyReduce_44 = happySpecReduce_3  18# happyReduction_44
happyReduction_44 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut23 happy_x_1 of { happy_var_1 -> 
	case happyOut24 happy_x_3 of { happy_var_3 -> 
	happyIn23
		 (happy_var_3 : happy_var_1
	)}}

happyReduce_45 = happySpecReduce_1  18# happyReduction_45
happyReduction_45 happy_x_1
	 =  case happyOut24 happy_x_1 of { happy_var_1 -> 
	happyIn23
		 ([happy_var_1]
	)}

happyReduce_46 = happySpecReduce_1  19# happyReduction_46
happyReduction_46 happy_x_1
	 =  case happyOut110 happy_x_1 of { happy_var_1 -> 
	happyIn24
		 (HsIVar happy_var_1
	)}

happyReduce_47 = happySpecReduce_1  19# happyReduction_47
happyReduction_47 happy_x_1
	 =  case happyOut138 happy_x_1 of { happy_var_1 -> 
	happyIn24
		 (HsIAbs happy_var_1
	)}

happyReduce_48 = happyReduce 4# 19# happyReduction_48
happyReduction_48 (happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut138 happy_x_1 of { happy_var_1 -> 
	happyIn24
		 (HsIThingAll happy_var_1
	) `HappyStk` happyRest}

happyReduce_49 = happySpecReduce_3  19# happyReduction_49
happyReduction_49 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut138 happy_x_1 of { happy_var_1 -> 
	happyIn24
		 (HsIThingWith happy_var_1 []
	)}

happyReduce_50 = happyReduce 4# 19# happyReduction_50
happyReduction_50 (happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut138 happy_x_1 of { happy_var_1 -> 
	case happyOut25 happy_x_3 of { happy_var_3 -> 
	happyIn24
		 (HsIThingWith happy_var_1 (reverse happy_var_3)
	) `HappyStk` happyRest}}

happyReduce_51 = happySpecReduce_3  20# happyReduction_51
happyReduction_51 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut25 happy_x_1 of { happy_var_1 -> 
	case happyOut26 happy_x_3 of { happy_var_3 -> 
	happyIn25
		 (happy_var_3 : happy_var_1
	)}}

happyReduce_52 = happySpecReduce_1  20# happyReduction_52
happyReduction_52 happy_x_1
	 =  case happyOut26 happy_x_1 of { happy_var_1 -> 
	happyIn25
		 ([happy_var_1]
	)}

happyReduce_53 = happySpecReduce_1  21# happyReduction_53
happyReduction_53 happy_x_1
	 =  case happyOut110 happy_x_1 of { happy_var_1 -> 
	happyIn26
		 (happy_var_1
	)}

happyReduce_54 = happySpecReduce_1  21# happyReduction_54
happyReduction_54 happy_x_1
	 =  case happyOut112 happy_x_1 of { happy_var_1 -> 
	happyIn26
		 (happy_var_1
	)}

happyReduce_55 = happyReduce 4# 22# happyReduction_55
happyReduction_55 (happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut134 happy_x_1 of { happy_var_1 -> 
	case happyOut29 happy_x_2 of { happy_var_2 -> 
	case happyOut28 happy_x_3 of { happy_var_3 -> 
	case happyOut30 happy_x_4 of { happy_var_4 -> 
	happyIn27
		 (HsInfixDecl happy_var_1 happy_var_2 happy_var_3 (reverse happy_var_4)
	) `HappyStk` happyRest}}}}

happyReduce_56 = happySpecReduce_0  23# happyReduction_56
happyReduction_56  =  happyIn28
		 (9
	)

happyReduce_57 = happyMonadReduce 1# 23# happyReduction_57
happyReduction_57 (happy_x_1 `HappyStk`
	happyRest) tk
	 = happyThen (case happyOutTok happy_x_1 of { (IntTok happy_var_1) -> 
	(  checkPrec happy_var_1 `thenP` \p ->
                                                  returnP (fromInteger (readInteger p)))}
	) (\r -> happyReturn (happyIn28 r))

happyReduce_58 = happySpecReduce_1  24# happyReduction_58
happyReduction_58 happy_x_1
	 =  happyIn29
		 (HsAssocNone
	)

happyReduce_59 = happySpecReduce_1  24# happyReduction_59
happyReduction_59 happy_x_1
	 =  happyIn29
		 (HsAssocLeft
	)

happyReduce_60 = happySpecReduce_1  24# happyReduction_60
happyReduction_60 happy_x_1
	 =  happyIn29
		 (HsAssocRight
	)

happyReduce_61 = happySpecReduce_3  25# happyReduction_61
happyReduction_61 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut30 happy_x_1 of { happy_var_1 -> 
	case happyOut119 happy_x_3 of { happy_var_3 -> 
	happyIn30
		 (happy_var_3 : happy_var_1
	)}}

happyReduce_62 = happySpecReduce_1  25# happyReduction_62
happyReduction_62 happy_x_1
	 =  case happyOut119 happy_x_1 of { happy_var_1 -> 
	happyIn30
		 ([happy_var_1]
	)}

happyReduce_63 = happySpecReduce_3  26# happyReduction_63
happyReduction_63 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut31 happy_x_1 of { happy_var_1 -> 
	case happyOut32 happy_x_3 of { happy_var_3 -> 
	happyIn31
		 (happy_var_3 : happy_var_1
	)}}

happyReduce_64 = happySpecReduce_1  26# happyReduction_64
happyReduction_64 happy_x_1
	 =  case happyOut32 happy_x_1 of { happy_var_1 -> 
	happyIn31
		 ([happy_var_1]
	)}

happyReduce_65 = happyMonadReduce 4# 27# happyReduction_65
happyReduction_65 (happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest) tk
	 = happyThen (case happyOut55 happy_x_2 of { happy_var_2 -> 
	case happyOut134 happy_x_3 of { happy_var_3 -> 
	case happyOut71 happy_x_4 of { happy_var_4 -> 
	( checkDataHeader happy_var_2 `thenP` \(cs,c,t) ->
             returnP hsDataDecl { hsDeclSrcLoc = happy_var_3, hsDeclContext = cs, hsDeclName = c, hsDeclArgs = t, hsDeclDerives = happy_var_4 })}}}
	) (\r -> happyReturn (happyIn32 r))

happyReduce_66 = happyMonadReduce 6# 27# happyReduction_66
happyReduction_66 (happy_x_6 `HappyStk`
	happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest) tk
	 = happyThen (case happyOut55 happy_x_2 of { happy_var_2 -> 
	case happyOut49 happy_x_4 of { happy_var_4 -> 
	case happyOut134 happy_x_5 of { happy_var_5 -> 
	case happyOut71 happy_x_6 of { happy_var_6 -> 
	( checkDataHeader happy_var_2 `thenP` \(cs,c,t) ->
             returnP hsDataDecl { hsDeclSrcLoc = happy_var_5, hsDeclContext = cs, hsDeclName = c, hsDeclArgs = t, hsDeclDerives = happy_var_6, hsDeclHasKind = Just happy_var_4 })}}}}
	) (\r -> happyReturn (happyIn32 r))

happyReduce_67 = happyMonadReduce 6# 27# happyReduction_67
happyReduction_67 (happy_x_6 `HappyStk`
	happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest) tk
	 = happyThen (case happyOut55 happy_x_2 of { happy_var_2 -> 
	case happyOut134 happy_x_3 of { happy_var_3 -> 
	case happyOut61 happy_x_5 of { happy_var_5 -> 
	case happyOut71 happy_x_6 of { happy_var_6 -> 
	( checkDataHeader happy_var_2 `thenP` \(cs,c,t) ->
                         returnP hsDataDecl { hsDeclSrcLoc = happy_var_3, hsDeclContext = cs, hsDeclName = c, hsDeclArgs = t, hsDeclDerives = happy_var_6, hsDeclCons = reverse happy_var_5 })}}}}
	) (\r -> happyReturn (happyIn32 r))

happyReduce_68 = happyMonadReduce 7# 27# happyReduction_68
happyReduction_68 (happy_x_7 `HappyStk`
	happy_x_6 `HappyStk`
	happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest) tk
	 = happyThen (case happyOut55 happy_x_3 of { happy_var_3 -> 
	case happyOut134 happy_x_4 of { happy_var_4 -> 
	case happyOut61 happy_x_6 of { happy_var_6 -> 
	case happyOut71 happy_x_7 of { happy_var_7 -> 
	( checkDataHeader happy_var_3 `thenP` \(cs,c,t) ->
                         returnP hsDataDecl { hsDeclKindDecl = True, hsDeclSrcLoc = happy_var_4, hsDeclContext = cs, hsDeclName = c, hsDeclArgs = t, hsDeclDerives = happy_var_7, hsDeclCons = reverse happy_var_6 })}}}}
	) (\r -> happyReturn (happyIn32 r))

happyReduce_69 = happyMonadReduce 6# 27# happyReduction_69
happyReduction_69 (happy_x_6 `HappyStk`
	happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest) tk
	 = happyThen (case happyOut55 happy_x_2 of { happy_var_2 -> 
	case happyOut134 happy_x_3 of { happy_var_3 -> 
	case happyOut62 happy_x_5 of { happy_var_5 -> 
	case happyOut71 happy_x_6 of { happy_var_6 -> 
	( checkDataHeader happy_var_2 `thenP` \(cs,c,t) ->
                         returnP (HsNewTypeDecl happy_var_3 cs c t happy_var_5 happy_var_6))}}}}
	) (\r -> happyReturn (happyIn32 r))

happyReduce_70 = happyReduce 5# 27# happyReduction_70
happyReduction_70 (happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut134 happy_x_2 of { happy_var_2 -> 
	case happyOut55 happy_x_3 of { happy_var_3 -> 
	case happyOut73 happy_x_5 of { happy_var_5 -> 
	happyIn32
		 (HsClassDecl happy_var_2 happy_var_3 happy_var_5
	) `HappyStk` happyRest}}}

happyReduce_71 = happyMonadReduce 8# 27# happyReduction_71
happyReduction_71 (happy_x_8 `HappyStk`
	happy_x_7 `HappyStk`
	happy_x_6 `HappyStk`
	happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest) tk
	 = happyThen (case happyOut134 happy_x_3 of { happy_var_3 -> 
	case happyOut125 happy_x_4 of { happy_var_4 -> 
	case happyOut78 happy_x_5 of { happy_var_5 -> 
	case happyOut56 happy_x_7 of { happy_var_7 -> 
	case happyOut73 happy_x_8 of { happy_var_8 -> 
	( let
                         { (cxt, clss) = happy_var_7;
                           ret = HsClassAliasDecl { hsDeclSrcLoc = happy_var_3, hsDeclName = happy_var_4, hsDeclTypeArgs = map HsTyVar happy_var_5, hsDeclContext = cxt, hsDeclClasses = clss, hsDeclDecls =happy_var_8 }
                         } in trace ("\n"++show ret++"\n") (return ret))}}}}}
	) (\r -> happyReturn (happyIn32 r))

happyReduce_72 = happyReduce 4# 27# happyReduction_72
happyReduction_72 (happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut134 happy_x_2 of { happy_var_2 -> 
	case happyOut55 happy_x_3 of { happy_var_3 -> 
	case happyOut79 happy_x_4 of { happy_var_4 -> 
	happyIn32
		 (HsInstDecl happy_var_2 happy_var_3 happy_var_4
	) `HappyStk` happyRest}}}

happyReduce_73 = happyReduce 4# 27# happyReduction_73
happyReduction_73 (happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut134 happy_x_3 of { happy_var_3 -> 
	case happyOut57 happy_x_4 of { happy_var_4 -> 
	happyIn32
		 (HsDeclDeriving happy_var_3 happy_var_4
	) `HappyStk` happyRest}}

happyReduce_74 = happySpecReduce_3  27# happyReduction_74
happyReduction_74 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut134 happy_x_2 of { happy_var_2 -> 
	case happyOut46 happy_x_3 of { happy_var_3 -> 
	happyIn32
		 (HsDefaultDecl happy_var_2 happy_var_3
	)}}

happyReduce_75 = happyMonadReduce 4# 27# happyReduction_75
happyReduction_75 (happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest) tk
	 = happyThen (case happyOut86 happy_x_1 of { happy_var_1 -> 
	case happyOut134 happy_x_2 of { happy_var_2 -> 
	case happyOut85 happy_x_4 of { happy_var_4 -> 
	( checkPattern happy_var_1 `thenP` \p ->
                                         returnP (HsActionDecl happy_var_2 p happy_var_4))}}}
	) (\r -> happyReturn (happyIn32 r))

happyReduce_76 = happyMonadReduce 7# 27# happyReduction_76
happyReduction_76 (happy_x_7 `HappyStk`
	happy_x_6 `HappyStk`
	happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest) tk
	 = happyThen (case happyOut134 happy_x_2 of { happy_var_2 -> 
	case happyOut78 happy_x_4 of { happy_var_4 -> 
	case happyOut45 happy_x_5 of { happy_var_5 -> 
	case happyOut55 happy_x_7 of { happy_var_7 -> 
	( doForeign happy_var_2 (UnQual (HsIdent "import"):reverse happy_var_4) happy_var_5 happy_var_7)}}}}
	) (\r -> happyReturn (happyIn32 r))

happyReduce_77 = happyMonadReduce 6# 27# happyReduction_77
happyReduction_77 (happy_x_6 `HappyStk`
	happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest) tk
	 = happyThen (case happyOut134 happy_x_2 of { happy_var_2 -> 
	case happyOut78 happy_x_3 of { happy_var_3 -> 
	case happyOut45 happy_x_4 of { happy_var_4 -> 
	case happyOut55 happy_x_6 of { happy_var_6 -> 
	( doForeign happy_var_2 (reverse happy_var_3) happy_var_4 happy_var_6)}}}}
	) (\r -> happyReturn (happyIn32 r))

happyReduce_78 = happyMonadReduce 8# 27# happyReduction_78
happyReduction_78 (happy_x_8 `HappyStk`
	happy_x_7 `HappyStk`
	happy_x_6 `HappyStk`
	happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest) tk
	 = happyThen (case happyOut134 happy_x_2 of { happy_var_2 -> 
	case happyOut78 happy_x_3 of { happy_var_3 -> 
	case happyOut45 happy_x_4 of { happy_var_4 -> 
	case happyOut55 happy_x_6 of { happy_var_6 -> 
	case happyOut85 happy_x_8 of { happy_var_8 -> 
	( doForeignEq happy_var_2 (reverse happy_var_3) happy_var_4 happy_var_6 happy_var_8)}}}}}
	) (\r -> happyReturn (happyIn32 r))

happyReduce_79 = happySpecReduce_3  27# happyReduction_79
happyReduction_79 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOutTok happy_x_1 of { (PragmaRules happy_var_1) -> 
	case happyOut35 happy_x_2 of { happy_var_2 -> 
	happyIn32
		 (HsPragmaRules $ map (\x -> x { hsRuleIsMeta = happy_var_1 }) (reverse happy_var_2)
	)}}

happyReduce_80 = happyReduce 6# 27# happyReduction_80
happyReduction_80 (happy_x_6 `HappyStk`
	happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut134 happy_x_1 of { happy_var_1 -> 
	case happyOutTok happy_x_2 of { (PragmaSpecialize happy_var_2) -> 
	case happyOut110 happy_x_3 of { happy_var_3 -> 
	case happyOut46 happy_x_5 of { happy_var_5 -> 
	happyIn32
		 (HsPragmaSpecialize { hsDeclSrcLoc = happy_var_1, hsDeclBool = happy_var_2, hsDeclName = happy_var_3, hsDeclType = happy_var_5 }
	) `HappyStk` happyRest}}}}

happyReduce_81 = happySpecReduce_1  27# happyReduction_81
happyReduction_81 happy_x_1
	 =  case happyOut40 happy_x_1 of { happy_var_1 -> 
	happyIn32
		 (happy_var_1
	)}

happyReduce_82 = happyReduce 6# 28# happyReduction_82
happyReduction_82 (happy_x_6 `HappyStk`
	happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut134 happy_x_1 of { happy_var_1 -> 
	case happyOutTok happy_x_2 of { (StringTok happy_var_2) -> 
	case happyOut36 happy_x_3 of { happy_var_3 -> 
	case happyOut85 happy_x_4 of { happy_var_4 -> 
	case happyOut85 happy_x_6 of { happy_var_6 -> 
	happyIn33
		 (HsRule { hsRuleSrcLoc = happy_var_1, hsRuleString = happy_var_2, hsRuleFreeVars = happy_var_3, hsRuleLeftExpr = happy_var_4, hsRuleRightExpr = happy_var_6 }
	) `HappyStk` happyRest}}}}}

happyReduce_83 = happySpecReduce_3  29# happyReduction_83
happyReduction_83 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut34 happy_x_1 of { happy_var_1 -> 
	case happyOut33 happy_x_3 of { happy_var_3 -> 
	happyIn34
		 (happy_var_3 : happy_var_1
	)}}

happyReduce_84 = happySpecReduce_2  29# happyReduction_84
happyReduction_84 happy_x_2
	happy_x_1
	 =  case happyOut33 happy_x_1 of { happy_var_1 -> 
	happyIn34
		 ([happy_var_1]
	)}

happyReduce_85 = happySpecReduce_3  30# happyReduction_85
happyReduction_85 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut34 happy_x_2 of { happy_var_2 -> 
	happyIn35
		 (happy_var_2
	)}

happyReduce_86 = happySpecReduce_3  30# happyReduction_86
happyReduction_86 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut34 happy_x_2 of { happy_var_2 -> 
	happyIn35
		 (happy_var_2
	)}

happyReduce_87 = happySpecReduce_3  31# happyReduction_87
happyReduction_87 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut37 happy_x_2 of { happy_var_2 -> 
	happyIn36
		 (happy_var_2
	)}

happyReduce_88 = happySpecReduce_0  31# happyReduction_88
happyReduction_88  =  happyIn36
		 ([]
	)

happyReduce_89 = happyReduce 6# 32# happyReduction_89
happyReduction_89 (happy_x_6 `HappyStk`
	happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut37 happy_x_1 of { happy_var_1 -> 
	case happyOut110 happy_x_3 of { happy_var_3 -> 
	case happyOut46 happy_x_5 of { happy_var_5 -> 
	happyIn37
		 ((happy_var_3,Just happy_var_5) : happy_var_1
	) `HappyStk` happyRest}}}

happyReduce_90 = happySpecReduce_2  32# happyReduction_90
happyReduction_90 happy_x_2
	happy_x_1
	 =  case happyOut37 happy_x_1 of { happy_var_1 -> 
	case happyOut110 happy_x_2 of { happy_var_2 -> 
	happyIn37
		 ((happy_var_2,Nothing) : happy_var_1
	)}}

happyReduce_91 = happySpecReduce_0  32# happyReduction_91
happyReduction_91  =  happyIn37
		 ([]
	)

happyReduce_92 = happySpecReduce_2  33# happyReduction_92
happyReduction_92 happy_x_2
	happy_x_1
	 =  case happyOut39 happy_x_1 of { happy_var_1 -> 
	happyIn38
		 (fixupHsDecls ( reverse happy_var_1 )
	)}

happyReduce_93 = happySpecReduce_1  33# happyReduction_93
happyReduction_93 happy_x_1
	 =  happyIn38
		 ([]
	)

happyReduce_94 = happySpecReduce_3  34# happyReduction_94
happyReduction_94 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut39 happy_x_1 of { happy_var_1 -> 
	case happyOut40 happy_x_3 of { happy_var_3 -> 
	happyIn39
		 (happy_var_3 : happy_var_1
	)}}

happyReduce_95 = happySpecReduce_1  34# happyReduction_95
happyReduction_95 happy_x_1
	 =  case happyOut40 happy_x_1 of { happy_var_1 -> 
	happyIn39
		 ([happy_var_1]
	)}

happyReduce_96 = happySpecReduce_1  35# happyReduction_96
happyReduction_96 happy_x_1
	 =  case happyOut42 happy_x_1 of { happy_var_1 -> 
	happyIn40
		 (happy_var_1
	)}

happyReduce_97 = happySpecReduce_1  35# happyReduction_97
happyReduction_97 happy_x_1
	 =  case happyOut27 happy_x_1 of { happy_var_1 -> 
	happyIn40
		 (happy_var_1
	)}

happyReduce_98 = happySpecReduce_1  35# happyReduction_98
happyReduction_98 happy_x_1
	 =  case happyOut81 happy_x_1 of { happy_var_1 -> 
	happyIn40
		 (happy_var_1
	)}

happyReduce_99 = happySpecReduce_1  35# happyReduction_99
happyReduction_99 happy_x_1
	 =  case happyOut43 happy_x_1 of { happy_var_1 -> 
	happyIn40
		 (happy_var_1
	)}

happyReduce_100 = happySpecReduce_3  36# happyReduction_100
happyReduction_100 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut38 happy_x_2 of { happy_var_2 -> 
	happyIn41
		 (happy_var_2
	)}

happyReduce_101 = happySpecReduce_3  36# happyReduction_101
happyReduction_101 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut38 happy_x_2 of { happy_var_2 -> 
	happyIn41
		 (happy_var_2
	)}

happyReduce_102 = happyReduce 4# 37# happyReduction_102
happyReduction_102 (happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut44 happy_x_1 of { happy_var_1 -> 
	case happyOut134 happy_x_2 of { happy_var_2 -> 
	case happyOut55 happy_x_4 of { happy_var_4 -> 
	happyIn42
		 (HsTypeSig happy_var_2 (reverse happy_var_1) happy_var_4
	) `HappyStk` happyRest}}}

happyReduce_103 = happyReduce 4# 38# happyReduction_103
happyReduction_103 (happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOutTok happy_x_1 of { (PragmaStart happy_var_1) -> 
	case happyOut134 happy_x_2 of { happy_var_2 -> 
	case happyOut44 happy_x_3 of { happy_var_3 -> 
	happyIn43
		 (HsPragmaProps happy_var_2 happy_var_1 happy_var_3
	) `HappyStk` happyRest}}}

happyReduce_104 = happySpecReduce_3  39# happyReduction_104
happyReduction_104 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut44 happy_x_1 of { happy_var_1 -> 
	case happyOut110 happy_x_3 of { happy_var_3 -> 
	happyIn44
		 (happy_var_3 : happy_var_1
	)}}

happyReduce_105 = happyMonadReduce 1# 39# happyReduction_105
happyReduction_105 (happy_x_1 `HappyStk`
	happyRest) tk
	 = happyThen (case happyOut111 happy_x_1 of { happy_var_1 -> 
	( checkUnQual happy_var_1 `thenP` \n ->
                                         returnP [n])}
	) (\r -> happyReturn (happyIn44 r))

happyReduce_106 = happySpecReduce_2  40# happyReduction_106
happyReduction_106 happy_x_2
	happy_x_1
	 =  case happyOutTok happy_x_1 of { (StringTok happy_var_1) -> 
	case happyOut110 happy_x_2 of { happy_var_2 -> 
	happyIn45
		 (Just (happy_var_1,happy_var_2)
	)}}

happyReduce_107 = happySpecReduce_0  40# happyReduction_107
happyReduction_107  =  happyIn45
		 (Nothing
	)

happyReduce_108 = happySpecReduce_3  41# happyReduction_108
happyReduction_108 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut51 happy_x_1 of { happy_var_1 -> 
	case happyOut46 happy_x_3 of { happy_var_3 -> 
	happyIn46
		 (HsTyFun happy_var_1 happy_var_3
	)}}

happyReduce_109 = happySpecReduce_1  41# happyReduction_109
happyReduction_109 happy_x_1
	 =  case happyOut51 happy_x_1 of { happy_var_1 -> 
	happyIn46
		 (happy_var_1
	)}

happyReduce_110 = happyReduce 4# 41# happyReduction_110
happyReduction_110 (happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut47 happy_x_2 of { happy_var_2 -> 
	case happyOut55 happy_x_4 of { happy_var_4 -> 
	happyIn46
		 (HsTyForall { hsTypeVars = reverse happy_var_2, hsTypeType = happy_var_4 }
	) `HappyStk` happyRest}}

happyReduce_111 = happyReduce 4# 41# happyReduction_111
happyReduction_111 (happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut47 happy_x_2 of { happy_var_2 -> 
	case happyOut55 happy_x_4 of { happy_var_4 -> 
	happyIn46
		 (HsTyExists { hsTypeVars = reverse happy_var_2, hsTypeType = happy_var_4 }
	) `HappyStk` happyRest}}

happyReduce_112 = happySpecReduce_2  42# happyReduction_112
happyReduction_112 happy_x_2
	happy_x_1
	 =  case happyOut47 happy_x_1 of { happy_var_1 -> 
	case happyOut48 happy_x_2 of { happy_var_2 -> 
	happyIn47
		 (happy_var_2 : happy_var_1
	)}}

happyReduce_113 = happySpecReduce_1  42# happyReduction_113
happyReduction_113 happy_x_1
	 =  case happyOut48 happy_x_1 of { happy_var_1 -> 
	happyIn47
		 ([happy_var_1]
	)}

happyReduce_114 = happySpecReduce_2  43# happyReduction_114
happyReduction_114 happy_x_2
	happy_x_1
	 =  case happyOut134 happy_x_1 of { happy_var_1 -> 
	case happyOut123 happy_x_2 of { happy_var_2 -> 
	happyIn48
		 (hsTyVarBind { hsTyVarBindSrcLoc = happy_var_1, hsTyVarBindName = happy_var_2 }
	)}}

happyReduce_115 = happyReduce 6# 43# happyReduction_115
happyReduction_115 (happy_x_6 `HappyStk`
	happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut134 happy_x_1 of { happy_var_1 -> 
	case happyOut123 happy_x_3 of { happy_var_3 -> 
	case happyOut49 happy_x_5 of { happy_var_5 -> 
	happyIn48
		 (hsTyVarBind { hsTyVarBindSrcLoc = happy_var_1, hsTyVarBindName = happy_var_3, hsTyVarBindKind = Just happy_var_5 }
	) `HappyStk` happyRest}}}

happyReduce_116 = happySpecReduce_1  44# happyReduction_116
happyReduction_116 happy_x_1
	 =  case happyOut50 happy_x_1 of { happy_var_1 -> 
	happyIn49
		 (happy_var_1
	)}

happyReduce_117 = happySpecReduce_3  44# happyReduction_117
happyReduction_117 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut50 happy_x_1 of { happy_var_1 -> 
	case happyOut49 happy_x_3 of { happy_var_3 -> 
	happyIn49
		 (HsKindFn happy_var_1 happy_var_3
	)}}

happyReduce_118 = happySpecReduce_3  45# happyReduction_118
happyReduction_118 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut49 happy_x_2 of { happy_var_2 -> 
	happyIn50
		 (happy_var_2
	)}

happyReduce_119 = happySpecReduce_1  45# happyReduction_119
happyReduction_119 happy_x_1
	 =  happyIn50
		 (hsKindStar
	)

happyReduce_120 = happySpecReduce_1  45# happyReduction_120
happyReduction_120 happy_x_1
	 =  happyIn50
		 (hsKindHash
	)

happyReduce_121 = happySpecReduce_1  45# happyReduction_121
happyReduction_121 happy_x_1
	 =  happyIn50
		 (hsKindBang
	)

happyReduce_122 = happySpecReduce_1  45# happyReduction_122
happyReduction_122 happy_x_1
	 =  happyIn50
		 (hsKindStarBang
	)

happyReduce_123 = happySpecReduce_1  45# happyReduction_123
happyReduction_123 happy_x_1
	 =  happyIn50
		 (hsKindQuest
	)

happyReduce_124 = happySpecReduce_1  45# happyReduction_124
happyReduction_124 happy_x_1
	 =  happyIn50
		 (hsKindQuestQuest
	)

happyReduce_125 = happySpecReduce_1  45# happyReduction_125
happyReduction_125 happy_x_1
	 =  case happyOut124 happy_x_1 of { happy_var_1 -> 
	happyIn50
		 (HsKind happy_var_1
	)}

happyReduce_126 = happySpecReduce_2  46# happyReduction_126
happyReduction_126 happy_x_2
	happy_x_1
	 =  case happyOut51 happy_x_1 of { happy_var_1 -> 
	case happyOut52 happy_x_2 of { happy_var_2 -> 
	happyIn51
		 (HsTyApp happy_var_1 happy_var_2
	)}}

happyReduce_127 = happySpecReduce_1  46# happyReduction_127
happyReduction_127 happy_x_1
	 =  case happyOut52 happy_x_1 of { happy_var_1 -> 
	happyIn51
		 (happy_var_1
	)}

happyReduce_128 = happySpecReduce_1  47# happyReduction_128
happyReduction_128 happy_x_1
	 =  case happyOut54 happy_x_1 of { happy_var_1 -> 
	happyIn52
		 (HsTyCon happy_var_1
	)}

happyReduce_129 = happySpecReduce_1  47# happyReduction_129
happyReduction_129 happy_x_1
	 =  case happyOut142 happy_x_1 of { happy_var_1 -> 
	happyIn52
		 (HsTyVar happy_var_1
	)}

happyReduce_130 = happySpecReduce_3  47# happyReduction_130
happyReduction_130 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut58 happy_x_2 of { happy_var_2 -> 
	happyIn52
		 (HsTyTuple (reverse happy_var_2)
	)}

happyReduce_131 = happySpecReduce_2  47# happyReduction_131
happyReduction_131 happy_x_2
	happy_x_1
	 =  happyIn52
		 (HsTyUnboxedTuple []
	)

happyReduce_132 = happySpecReduce_3  47# happyReduction_132
happyReduction_132 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut46 happy_x_2 of { happy_var_2 -> 
	happyIn52
		 (HsTyUnboxedTuple [happy_var_2]
	)}

happyReduce_133 = happySpecReduce_3  47# happyReduction_133
happyReduction_133 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut58 happy_x_2 of { happy_var_2 -> 
	happyIn52
		 (HsTyUnboxedTuple (reverse happy_var_2)
	)}

happyReduce_134 = happySpecReduce_3  47# happyReduction_134
happyReduction_134 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut46 happy_x_2 of { happy_var_2 -> 
	happyIn52
		 (HsTyApp list_tycon happy_var_2
	)}

happyReduce_135 = happySpecReduce_3  47# happyReduction_135
happyReduction_135 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut53 happy_x_2 of { happy_var_2 -> 
	happyIn52
		 (happy_var_2
	)}

happyReduce_136 = happyReduce 5# 47# happyReduction_136
happyReduction_136 (happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut46 happy_x_2 of { happy_var_2 -> 
	case happyOut46 happy_x_4 of { happy_var_4 -> 
	happyIn52
		 (HsTyEq happy_var_2 happy_var_4
	) `HappyStk` happyRest}}

happyReduce_137 = happyReduce 4# 48# happyReduction_137
happyReduction_137 (happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut134 happy_x_1 of { happy_var_1 -> 
	case happyOut52 happy_x_2 of { happy_var_2 -> 
	case happyOut49 happy_x_4 of { happy_var_4 -> 
	happyIn53
		 (HsTyExpKind { hsTySrcLoc = happy_var_1, hsTyType = happy_var_2, hsTyKind = happy_var_4 }
	) `HappyStk` happyRest}}}

happyReduce_138 = happySpecReduce_1  48# happyReduction_138
happyReduction_138 happy_x_1
	 =  case happyOut46 happy_x_1 of { happy_var_1 -> 
	happyIn53
		 (happy_var_1
	)}

happyReduce_139 = happySpecReduce_1  49# happyReduction_139
happyReduction_139 happy_x_1
	 =  case happyOut124 happy_x_1 of { happy_var_1 -> 
	happyIn54
		 (happy_var_1
	)}

happyReduce_140 = happySpecReduce_2  49# happyReduction_140
happyReduction_140 happy_x_2
	happy_x_1
	 =  happyIn54
		 (unit_tycon_name
	)

happyReduce_141 = happySpecReduce_3  49# happyReduction_141
happyReduction_141 happy_x_3
	happy_x_2
	happy_x_1
	 =  happyIn54
		 (fun_tycon_name
	)

happyReduce_142 = happySpecReduce_2  49# happyReduction_142
happyReduction_142 happy_x_2
	happy_x_1
	 =  happyIn54
		 (list_tycon_name
	)

happyReduce_143 = happySpecReduce_3  49# happyReduction_143
happyReduction_143 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut92 happy_x_2 of { happy_var_2 -> 
	happyIn54
		 (tuple_tycon_name happy_var_2
	)}

happyReduce_144 = happyMonadReduce 3# 50# happyReduction_144
happyReduction_144 (happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest) tk
	 = happyThen (case happyOut51 happy_x_1 of { happy_var_1 -> 
	case happyOut46 happy_x_3 of { happy_var_3 -> 
	( checkContext happy_var_1 `thenP` \c ->
                                         returnP (HsQualType c happy_var_3))}}
	) (\r -> happyReturn (happyIn55 r))

happyReduce_145 = happySpecReduce_1  50# happyReduction_145
happyReduction_145 happy_x_1
	 =  case happyOut46 happy_x_1 of { happy_var_1 -> 
	happyIn55
		 (HsQualType [] happy_var_1
	)}

happyReduce_146 = happyMonadReduce 3# 51# happyReduction_146
happyReduction_146 (happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest) tk
	 = happyThen (case happyOut51 happy_x_1 of { happy_var_1 -> 
	case happyOut51 happy_x_3 of { happy_var_3 -> 
	( liftM2 (,)     (checkContext happy_var_1) (checkContext happy_var_3))}}
	) (\r -> happyReturn (happyIn56 r))

happyReduce_147 = happyMonadReduce 1# 51# happyReduction_147
happyReduction_147 (happy_x_1 `HappyStk`
	happyRest) tk
	 = happyThen (case happyOut51 happy_x_1 of { happy_var_1 -> 
	( liftM ((,) []) (checkContext happy_var_1))}
	) (\r -> happyReturn (happyIn56 r))

happyReduce_148 = happyMonadReduce 1# 52# happyReduction_148
happyReduction_148 (happy_x_1 `HappyStk`
	happyRest) tk
	 = happyThen (case happyOut55 happy_x_1 of { happy_var_1 -> 
	( qualTypeToClassHead happy_var_1)}
	) (\r -> happyReturn (happyIn57 r))

happyReduce_149 = happySpecReduce_3  53# happyReduction_149
happyReduction_149 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut58 happy_x_1 of { happy_var_1 -> 
	case happyOut46 happy_x_3 of { happy_var_3 -> 
	happyIn58
		 (happy_var_3 : happy_var_1
	)}}

happyReduce_150 = happySpecReduce_3  53# happyReduction_150
happyReduction_150 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut46 happy_x_1 of { happy_var_1 -> 
	case happyOut46 happy_x_3 of { happy_var_3 -> 
	happyIn58
		 ([happy_var_3, happy_var_1]
	)}}

happyReduce_151 = happySpecReduce_2  54# happyReduction_151
happyReduction_151 happy_x_2
	happy_x_1
	 =  case happyOut139 happy_x_1 of { happy_var_1 -> 
	case happyOut60 happy_x_2 of { happy_var_2 -> 
	happyIn59
		 ((happy_var_1,reverse happy_var_2)
	)}}

happyReduce_152 = happySpecReduce_2  55# happyReduction_152
happyReduction_152 happy_x_2
	happy_x_1
	 =  case happyOut60 happy_x_1 of { happy_var_1 -> 
	case happyOut52 happy_x_2 of { happy_var_2 -> 
	happyIn60
		 (happy_var_2 : happy_var_1
	)}}

happyReduce_153 = happySpecReduce_0  55# happyReduction_153
happyReduction_153  =  happyIn60
		 ([]
	)

happyReduce_154 = happySpecReduce_3  56# happyReduction_154
happyReduction_154 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut61 happy_x_1 of { happy_var_1 -> 
	case happyOut62 happy_x_3 of { happy_var_3 -> 
	happyIn61
		 (happy_var_3 : happy_var_1
	)}}

happyReduce_155 = happySpecReduce_1  56# happyReduction_155
happyReduction_155 happy_x_1
	 =  case happyOut62 happy_x_1 of { happy_var_1 -> 
	happyIn61
		 ([happy_var_1]
	)}

happyReduce_156 = happySpecReduce_3  57# happyReduction_156
happyReduction_156 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut134 happy_x_1 of { happy_var_1 -> 
	case happyOut63 happy_x_2 of { happy_var_2 -> 
	case happyOut64 happy_x_3 of { happy_var_3 -> 
	happyIn62
		 (HsConDecl { hsConDeclSrcLoc = happy_var_1, hsConDeclName = (fst happy_var_3), hsConDeclConArg = (snd happy_var_3), hsConDeclExists = happy_var_2 }
	)}}}

happyReduce_157 = happyReduce 5# 57# happyReduction_157
happyReduction_157 (happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut134 happy_x_1 of { happy_var_1 -> 
	case happyOut63 happy_x_2 of { happy_var_2 -> 
	case happyOut67 happy_x_3 of { happy_var_3 -> 
	case happyOut117 happy_x_4 of { happy_var_4 -> 
	case happyOut67 happy_x_5 of { happy_var_5 -> 
	happyIn62
		 (HsConDecl { hsConDeclSrcLoc = happy_var_1, hsConDeclName = happy_var_4, hsConDeclConArg = [happy_var_3,happy_var_5], hsConDeclExists = happy_var_2 }
	) `HappyStk` happyRest}}}}}

happyReduce_158 = happyReduce 6# 57# happyReduction_158
happyReduction_158 (happy_x_6 `HappyStk`
	happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut134 happy_x_1 of { happy_var_1 -> 
	case happyOut63 happy_x_2 of { happy_var_2 -> 
	case happyOut112 happy_x_3 of { happy_var_3 -> 
	case happyOut68 happy_x_5 of { happy_var_5 -> 
	happyIn62
		 (HsRecDecl { hsConDeclSrcLoc = happy_var_1, hsConDeclName = happy_var_3, hsConDeclRecArg = (reverse happy_var_5), hsConDeclExists = happy_var_2 }
	) `HappyStk` happyRest}}}}

happyReduce_159 = happySpecReduce_3  58# happyReduction_159
happyReduction_159 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut47 happy_x_2 of { happy_var_2 -> 
	happyIn63
		 (happy_var_2
	)}

happyReduce_160 = happySpecReduce_3  58# happyReduction_160
happyReduction_160 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut47 happy_x_2 of { happy_var_2 -> 
	happyIn63
		 (happy_var_2
	)}

happyReduce_161 = happySpecReduce_0  58# happyReduction_161
happyReduction_161  =  happyIn63
		 ([]
	)

happyReduce_162 = happyMonadReduce 1# 59# happyReduction_162
happyReduction_162 (happy_x_1 `HappyStk`
	happyRest) tk
	 = happyThen (case happyOut51 happy_x_1 of { happy_var_1 -> 
	( splitTyConApp happy_var_1 `thenP` \(c,ts) ->
                                         returnP (c,map HsUnBangedTy ts))}
	) (\r -> happyReturn (happyIn64 r))

happyReduce_163 = happySpecReduce_1  59# happyReduction_163
happyReduction_163 happy_x_1
	 =  case happyOut65 happy_x_1 of { happy_var_1 -> 
	happyIn64
		 (happy_var_1
	)}

happyReduce_164 = happyMonadReduce 3# 60# happyReduction_164
happyReduction_164 (happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest) tk
	 = happyThen (case happyOut51 happy_x_1 of { happy_var_1 -> 
	case happyOut52 happy_x_3 of { happy_var_3 -> 
	( splitTyConApp happy_var_1 `thenP` \(c,ts) ->
                                         returnP (c,map HsUnBangedTy ts++
                                                      [HsBangedTy happy_var_3]))}}
	) (\r -> happyReturn (happyIn65 r))

happyReduce_165 = happySpecReduce_2  60# happyReduction_165
happyReduction_165 happy_x_2
	happy_x_1
	 =  case happyOut65 happy_x_1 of { happy_var_1 -> 
	case happyOut66 happy_x_2 of { happy_var_2 -> 
	happyIn65
		 ((fst happy_var_1, snd happy_var_1 ++ [happy_var_2] )
	)}}

happyReduce_166 = happySpecReduce_1  61# happyReduction_166
happyReduction_166 happy_x_1
	 =  case happyOut52 happy_x_1 of { happy_var_1 -> 
	happyIn66
		 (HsUnBangedTy happy_var_1
	)}

happyReduce_167 = happySpecReduce_2  61# happyReduction_167
happyReduction_167 happy_x_2
	happy_x_1
	 =  case happyOut52 happy_x_2 of { happy_var_2 -> 
	happyIn66
		 (HsBangedTy   happy_var_2
	)}

happyReduce_168 = happySpecReduce_1  62# happyReduction_168
happyReduction_168 happy_x_1
	 =  case happyOut51 happy_x_1 of { happy_var_1 -> 
	happyIn67
		 (HsUnBangedTy happy_var_1
	)}

happyReduce_169 = happySpecReduce_2  62# happyReduction_169
happyReduction_169 happy_x_2
	happy_x_1
	 =  case happyOut52 happy_x_2 of { happy_var_2 -> 
	happyIn67
		 (HsBangedTy   happy_var_2
	)}

happyReduce_170 = happySpecReduce_3  63# happyReduction_170
happyReduction_170 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut68 happy_x_1 of { happy_var_1 -> 
	case happyOut69 happy_x_3 of { happy_var_3 -> 
	happyIn68
		 (happy_var_3 : happy_var_1
	)}}

happyReduce_171 = happySpecReduce_1  63# happyReduction_171
happyReduction_171 happy_x_1
	 =  case happyOut69 happy_x_1 of { happy_var_1 -> 
	happyIn68
		 ([happy_var_1]
	)}

happyReduce_172 = happySpecReduce_3  64# happyReduction_172
happyReduction_172 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut44 happy_x_1 of { happy_var_1 -> 
	case happyOut70 happy_x_3 of { happy_var_3 -> 
	happyIn69
		 ((reverse happy_var_1, happy_var_3)
	)}}

happyReduce_173 = happySpecReduce_1  65# happyReduction_173
happyReduction_173 happy_x_1
	 =  case happyOut46 happy_x_1 of { happy_var_1 -> 
	happyIn70
		 (HsUnBangedTy happy_var_1
	)}

happyReduce_174 = happySpecReduce_2  65# happyReduction_174
happyReduction_174 happy_x_2
	happy_x_1
	 =  case happyOut52 happy_x_2 of { happy_var_2 -> 
	happyIn70
		 (HsBangedTy   happy_var_2
	)}

happyReduce_175 = happySpecReduce_0  66# happyReduction_175
happyReduction_175  =  happyIn71
		 ([]
	)

happyReduce_176 = happySpecReduce_2  66# happyReduction_176
happyReduction_176 happy_x_2
	happy_x_1
	 =  case happyOut141 happy_x_2 of { happy_var_2 -> 
	happyIn71
		 ([happy_var_2]
	)}

happyReduce_177 = happySpecReduce_3  66# happyReduction_177
happyReduction_177 happy_x_3
	happy_x_2
	happy_x_1
	 =  happyIn71
		 ([]
	)

happyReduce_178 = happyReduce 4# 66# happyReduction_178
happyReduction_178 (happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut72 happy_x_3 of { happy_var_3 -> 
	happyIn71
		 (reverse happy_var_3
	) `HappyStk` happyRest}

happyReduce_179 = happySpecReduce_3  67# happyReduction_179
happyReduction_179 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut72 happy_x_1 of { happy_var_1 -> 
	case happyOut141 happy_x_3 of { happy_var_3 -> 
	happyIn72
		 (happy_var_3 : happy_var_1
	)}}

happyReduce_180 = happySpecReduce_1  67# happyReduction_180
happyReduction_180 happy_x_1
	 =  case happyOut141 happy_x_1 of { happy_var_1 -> 
	happyIn72
		 ([happy_var_1]
	)}

happyReduce_181 = happySpecReduce_2  68# happyReduction_181
happyReduction_181 happy_x_2
	happy_x_1
	 =  case happyOut41 happy_x_2 of { happy_var_2 -> 
	happyIn73
		 (fixupHsDecls happy_var_2
	)}

happyReduce_182 = happySpecReduce_0  68# happyReduction_182
happyReduction_182  =  happyIn73
		 ([]
	)

happyReduce_183 = happySpecReduce_3  69# happyReduction_183
happyReduction_183 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut74 happy_x_1 of { happy_var_1 -> 
	case happyOut81 happy_x_3 of { happy_var_3 -> 
	happyIn74
		 (happy_var_3 : happy_var_1
	)}}

happyReduce_184 = happySpecReduce_1  69# happyReduction_184
happyReduction_184 happy_x_1
	 =  case happyOut81 happy_x_1 of { happy_var_1 -> 
	happyIn74
		 ([happy_var_1]
	)}

happyReduce_185 = happySpecReduce_0  70# happyReduction_185
happyReduction_185  =  happyIn75
		 ([]
	)

happyReduce_186 = happySpecReduce_2  70# happyReduction_186
happyReduction_186 happy_x_2
	happy_x_1
	 =  case happyOut76 happy_x_2 of { happy_var_2 -> 
	happyIn75
		 (reverse happy_var_2
	)}

happyReduce_187 = happySpecReduce_3  71# happyReduction_187
happyReduction_187 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut76 happy_x_1 of { happy_var_1 -> 
	case happyOut77 happy_x_3 of { happy_var_3 -> 
	happyIn76
		 ((happy_var_3:happy_var_1)
	)}}

happyReduce_188 = happySpecReduce_1  71# happyReduction_188
happyReduction_188 happy_x_1
	 =  case happyOut77 happy_x_1 of { happy_var_1 -> 
	happyIn76
		 ([happy_var_1]
	)}

happyReduce_189 = happySpecReduce_3  72# happyReduction_189
happyReduction_189 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut78 happy_x_1 of { happy_var_1 -> 
	case happyOut78 happy_x_3 of { happy_var_3 -> 
	happyIn77
		 ((happy_var_1,happy_var_3)
	)}}

happyReduce_190 = happySpecReduce_0  73# happyReduction_190
happyReduction_190  =  happyIn78
		 ([]
	)

happyReduce_191 = happySpecReduce_2  73# happyReduction_191
happyReduction_191 happy_x_2
	happy_x_1
	 =  case happyOut78 happy_x_1 of { happy_var_1 -> 
	case happyOut123 happy_x_2 of { happy_var_2 -> 
	happyIn78
		 ((happy_var_2:happy_var_1)
	)}}

happyReduce_192 = happyReduce 4# 74# happyReduction_192
happyReduction_192 (happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut80 happy_x_3 of { happy_var_3 -> 
	happyIn79
		 (happy_var_3
	) `HappyStk` happyRest}

happyReduce_193 = happyReduce 4# 74# happyReduction_193
happyReduction_193 (happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut80 happy_x_3 of { happy_var_3 -> 
	happyIn79
		 (happy_var_3
	) `HappyStk` happyRest}

happyReduce_194 = happySpecReduce_0  74# happyReduction_194
happyReduction_194  =  happyIn79
		 ([]
	)

happyReduce_195 = happySpecReduce_2  75# happyReduction_195
happyReduction_195 happy_x_2
	happy_x_1
	 =  case happyOut74 happy_x_1 of { happy_var_1 -> 
	happyIn80
		 (fixupHsDecls (reverse happy_var_1)
	)}

happyReduce_196 = happySpecReduce_1  75# happyReduction_196
happyReduction_196 happy_x_1
	 =  happyIn80
		 ([]
	)

happyReduce_197 = happyReduce 5# 76# happyReduction_197
happyReduction_197 (happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut59 happy_x_2 of { happy_var_2 -> 
	case happyOut134 happy_x_3 of { happy_var_3 -> 
	case happyOut46 happy_x_5 of { happy_var_5 -> 
	happyIn81
		 (HsTypeDecl happy_var_3 (fst happy_var_2) (snd happy_var_2) happy_var_5
	) `HappyStk` happyRest}}}

happyReduce_198 = happySpecReduce_3  76# happyReduction_198
happyReduction_198 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut59 happy_x_2 of { happy_var_2 -> 
	case happyOut134 happy_x_3 of { happy_var_3 -> 
	happyIn81
		 (HsTypeDecl happy_var_3 (fst happy_var_2) (snd happy_var_2) HsTyAssoc
	)}}

happyReduce_199 = happyMonadReduce 3# 76# happyReduction_199
happyReduction_199 (happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest) tk
	 = happyThen (case happyOut86 happy_x_1 of { happy_var_1 -> 
	case happyOut134 happy_x_2 of { happy_var_2 -> 
	case happyOut82 happy_x_3 of { happy_var_3 -> 
	( checkValDef happy_var_2 happy_var_1 happy_var_3 [])}}}
	) (\r -> happyReturn (happyIn81 r))

happyReduce_200 = happyMonadReduce 5# 76# happyReduction_200
happyReduction_200 (happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest) tk
	 = happyThen (case happyOut86 happy_x_1 of { happy_var_1 -> 
	case happyOut134 happy_x_2 of { happy_var_2 -> 
	case happyOut82 happy_x_3 of { happy_var_3 -> 
	case happyOut41 happy_x_5 of { happy_var_5 -> 
	( checkValDef happy_var_2 happy_var_1 happy_var_3 happy_var_5)}}}}
	) (\r -> happyReturn (happyIn81 r))

happyReduce_201 = happyMonadReduce 2# 77# happyReduction_201
happyReduction_201 (happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest) tk
	 = happyThen (case happyOut85 happy_x_2 of { happy_var_2 -> 
	( checkExpr happy_var_2 `thenP` \e ->
                                         returnP (HsUnGuardedRhs e))}
	) (\r -> happyReturn (happyIn82 r))

happyReduce_202 = happySpecReduce_1  77# happyReduction_202
happyReduction_202 happy_x_1
	 =  case happyOut83 happy_x_1 of { happy_var_1 -> 
	happyIn82
		 (HsGuardedRhss  (reverse happy_var_1)
	)}

happyReduce_203 = happySpecReduce_2  78# happyReduction_203
happyReduction_203 happy_x_2
	happy_x_1
	 =  case happyOut83 happy_x_1 of { happy_var_1 -> 
	case happyOut84 happy_x_2 of { happy_var_2 -> 
	happyIn83
		 (happy_var_2 : happy_var_1
	)}}

happyReduce_204 = happySpecReduce_1  78# happyReduction_204
happyReduction_204 happy_x_1
	 =  case happyOut84 happy_x_1 of { happy_var_1 -> 
	happyIn83
		 ([happy_var_1]
	)}

happyReduce_205 = happyMonadReduce 5# 79# happyReduction_205
happyReduction_205 (happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest) tk
	 = happyThen (case happyOut85 happy_x_2 of { happy_var_2 -> 
	case happyOut134 happy_x_3 of { happy_var_3 -> 
	case happyOut85 happy_x_5 of { happy_var_5 -> 
	( checkExpr happy_var_2 `thenP` \g ->
                                         checkExpr happy_var_5 `thenP` \e ->
                                         returnP (HsGuardedRhs happy_var_3 g e))}}}
	) (\r -> happyReturn (happyIn84 r))

happyReduce_206 = happyReduce 4# 80# happyReduction_206
happyReduction_206 (happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut86 happy_x_1 of { happy_var_1 -> 
	case happyOut134 happy_x_3 of { happy_var_3 -> 
	case happyOut55 happy_x_4 of { happy_var_4 -> 
	happyIn85
		 (HsExpTypeSig happy_var_3 happy_var_1 happy_var_4
	) `HappyStk` happyRest}}}

happyReduce_207 = happySpecReduce_1  80# happyReduction_207
happyReduction_207 happy_x_1
	 =  case happyOut86 happy_x_1 of { happy_var_1 -> 
	happyIn85
		 (happy_var_1
	)}

happyReduce_208 = happySpecReduce_1  81# happyReduction_208
happyReduction_208 happy_x_1
	 =  case happyOut87 happy_x_1 of { happy_var_1 -> 
	happyIn86
		 (happy_var_1
	)}

happyReduce_209 = happySpecReduce_3  81# happyReduction_209
happyReduction_209 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut86 happy_x_1 of { happy_var_1 -> 
	case happyOut120 happy_x_2 of { happy_var_2 -> 
	case happyOut87 happy_x_3 of { happy_var_3 -> 
	happyIn86
		 (HsInfixApp happy_var_1 happy_var_2 happy_var_3
	)}}}

happyReduce_210 = happyMonadReduce 5# 82# happyReduction_210
happyReduction_210 (happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest) tk
	 = happyThen (case happyOut89 happy_x_2 of { happy_var_2 -> 
	case happyOut134 happy_x_3 of { happy_var_3 -> 
	case happyOut85 happy_x_5 of { happy_var_5 -> 
	( checkPatterns (reverse happy_var_2) `thenP` \ps ->
                                         returnP (HsLambda happy_var_3 ps happy_var_5))}}}
	) (\r -> happyReturn (happyIn87 r))

happyReduce_211 = happyReduce 4# 82# happyReduction_211
happyReduction_211 (happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut41 happy_x_2 of { happy_var_2 -> 
	case happyOut85 happy_x_4 of { happy_var_4 -> 
	happyIn87
		 (HsLet happy_var_2 happy_var_4
	) `HappyStk` happyRest}}

happyReduce_212 = happyReduce 8# 82# happyReduction_212
happyReduction_212 (happy_x_8 `HappyStk`
	happy_x_7 `HappyStk`
	happy_x_6 `HappyStk`
	happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut85 happy_x_2 of { happy_var_2 -> 
	case happyOut85 happy_x_5 of { happy_var_5 -> 
	case happyOut85 happy_x_8 of { happy_var_8 -> 
	happyIn87
		 (HsIf happy_var_2 happy_var_5 happy_var_8
	) `HappyStk` happyRest}}}

happyReduce_213 = happyReduce 4# 82# happyReduction_213
happyReduction_213 (happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut85 happy_x_2 of { happy_var_2 -> 
	case happyOut98 happy_x_4 of { happy_var_4 -> 
	happyIn87
		 (HsCase happy_var_2 happy_var_4
	) `HappyStk` happyRest}}

happyReduce_214 = happySpecReduce_2  82# happyReduction_214
happyReduction_214 happy_x_2
	happy_x_1
	 =  case happyOut88 happy_x_2 of { happy_var_2 -> 
	happyIn87
		 (HsNegApp happy_var_2
	)}

happyReduce_215 = happySpecReduce_2  82# happyReduction_215
happyReduction_215 happy_x_2
	happy_x_1
	 =  case happyOut104 happy_x_2 of { happy_var_2 -> 
	happyIn87
		 (HsDo happy_var_2
	)}

happyReduce_216 = happySpecReduce_1  82# happyReduction_216
happyReduction_216 happy_x_1
	 =  case happyOut88 happy_x_1 of { happy_var_1 -> 
	happyIn87
		 (happy_var_1
	)}

happyReduce_217 = happySpecReduce_2  83# happyReduction_217
happyReduction_217 happy_x_2
	happy_x_1
	 =  case happyOut88 happy_x_1 of { happy_var_1 -> 
	case happyOut90 happy_x_2 of { happy_var_2 -> 
	happyIn88
		 (HsApp happy_var_1 happy_var_2
	)}}

happyReduce_218 = happySpecReduce_1  83# happyReduction_218
happyReduction_218 happy_x_1
	 =  case happyOut90 happy_x_1 of { happy_var_1 -> 
	happyIn88
		 (happy_var_1
	)}

happyReduce_219 = happySpecReduce_2  84# happyReduction_219
happyReduction_219 happy_x_2
	happy_x_1
	 =  case happyOut89 happy_x_1 of { happy_var_1 -> 
	case happyOut90 happy_x_2 of { happy_var_2 -> 
	happyIn89
		 (happy_var_2 : happy_var_1
	)}}

happyReduce_220 = happySpecReduce_1  84# happyReduction_220
happyReduction_220 happy_x_1
	 =  case happyOut90 happy_x_1 of { happy_var_1 -> 
	happyIn89
		 ([happy_var_1]
	)}

happyReduce_221 = happyMonadReduce 4# 85# happyReduction_221
happyReduction_221 (happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest) tk
	 = happyThen (case happyOut90 happy_x_1 of { happy_var_1 -> 
	case happyOut107 happy_x_3 of { happy_var_3 -> 
	( mkRecConstrOrUpdate happy_var_1 (reverse happy_var_3))}}
	) (\r -> happyReturn (happyIn90 r))

happyReduce_222 = happySpecReduce_1  85# happyReduction_222
happyReduction_222 happy_x_1
	 =  case happyOut91 happy_x_1 of { happy_var_1 -> 
	happyIn90
		 (happy_var_1
	)}

happyReduce_223 = happySpecReduce_1  86# happyReduction_223
happyReduction_223 happy_x_1
	 =  case happyOut111 happy_x_1 of { happy_var_1 -> 
	happyIn91
		 (HsVar happy_var_1
	)}

happyReduce_224 = happySpecReduce_1  86# happyReduction_224
happyReduction_224 happy_x_1
	 =  case happyOut109 happy_x_1 of { happy_var_1 -> 
	happyIn91
		 (happy_var_1
	)}

happyReduce_225 = happySpecReduce_1  86# happyReduction_225
happyReduction_225 happy_x_1
	 =  case happyOut133 happy_x_1 of { happy_var_1 -> 
	happyIn91
		 (happy_var_1
	)}

happyReduce_226 = happySpecReduce_3  86# happyReduction_226
happyReduction_226 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut85 happy_x_2 of { happy_var_2 -> 
	happyIn91
		 (HsParen happy_var_2
	)}

happyReduce_227 = happySpecReduce_3  86# happyReduction_227
happyReduction_227 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut93 happy_x_2 of { happy_var_2 -> 
	happyIn91
		 (HsTuple (reverse happy_var_2)
	)}

happyReduce_228 = happySpecReduce_2  86# happyReduction_228
happyReduction_228 happy_x_2
	happy_x_1
	 =  happyIn91
		 (HsUnboxedTuple []
	)

happyReduce_229 = happySpecReduce_3  86# happyReduction_229
happyReduction_229 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut85 happy_x_2 of { happy_var_2 -> 
	happyIn91
		 (HsUnboxedTuple [happy_var_2]
	)}

happyReduce_230 = happySpecReduce_3  86# happyReduction_230
happyReduction_230 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut93 happy_x_2 of { happy_var_2 -> 
	happyIn91
		 (HsUnboxedTuple (reverse happy_var_2)
	)}

happyReduce_231 = happySpecReduce_3  86# happyReduction_231
happyReduction_231 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut94 happy_x_2 of { happy_var_2 -> 
	happyIn91
		 (happy_var_2
	)}

happyReduce_232 = happyReduce 4# 86# happyReduction_232
happyReduction_232 (happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut86 happy_x_2 of { happy_var_2 -> 
	case happyOut120 happy_x_3 of { happy_var_3 -> 
	happyIn91
		 (HsLeftSection happy_var_3 happy_var_2
	) `HappyStk` happyRest}}

happyReduce_233 = happyReduce 4# 86# happyReduction_233
happyReduction_233 (happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut121 happy_x_2 of { happy_var_2 -> 
	case happyOut86 happy_x_3 of { happy_var_3 -> 
	happyIn91
		 (HsRightSection happy_var_3 happy_var_2
	) `HappyStk` happyRest}}

happyReduce_234 = happyMonadReduce 3# 86# happyReduction_234
happyReduction_234 (happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest) tk
	 = happyThen (case happyOut111 happy_x_1 of { happy_var_1 -> 
	case happyOut90 happy_x_3 of { happy_var_3 -> 
	( checkUnQual happy_var_1 `thenP` \n ->
                                         returnP (HsAsPat n happy_var_3))}}
	) (\r -> happyReturn (happyIn91 r))

happyReduce_235 = happySpecReduce_2  86# happyReduction_235
happyReduction_235 happy_x_2
	happy_x_1
	 =  case happyOut134 happy_x_1 of { happy_var_1 -> 
	happyIn91
		 (HsWildCard happy_var_1
	)}

happyReduce_236 = happyReduce 4# 86# happyReduction_236
happyReduction_236 (happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut134 happy_x_2 of { happy_var_2 -> 
	case happyOut91 happy_x_3 of { happy_var_3 -> 
	case happyOut134 happy_x_4 of { happy_var_4 -> 
	happyIn91
		 (HsIrrPat $ located (happy_var_2,happy_var_4) happy_var_3
	) `HappyStk` happyRest}}}

happyReduce_237 = happySpecReduce_2  87# happyReduction_237
happyReduction_237 happy_x_2
	happy_x_1
	 =  case happyOut92 happy_x_1 of { happy_var_1 -> 
	happyIn92
		 (happy_var_1 + 1
	)}

happyReduce_238 = happySpecReduce_1  87# happyReduction_238
happyReduction_238 happy_x_1
	 =  happyIn92
		 (1
	)

happyReduce_239 = happySpecReduce_3  88# happyReduction_239
happyReduction_239 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut93 happy_x_1 of { happy_var_1 -> 
	case happyOut85 happy_x_3 of { happy_var_3 -> 
	happyIn93
		 (happy_var_3 : happy_var_1
	)}}

happyReduce_240 = happySpecReduce_3  88# happyReduction_240
happyReduction_240 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut85 happy_x_1 of { happy_var_1 -> 
	case happyOut85 happy_x_3 of { happy_var_3 -> 
	happyIn93
		 ([happy_var_3,happy_var_1]
	)}}

happyReduce_241 = happySpecReduce_1  89# happyReduction_241
happyReduction_241 happy_x_1
	 =  case happyOut85 happy_x_1 of { happy_var_1 -> 
	happyIn94
		 (HsList [happy_var_1]
	)}

happyReduce_242 = happySpecReduce_1  89# happyReduction_242
happyReduction_242 happy_x_1
	 =  case happyOut95 happy_x_1 of { happy_var_1 -> 
	happyIn94
		 (HsList (reverse happy_var_1)
	)}

happyReduce_243 = happySpecReduce_2  89# happyReduction_243
happyReduction_243 happy_x_2
	happy_x_1
	 =  case happyOut85 happy_x_1 of { happy_var_1 -> 
	happyIn94
		 (HsEnumFrom happy_var_1
	)}

happyReduce_244 = happyReduce 4# 89# happyReduction_244
happyReduction_244 (happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut85 happy_x_1 of { happy_var_1 -> 
	case happyOut85 happy_x_3 of { happy_var_3 -> 
	happyIn94
		 (HsEnumFromThen happy_var_1 happy_var_3
	) `HappyStk` happyRest}}

happyReduce_245 = happySpecReduce_3  89# happyReduction_245
happyReduction_245 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut85 happy_x_1 of { happy_var_1 -> 
	case happyOut85 happy_x_3 of { happy_var_3 -> 
	happyIn94
		 (HsEnumFromTo happy_var_1 happy_var_3
	)}}

happyReduce_246 = happyReduce 5# 89# happyReduction_246
happyReduction_246 (happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut85 happy_x_1 of { happy_var_1 -> 
	case happyOut85 happy_x_3 of { happy_var_3 -> 
	case happyOut85 happy_x_5 of { happy_var_5 -> 
	happyIn94
		 (HsEnumFromThenTo happy_var_1 happy_var_3 happy_var_5
	) `HappyStk` happyRest}}}

happyReduce_247 = happySpecReduce_3  89# happyReduction_247
happyReduction_247 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut85 happy_x_1 of { happy_var_1 -> 
	case happyOut96 happy_x_3 of { happy_var_3 -> 
	happyIn94
		 (HsListComp happy_var_1 (reverse happy_var_3)
	)}}

happyReduce_248 = happySpecReduce_3  90# happyReduction_248
happyReduction_248 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut95 happy_x_1 of { happy_var_1 -> 
	case happyOut85 happy_x_3 of { happy_var_3 -> 
	happyIn95
		 (happy_var_3 : happy_var_1
	)}}

happyReduce_249 = happySpecReduce_3  90# happyReduction_249
happyReduction_249 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut85 happy_x_1 of { happy_var_1 -> 
	case happyOut85 happy_x_3 of { happy_var_3 -> 
	happyIn95
		 ([happy_var_3,happy_var_1]
	)}}

happyReduce_250 = happySpecReduce_3  91# happyReduction_250
happyReduction_250 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut96 happy_x_1 of { happy_var_1 -> 
	case happyOut97 happy_x_3 of { happy_var_3 -> 
	happyIn96
		 (happy_var_3 : happy_var_1
	)}}

happyReduce_251 = happySpecReduce_1  91# happyReduction_251
happyReduction_251 happy_x_1
	 =  case happyOut97 happy_x_1 of { happy_var_1 -> 
	happyIn96
		 ([happy_var_1]
	)}

happyReduce_252 = happyMonadReduce 4# 92# happyReduction_252
happyReduction_252 (happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest) tk
	 = happyThen (case happyOut86 happy_x_1 of { happy_var_1 -> 
	case happyOut134 happy_x_2 of { happy_var_2 -> 
	case happyOut85 happy_x_4 of { happy_var_4 -> 
	( checkPattern happy_var_1 `thenP` \p ->
                                         returnP (HsGenerator happy_var_2 p happy_var_4))}}}
	) (\r -> happyReturn (happyIn97 r))

happyReduce_253 = happySpecReduce_1  92# happyReduction_253
happyReduction_253 happy_x_1
	 =  case happyOut85 happy_x_1 of { happy_var_1 -> 
	happyIn97
		 (HsQualifier happy_var_1
	)}

happyReduce_254 = happySpecReduce_2  92# happyReduction_254
happyReduction_254 happy_x_2
	happy_x_1
	 =  case happyOut41 happy_x_2 of { happy_var_2 -> 
	happyIn97
		 (HsLetStmt happy_var_2
	)}

happyReduce_255 = happyReduce 4# 93# happyReduction_255
happyReduction_255 (happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut99 happy_x_2 of { happy_var_2 -> 
	happyIn98
		 (reverse happy_var_2
	) `HappyStk` happyRest}

happyReduce_256 = happyReduce 4# 93# happyReduction_256
happyReduction_256 (happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut99 happy_x_2 of { happy_var_2 -> 
	happyIn98
		 (reverse happy_var_2
	) `HappyStk` happyRest}

happyReduce_257 = happySpecReduce_3  94# happyReduction_257
happyReduction_257 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut99 happy_x_1 of { happy_var_1 -> 
	case happyOut100 happy_x_3 of { happy_var_3 -> 
	happyIn99
		 (happy_var_3 : happy_var_1
	)}}

happyReduce_258 = happySpecReduce_1  94# happyReduction_258
happyReduction_258 happy_x_1
	 =  case happyOut100 happy_x_1 of { happy_var_1 -> 
	happyIn99
		 ([happy_var_1]
	)}

happyReduce_259 = happyMonadReduce 3# 95# happyReduction_259
happyReduction_259 (happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest) tk
	 = happyThen (case happyOut86 happy_x_1 of { happy_var_1 -> 
	case happyOut134 happy_x_2 of { happy_var_2 -> 
	case happyOut101 happy_x_3 of { happy_var_3 -> 
	( checkPattern happy_var_1 `thenP` \p ->
                                 returnP (HsAlt happy_var_2 p happy_var_3 []))}}}
	) (\r -> happyReturn (happyIn100 r))

happyReduce_260 = happyMonadReduce 5# 95# happyReduction_260
happyReduction_260 (happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest) tk
	 = happyThen (case happyOut86 happy_x_1 of { happy_var_1 -> 
	case happyOut134 happy_x_2 of { happy_var_2 -> 
	case happyOut101 happy_x_3 of { happy_var_3 -> 
	case happyOut41 happy_x_5 of { happy_var_5 -> 
	( checkPattern happy_var_1 `thenP` \p ->
                                 returnP (HsAlt happy_var_2 p happy_var_3 happy_var_5))}}}}
	) (\r -> happyReturn (happyIn100 r))

happyReduce_261 = happySpecReduce_2  96# happyReduction_261
happyReduction_261 happy_x_2
	happy_x_1
	 =  case happyOut85 happy_x_2 of { happy_var_2 -> 
	happyIn101
		 (HsUnGuardedRhs happy_var_2
	)}

happyReduce_262 = happySpecReduce_1  96# happyReduction_262
happyReduction_262 happy_x_1
	 =  case happyOut102 happy_x_1 of { happy_var_1 -> 
	happyIn101
		 (HsGuardedRhss (reverse happy_var_1)
	)}

happyReduce_263 = happySpecReduce_2  97# happyReduction_263
happyReduction_263 happy_x_2
	happy_x_1
	 =  case happyOut102 happy_x_1 of { happy_var_1 -> 
	case happyOut103 happy_x_2 of { happy_var_2 -> 
	happyIn102
		 (happy_var_2 : happy_var_1
	)}}

happyReduce_264 = happySpecReduce_1  97# happyReduction_264
happyReduction_264 happy_x_1
	 =  case happyOut103 happy_x_1 of { happy_var_1 -> 
	happyIn102
		 ([happy_var_1]
	)}

happyReduce_265 = happyReduce 5# 98# happyReduction_265
happyReduction_265 (happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut85 happy_x_2 of { happy_var_2 -> 
	case happyOut134 happy_x_3 of { happy_var_3 -> 
	case happyOut85 happy_x_5 of { happy_var_5 -> 
	happyIn103
		 (HsGuardedRhs happy_var_3 happy_var_2 happy_var_5
	) `HappyStk` happyRest}}}

happyReduce_266 = happySpecReduce_3  99# happyReduction_266
happyReduction_266 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut105 happy_x_2 of { happy_var_2 -> 
	happyIn104
		 (happy_var_2
	)}

happyReduce_267 = happySpecReduce_3  99# happyReduction_267
happyReduction_267 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut105 happy_x_2 of { happy_var_2 -> 
	happyIn104
		 (happy_var_2
	)}

happyReduce_268 = happySpecReduce_3  100# happyReduction_268
happyReduction_268 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut106 happy_x_1 of { happy_var_1 -> 
	case happyOut85 happy_x_3 of { happy_var_3 -> 
	happyIn105
		 (reverse (HsQualifier happy_var_3 : happy_var_1)
	)}}

happyReduce_269 = happySpecReduce_1  100# happyReduction_269
happyReduction_269 happy_x_1
	 =  case happyOut85 happy_x_1 of { happy_var_1 -> 
	happyIn105
		 ([HsQualifier happy_var_1]
	)}

happyReduce_270 = happySpecReduce_3  101# happyReduction_270
happyReduction_270 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut106 happy_x_1 of { happy_var_1 -> 
	case happyOut97 happy_x_3 of { happy_var_3 -> 
	happyIn106
		 (happy_var_3 : happy_var_1
	)}}

happyReduce_271 = happySpecReduce_1  101# happyReduction_271
happyReduction_271 happy_x_1
	 =  case happyOut97 happy_x_1 of { happy_var_1 -> 
	happyIn106
		 ([happy_var_1]
	)}

happyReduce_272 = happySpecReduce_3  102# happyReduction_272
happyReduction_272 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut107 happy_x_1 of { happy_var_1 -> 
	case happyOut108 happy_x_3 of { happy_var_3 -> 
	happyIn107
		 (happy_var_3 : happy_var_1
	)}}

happyReduce_273 = happySpecReduce_1  102# happyReduction_273
happyReduction_273 happy_x_1
	 =  case happyOut108 happy_x_1 of { happy_var_1 -> 
	happyIn107
		 ([happy_var_1]
	)}

happyReduce_274 = happySpecReduce_3  103# happyReduction_274
happyReduction_274 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut111 happy_x_1 of { happy_var_1 -> 
	case happyOut85 happy_x_3 of { happy_var_3 -> 
	happyIn108
		 (HsFieldUpdate happy_var_1 happy_var_3
	)}}

happyReduce_275 = happySpecReduce_2  104# happyReduction_275
happyReduction_275 happy_x_2
	happy_x_1
	 =  happyIn109
		 (unit_con
	)

happyReduce_276 = happySpecReduce_2  104# happyReduction_276
happyReduction_276 happy_x_2
	happy_x_1
	 =  happyIn109
		 (HsList []
	)

happyReduce_277 = happySpecReduce_3  104# happyReduction_277
happyReduction_277 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut92 happy_x_2 of { happy_var_2 -> 
	happyIn109
		 (tuple_con happy_var_2
	)}

happyReduce_278 = happySpecReduce_1  104# happyReduction_278
happyReduction_278 happy_x_1
	 =  case happyOut113 happy_x_1 of { happy_var_1 -> 
	happyIn109
		 (HsCon happy_var_1
	)}

happyReduce_279 = happySpecReduce_1  105# happyReduction_279
happyReduction_279 happy_x_1
	 =  case happyOut123 happy_x_1 of { happy_var_1 -> 
	happyIn110
		 (happy_var_1
	)}

happyReduce_280 = happySpecReduce_3  105# happyReduction_280
happyReduction_280 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut130 happy_x_2 of { happy_var_2 -> 
	happyIn110
		 (happy_var_2
	)}

happyReduce_281 = happySpecReduce_1  106# happyReduction_281
happyReduction_281 happy_x_1
	 =  case happyOut122 happy_x_1 of { happy_var_1 -> 
	happyIn111
		 (happy_var_1
	)}

happyReduce_282 = happySpecReduce_3  106# happyReduction_282
happyReduction_282 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut128 happy_x_2 of { happy_var_2 -> 
	happyIn111
		 (happy_var_2
	)}

happyReduce_283 = happySpecReduce_1  107# happyReduction_283
happyReduction_283 happy_x_1
	 =  case happyOut125 happy_x_1 of { happy_var_1 -> 
	happyIn112
		 (happy_var_1
	)}

happyReduce_284 = happySpecReduce_3  107# happyReduction_284
happyReduction_284 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut127 happy_x_2 of { happy_var_2 -> 
	happyIn112
		 (happy_var_2
	)}

happyReduce_285 = happySpecReduce_1  108# happyReduction_285
happyReduction_285 happy_x_1
	 =  case happyOut124 happy_x_1 of { happy_var_1 -> 
	happyIn113
		 (happy_var_1
	)}

happyReduce_286 = happySpecReduce_3  108# happyReduction_286
happyReduction_286 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut126 happy_x_2 of { happy_var_2 -> 
	happyIn113
		 (happy_var_2
	)}

happyReduce_287 = happySpecReduce_1  109# happyReduction_287
happyReduction_287 happy_x_1
	 =  case happyOut130 happy_x_1 of { happy_var_1 -> 
	happyIn114
		 (happy_var_1
	)}

happyReduce_288 = happySpecReduce_3  109# happyReduction_288
happyReduction_288 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut123 happy_x_2 of { happy_var_2 -> 
	happyIn114
		 (happy_var_2
	)}

happyReduce_289 = happySpecReduce_1  110# happyReduction_289
happyReduction_289 happy_x_1
	 =  case happyOut128 happy_x_1 of { happy_var_1 -> 
	happyIn115
		 (happy_var_1
	)}

happyReduce_290 = happySpecReduce_3  110# happyReduction_290
happyReduction_290 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut122 happy_x_2 of { happy_var_2 -> 
	happyIn115
		 (happy_var_2
	)}

happyReduce_291 = happySpecReduce_1  111# happyReduction_291
happyReduction_291 happy_x_1
	 =  case happyOut129 happy_x_1 of { happy_var_1 -> 
	happyIn116
		 (happy_var_1
	)}

happyReduce_292 = happySpecReduce_3  111# happyReduction_292
happyReduction_292 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut122 happy_x_2 of { happy_var_2 -> 
	happyIn116
		 (happy_var_2
	)}

happyReduce_293 = happySpecReduce_1  112# happyReduction_293
happyReduction_293 happy_x_1
	 =  case happyOut127 happy_x_1 of { happy_var_1 -> 
	happyIn117
		 (happy_var_1
	)}

happyReduce_294 = happySpecReduce_3  112# happyReduction_294
happyReduction_294 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut125 happy_x_2 of { happy_var_2 -> 
	happyIn117
		 (happy_var_2
	)}

happyReduce_295 = happySpecReduce_1  113# happyReduction_295
happyReduction_295 happy_x_1
	 =  case happyOut126 happy_x_1 of { happy_var_1 -> 
	happyIn118
		 (happy_var_1
	)}

happyReduce_296 = happySpecReduce_3  113# happyReduction_296
happyReduction_296 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut124 happy_x_2 of { happy_var_2 -> 
	happyIn118
		 (happy_var_2
	)}

happyReduce_297 = happySpecReduce_1  114# happyReduction_297
happyReduction_297 happy_x_1
	 =  case happyOut114 happy_x_1 of { happy_var_1 -> 
	happyIn119
		 (happy_var_1
	)}

happyReduce_298 = happySpecReduce_1  114# happyReduction_298
happyReduction_298 happy_x_1
	 =  case happyOut117 happy_x_1 of { happy_var_1 -> 
	happyIn119
		 (happy_var_1
	)}

happyReduce_299 = happySpecReduce_1  115# happyReduction_299
happyReduction_299 happy_x_1
	 =  case happyOut115 happy_x_1 of { happy_var_1 -> 
	happyIn120
		 (HsVar happy_var_1
	)}

happyReduce_300 = happySpecReduce_1  115# happyReduction_300
happyReduction_300 happy_x_1
	 =  case happyOut118 happy_x_1 of { happy_var_1 -> 
	happyIn120
		 (HsCon happy_var_1
	)}

happyReduce_301 = happySpecReduce_1  116# happyReduction_301
happyReduction_301 happy_x_1
	 =  case happyOut116 happy_x_1 of { happy_var_1 -> 
	happyIn121
		 (HsVar happy_var_1
	)}

happyReduce_302 = happySpecReduce_1  116# happyReduction_302
happyReduction_302 happy_x_1
	 =  case happyOut118 happy_x_1 of { happy_var_1 -> 
	happyIn121
		 (HsCon happy_var_1
	)}

happyReduce_303 = happySpecReduce_1  117# happyReduction_303
happyReduction_303 happy_x_1
	 =  case happyOut123 happy_x_1 of { happy_var_1 -> 
	happyIn122
		 (happy_var_1
	)}

happyReduce_304 = happySpecReduce_1  117# happyReduction_304
happyReduction_304 happy_x_1
	 =  case happyOutTok happy_x_1 of { (QVarId happy_var_1) -> 
	happyIn122
		 (Qual (Module (fst happy_var_1)) (HsIdent (snd happy_var_1))
	)}

happyReduce_305 = happySpecReduce_1  118# happyReduction_305
happyReduction_305 happy_x_1
	 =  case happyOutTok happy_x_1 of { (VarId happy_var_1) -> 
	happyIn123
		 (UnQual (HsIdent happy_var_1)
	)}

happyReduce_306 = happySpecReduce_1  118# happyReduction_306
happyReduction_306 happy_x_1
	 =  happyIn123
		 (as_name
	)

happyReduce_307 = happySpecReduce_1  118# happyReduction_307
happyReduction_307 happy_x_1
	 =  happyIn123
		 (UnQual (HsIdent "alias")
	)

happyReduce_308 = happySpecReduce_1  118# happyReduction_308
happyReduction_308 happy_x_1
	 =  happyIn123
		 (UnQual (HsIdent "kind")
	)

happyReduce_309 = happySpecReduce_1  118# happyReduction_309
happyReduction_309 happy_x_1
	 =  happyIn123
		 (qualified_name
	)

happyReduce_310 = happySpecReduce_1  118# happyReduction_310
happyReduction_310 happy_x_1
	 =  happyIn123
		 (hiding_name
	)

happyReduce_311 = happySpecReduce_1  118# happyReduction_311
happyReduction_311 happy_x_1
	 =  happyIn123
		 (UnQual (HsIdent "forall")
	)

happyReduce_312 = happySpecReduce_1  118# happyReduction_312
happyReduction_312 happy_x_1
	 =  happyIn123
		 (UnQual (HsIdent "exists")
	)

happyReduce_313 = happySpecReduce_1  118# happyReduction_313
happyReduction_313 happy_x_1
	 =  happyIn123
		 (derive_name
	)

happyReduce_314 = happySpecReduce_1  119# happyReduction_314
happyReduction_314 happy_x_1
	 =  case happyOut125 happy_x_1 of { happy_var_1 -> 
	happyIn124
		 (happy_var_1
	)}

happyReduce_315 = happySpecReduce_1  119# happyReduction_315
happyReduction_315 happy_x_1
	 =  case happyOutTok happy_x_1 of { (QConId happy_var_1) -> 
	happyIn124
		 (Qual (Module (fst happy_var_1)) (HsIdent (snd happy_var_1))
	)}

happyReduce_316 = happySpecReduce_1  120# happyReduction_316
happyReduction_316 happy_x_1
	 =  case happyOutTok happy_x_1 of { (ConId happy_var_1) -> 
	happyIn125
		 (UnQual (HsIdent happy_var_1)
	)}

happyReduce_317 = happySpecReduce_1  121# happyReduction_317
happyReduction_317 happy_x_1
	 =  case happyOut127 happy_x_1 of { happy_var_1 -> 
	happyIn126
		 (happy_var_1
	)}

happyReduce_318 = happySpecReduce_1  121# happyReduction_318
happyReduction_318 happy_x_1
	 =  case happyOutTok happy_x_1 of { (QConSym happy_var_1) -> 
	happyIn126
		 (Qual (Module (fst happy_var_1)) (hsSymbol (snd happy_var_1))
	)}

happyReduce_319 = happySpecReduce_1  122# happyReduction_319
happyReduction_319 happy_x_1
	 =  case happyOutTok happy_x_1 of { (ConSym happy_var_1) -> 
	happyIn127
		 (UnQual (hsSymbol happy_var_1)
	)}

happyReduce_320 = happySpecReduce_1  123# happyReduction_320
happyReduction_320 happy_x_1
	 =  case happyOut130 happy_x_1 of { happy_var_1 -> 
	happyIn128
		 (happy_var_1
	)}

happyReduce_321 = happySpecReduce_1  123# happyReduction_321
happyReduction_321 happy_x_1
	 =  case happyOut132 happy_x_1 of { happy_var_1 -> 
	happyIn128
		 (happy_var_1
	)}

happyReduce_322 = happySpecReduce_1  124# happyReduction_322
happyReduction_322 happy_x_1
	 =  case happyOut131 happy_x_1 of { happy_var_1 -> 
	happyIn129
		 (happy_var_1
	)}

happyReduce_323 = happySpecReduce_1  124# happyReduction_323
happyReduction_323 happy_x_1
	 =  case happyOut132 happy_x_1 of { happy_var_1 -> 
	happyIn129
		 (happy_var_1
	)}

happyReduce_324 = happySpecReduce_1  125# happyReduction_324
happyReduction_324 happy_x_1
	 =  case happyOutTok happy_x_1 of { (VarSym happy_var_1) -> 
	happyIn130
		 (UnQual (hsSymbol happy_var_1)
	)}

happyReduce_325 = happySpecReduce_1  125# happyReduction_325
happyReduction_325 happy_x_1
	 =  happyIn130
		 (minus_name
	)

happyReduce_326 = happySpecReduce_1  125# happyReduction_326
happyReduction_326 happy_x_1
	 =  happyIn130
		 (pling_name
	)

happyReduce_327 = happySpecReduce_1  125# happyReduction_327
happyReduction_327 happy_x_1
	 =  happyIn130
		 (UnQual (hsSymbol "?")
	)

happyReduce_328 = happySpecReduce_1  125# happyReduction_328
happyReduction_328 happy_x_1
	 =  happyIn130
		 (UnQual (hsSymbol "??")
	)

happyReduce_329 = happySpecReduce_1  125# happyReduction_329
happyReduction_329 happy_x_1
	 =  happyIn130
		 (UnQual (hsSymbol "*!")
	)

happyReduce_330 = happySpecReduce_1  125# happyReduction_330
happyReduction_330 happy_x_1
	 =  happyIn130
		 (star_name
	)

happyReduce_331 = happySpecReduce_1  125# happyReduction_331
happyReduction_331 happy_x_1
	 =  happyIn130
		 (hash_name
	)

happyReduce_332 = happySpecReduce_1  125# happyReduction_332
happyReduction_332 happy_x_1
	 =  happyIn130
		 (dot_name
	)

happyReduce_333 = happySpecReduce_1  126# happyReduction_333
happyReduction_333 happy_x_1
	 =  case happyOutTok happy_x_1 of { (VarSym happy_var_1) -> 
	happyIn131
		 (UnQual (hsSymbol happy_var_1)
	)}

happyReduce_334 = happySpecReduce_1  126# happyReduction_334
happyReduction_334 happy_x_1
	 =  happyIn131
		 (pling_name
	)

happyReduce_335 = happySpecReduce_1  126# happyReduction_335
happyReduction_335 happy_x_1
	 =  happyIn131
		 (star_name
	)

happyReduce_336 = happySpecReduce_1  126# happyReduction_336
happyReduction_336 happy_x_1
	 =  happyIn131
		 (hash_name
	)

happyReduce_337 = happySpecReduce_1  126# happyReduction_337
happyReduction_337 happy_x_1
	 =  happyIn131
		 (dot_name
	)

happyReduce_338 = happySpecReduce_1  127# happyReduction_338
happyReduction_338 happy_x_1
	 =  case happyOutTok happy_x_1 of { (QVarSym happy_var_1) -> 
	happyIn132
		 (Qual (Module (fst happy_var_1)) (hsSymbol (snd happy_var_1))
	)}

happyReduce_339 = happySpecReduce_1  128# happyReduction_339
happyReduction_339 happy_x_1
	 =  case happyOutTok happy_x_1 of { (IntTok happy_var_1) -> 
	happyIn133
		 (HsLit (HsInt (readInteger happy_var_1))
	)}

happyReduce_340 = happySpecReduce_1  128# happyReduction_340
happyReduction_340 happy_x_1
	 =  case happyOutTok happy_x_1 of { (UIntTok happy_var_1) -> 
	happyIn133
		 (HsLit (HsIntPrim (readInteger happy_var_1))
	)}

happyReduce_341 = happySpecReduce_1  128# happyReduction_341
happyReduction_341 happy_x_1
	 =  case happyOutTok happy_x_1 of { (Character happy_var_1) -> 
	happyIn133
		 (HsLit (HsChar happy_var_1)
	)}

happyReduce_342 = happySpecReduce_1  128# happyReduction_342
happyReduction_342 happy_x_1
	 =  case happyOutTok happy_x_1 of { (UCharacter happy_var_1) -> 
	happyIn133
		 (HsLit (HsCharPrim happy_var_1)
	)}

happyReduce_343 = happySpecReduce_1  128# happyReduction_343
happyReduction_343 happy_x_1
	 =  case happyOutTok happy_x_1 of { (FloatTok happy_var_1) -> 
	happyIn133
		 (HsLit (HsFrac (readRational happy_var_1))
	)}

happyReduce_344 = happySpecReduce_1  128# happyReduction_344
happyReduction_344 happy_x_1
	 =  case happyOutTok happy_x_1 of { (StringTok happy_var_1) -> 
	happyIn133
		 (HsLit (HsString happy_var_1)
	)}

happyReduce_345 = happySpecReduce_1  128# happyReduction_345
happyReduction_345 happy_x_1
	 =  case happyOutTok happy_x_1 of { (UStringTok happy_var_1) -> 
	happyIn133
		 (HsLit (HsStringPrim happy_var_1)
	)}

happyReduce_346 = happyMonadReduce 0# 129# happyReduction_346
happyReduction_346 (happyRest) tk
	 = happyThen (( getSrcLoc)
	) (\r -> happyReturn (happyIn134 r))

happyReduce_347 = happySpecReduce_1  130# happyReduction_347
happyReduction_347 happy_x_1
	 =  happyIn135
		 (()
	)

happyReduce_348 = happyMonadReduce 1# 130# happyReduction_348
happyReduction_348 (happy_x_1 `HappyStk`
	happyRest) tk
	 = happyThen (( popContext)
	) (\r -> happyReturn (happyIn135 r))

happyReduce_349 = happyMonadReduce 1# 131# happyReduction_349
happyReduction_349 (happy_x_1 `HappyStk`
	happyRest) tk
	 = happyThen (( getSrcLoc `thenP` \sl ->
                                 pushCurrentContext)
	) (\r -> happyReturn (happyIn136 r))

happyReduce_350 = happySpecReduce_1  132# happyReduction_350
happyReduction_350 happy_x_1
	 =  case happyOutTok happy_x_1 of { (ConId happy_var_1) -> 
	happyIn137
		 (Module happy_var_1
	)}

happyReduce_351 = happySpecReduce_1  132# happyReduction_351
happyReduction_351 happy_x_1
	 =  case happyOutTok happy_x_1 of { (QConId happy_var_1) -> 
	happyIn137
		 (Module (fst happy_var_1 ++ "." ++ snd happy_var_1)
	)}

happyReduce_352 = happySpecReduce_1  133# happyReduction_352
happyReduction_352 happy_x_1
	 =  case happyOut125 happy_x_1 of { happy_var_1 -> 
	happyIn138
		 (happy_var_1
	)}

happyReduce_353 = happySpecReduce_1  134# happyReduction_353
happyReduction_353 happy_x_1
	 =  case happyOut125 happy_x_1 of { happy_var_1 -> 
	happyIn139
		 (happy_var_1
	)}

happyReduce_354 = happySpecReduce_1  135# happyReduction_354
happyReduction_354 happy_x_1
	 =  case happyOut124 happy_x_1 of { happy_var_1 -> 
	happyIn140
		 (happy_var_1
	)}

happyReduce_355 = happySpecReduce_1  136# happyReduction_355
happyReduction_355 happy_x_1
	 =  case happyOut124 happy_x_1 of { happy_var_1 -> 
	happyIn141
		 (happy_var_1
	)}

happyReduce_356 = happySpecReduce_1  137# happyReduction_356
happyReduction_356 happy_x_1
	 =  case happyOut123 happy_x_1 of { happy_var_1 -> 
	happyIn142
		 (happy_var_1
	)}

happyNewToken action sts stk
	= lexer(\tk -> 
	let cont i = happyDoAction i tk action sts stk in
	case tk of {
	EOF -> happyDoAction 82# tk action sts stk;
	VarId happy_dollar_dollar -> cont 1#;
	QVarId happy_dollar_dollar -> cont 2#;
	ConId happy_dollar_dollar -> cont 3#;
	QConId happy_dollar_dollar -> cont 4#;
	VarSym happy_dollar_dollar -> cont 5#;
	ConSym happy_dollar_dollar -> cont 6#;
	QVarSym happy_dollar_dollar -> cont 7#;
	QConSym happy_dollar_dollar -> cont 8#;
	IntTok happy_dollar_dollar -> cont 9#;
	UIntTok happy_dollar_dollar -> cont 10#;
	FloatTok happy_dollar_dollar -> cont 11#;
	Character happy_dollar_dollar -> cont 12#;
	UCharacter happy_dollar_dollar -> cont 13#;
	StringTok happy_dollar_dollar -> cont 14#;
	UStringTok happy_dollar_dollar -> cont 15#;
	PragmaOptions happy_dollar_dollar -> cont 16#;
	PragmaStart happy_dollar_dollar -> cont 17#;
	PragmaRules happy_dollar_dollar -> cont 18#;
	PragmaSpecialize happy_dollar_dollar -> cont 19#;
	PragmaEnd -> cont 20#;
	LeftParen -> cont 21#;
	RightParen -> cont 22#;
	LeftUParen -> cont 23#;
	RightUParen -> cont 24#;
	SemiColon -> cont 25#;
	LeftCurly -> cont 26#;
	RightCurly -> cont 27#;
	VRightCurly -> cont 28#;
	LeftSquare -> cont 29#;
	RightSquare -> cont 30#;
	Comma -> cont 31#;
	Underscore -> cont 32#;
	BackQuote -> cont 33#;
	DotDot -> cont 34#;
	DoubleColon -> cont 35#;
	Equals -> cont 36#;
	Backslash -> cont 37#;
	Bar -> cont 38#;
	LeftArrow -> cont 39#;
	RightArrow -> cont 40#;
	At -> cont 41#;
	Tilde -> cont 42#;
	DoubleArrow -> cont 43#;
	Minus -> cont 44#;
	Exclamation -> cont 45#;
	Quest -> cont 46#;
	QuestQuest -> cont 47#;
	StarBang -> cont 48#;
	Star -> cont 49#;
	Hash -> cont 50#;
	Dot -> cont 51#;
	KW_As -> cont 52#;
	KW_Derive -> cont 53#;
	KW_Case -> cont 54#;
	KW_Class -> cont 55#;
	KW_Alias -> cont 56#;
	KW_Data -> cont 57#;
	KW_Default -> cont 58#;
	KW_Deriving -> cont 59#;
	KW_Do -> cont 60#;
	KW_Else -> cont 61#;
	KW_Hiding -> cont 62#;
	KW_If -> cont 63#;
	KW_Import -> cont 64#;
	KW_In -> cont 65#;
	KW_Infix -> cont 66#;
	KW_InfixL -> cont 67#;
	KW_InfixR -> cont 68#;
	KW_Instance -> cont 69#;
	KW_Let -> cont 70#;
	KW_Module -> cont 71#;
	KW_NewType -> cont 72#;
	KW_Of -> cont 73#;
	KW_Then -> cont 74#;
	KW_Type -> cont 75#;
	KW_Where -> cont 76#;
	KW_Qualified -> cont 77#;
	KW_Foreign -> cont 78#;
	KW_Forall -> cont 79#;
	KW_Exists -> cont 80#;
	KW_Kind -> cont 81#;
	_ -> happyError' tk
	})

happyError_ tk = happyError' tk

happyThen :: () => P a -> (a -> P b) -> P b
happyThen = (thenP)
happyReturn :: () => a -> P a
happyReturn = (returnP)
happyThen1 = happyThen
happyReturn1 :: () => a -> P a
happyReturn1 = happyReturn
happyError' :: () => (Token) -> P a
happyError' tk = (\token -> happyError) tk

parse = happySomeParser where
  happySomeParser = happyThen (happyParse 0#) (\x -> happyReturn (happyOut5 x))

parseHsStmt = happySomeParser where
  happySomeParser = happyThen (happyParse 1#) (\x -> happyReturn (happyOut97 x))

happySeq = happyDontSeq


{-# NOINLINE parse #-}
{-# NOINLINE parseHsStmt #-}

happyError = parseError "Parse error"
hsSymbol x = HsIdent x
readInteger x = fromIntegral x
readRational x = x

as_name	              = UnQual $ HsIdent "as"
derive_name	      = UnQual $ HsIdent "derive"
qualified_name        = UnQual $ HsIdent "qualified"
hiding_name	      = UnQual $ HsIdent "hiding"
minus_name	      = UnQual $ HsIdent "-"
pling_name	      = UnQual $ HsIdent "!"
star_name	      = UnQual $ HsIdent "*"
hash_name	      = UnQual $ HsIdent "#"
dot_name	      = UnQual $ HsIdent "."
prelude_mod	      = Module "Prelude"
main_mod	      = Module "Main"

unit_con_name	      = UnQual (HsIdent "()")
tuple_con_name i      = Qual (Module "Lhc.Basics") (HsIdent ("("++replicate i ','++")"))

unit_con	      = HsCon { {-hsExpSrcSpan = bogusSrcSpan,-} hsExpName = unit_con_name }
tuple_con i	      = HsCon { {-hsExpSrcSpan = bogusSrcSpan,-} hsExpName = (tuple_con_name i) }


unit_tycon_name       = unit_con_name
fun_tycon_name        = Qual (Module "Lhc.Basics") (HsIdent "->")
list_tycon_name       = UnQual (HsIdent "[]")
tuple_tycon_name i    = tuple_con_name i

list_tycon	      = HsTyCon list_tycon_name
{-# LINE 1 "templates/GenericTemplate.hs" #-}
{-# LINE 1 "templates/GenericTemplate.hs" #-}
{-# LINE 1 "<built-in>" #-}
{-# LINE 1 "<command line>" #-}
{-# LINE 1 "templates/GenericTemplate.hs" #-}
-- Id: GenericTemplate.hs,v 1.26 2005/01/14 14:47:22 simonmar Exp 

{-# LINE 28 "templates/GenericTemplate.hs" #-}


data Happy_IntList = HappyCons Int# Happy_IntList





{-# LINE 49 "templates/GenericTemplate.hs" #-}

{-# LINE 59 "templates/GenericTemplate.hs" #-}

{-# LINE 68 "templates/GenericTemplate.hs" #-}

infixr 9 `HappyStk`
data HappyStk a = HappyStk a (HappyStk a)

-----------------------------------------------------------------------------
-- starting the parse

happyParse start_state = happyNewToken start_state notHappyAtAll notHappyAtAll

-----------------------------------------------------------------------------
-- Accepting the parse

-- If the current token is 0#, it means we've just accepted a partial
-- parse (a %partial parser).  We must ignore the saved token on the top of
-- the stack in this case.
happyAccept 0# tk st sts (_ `HappyStk` ans `HappyStk` _) =
	happyReturn1 ans
happyAccept j tk st sts (HappyStk ans _) = 
	(happyTcHack j (happyTcHack st)) (happyReturn1 ans)

-----------------------------------------------------------------------------
-- Arrays only: do the next action



happyDoAction i tk st
	= {- nothing -}


	  case action of
		0#		  -> {- nothing -}
				     happyFail i tk st
		-1# 	  -> {- nothing -}
				     happyAccept i tk st
		n | (n <# (0# :: Int#)) -> {- nothing -}

				     (happyReduceArr ! rule) i tk st
				     where rule = (I# ((negateInt# ((n +# (1# :: Int#))))))
		n		  -> {- nothing -}


				     happyShift new_state i tk st
				     where new_state = (n -# (1# :: Int#))
   where off    = indexShortOffAddr happyActOffsets st
	 off_i  = (off +# i)
	 check  = if (off_i >=# (0# :: Int#))
			then (indexShortOffAddr happyCheck off_i ==#  i)
			else False
 	 action | check     = indexShortOffAddr happyTable off_i
		| otherwise = indexShortOffAddr happyDefActions st

{-# LINE 127 "templates/GenericTemplate.hs" #-}


indexShortOffAddr (HappyA# arr) off =
#if __GLASGOW_HASKELL__ > 500
	narrow16Int# i
#elif __GLASGOW_HASKELL__ == 500
	intToInt16# i
#else
	(i `iShiftL#` 16#) `iShiftRA#` 16#
#endif
  where
#if __GLASGOW_HASKELL__ >= 503
	i = word2Int# ((high `uncheckedShiftL#` 8#) `or#` low)
#else
	i = word2Int# ((high `shiftL#` 8#) `or#` low)
#endif
	high = int2Word# (ord# (indexCharOffAddr# arr (off' +# 1#)))
	low  = int2Word# (ord# (indexCharOffAddr# arr off'))
	off' = off *# 2#





data HappyAddr = HappyA# Addr#




-----------------------------------------------------------------------------
-- HappyState data type (not arrays)

{-# LINE 170 "templates/GenericTemplate.hs" #-}

-----------------------------------------------------------------------------
-- Shifting a token

happyShift new_state 0# tk st sts stk@(x `HappyStk` _) =
     let i = (case unsafeCoerce# x of { (I# (i)) -> i }) in
--     trace "shifting the error token" $
     happyDoAction i tk new_state (HappyCons (st) (sts)) (stk)

happyShift new_state i tk st sts stk =
     happyNewToken new_state (HappyCons (st) (sts)) ((happyInTok (tk))`HappyStk`stk)

-- happyReduce is specialised for the common cases.

happySpecReduce_0 i fn 0# tk st sts stk
     = happyFail 0# tk st sts stk
happySpecReduce_0 nt fn j tk st@((action)) sts stk
     = happyGoto nt j tk st (HappyCons (st) (sts)) (fn `HappyStk` stk)

happySpecReduce_1 i fn 0# tk st sts stk
     = happyFail 0# tk st sts stk
happySpecReduce_1 nt fn j tk _ sts@((HappyCons (st@(action)) (_))) (v1`HappyStk`stk')
     = let r = fn v1 in
       happySeq r (happyGoto nt j tk st sts (r `HappyStk` stk'))

happySpecReduce_2 i fn 0# tk st sts stk
     = happyFail 0# tk st sts stk
happySpecReduce_2 nt fn j tk _ (HappyCons (_) (sts@((HappyCons (st@(action)) (_))))) (v1`HappyStk`v2`HappyStk`stk')
     = let r = fn v1 v2 in
       happySeq r (happyGoto nt j tk st sts (r `HappyStk` stk'))

happySpecReduce_3 i fn 0# tk st sts stk
     = happyFail 0# tk st sts stk
happySpecReduce_3 nt fn j tk _ (HappyCons (_) ((HappyCons (_) (sts@((HappyCons (st@(action)) (_))))))) (v1`HappyStk`v2`HappyStk`v3`HappyStk`stk')
     = let r = fn v1 v2 v3 in
       happySeq r (happyGoto nt j tk st sts (r `HappyStk` stk'))

happyReduce k i fn 0# tk st sts stk
     = happyFail 0# tk st sts stk
happyReduce k nt fn j tk st sts stk
     = case happyDrop (k -# (1# :: Int#)) sts of
	 sts1@((HappyCons (st1@(action)) (_))) ->
        	let r = fn stk in  -- it doesn't hurt to always seq here...
       		happyDoSeq r (happyGoto nt j tk st1 sts1 r)

happyMonadReduce k nt fn 0# tk st sts stk
     = happyFail 0# tk st sts stk
happyMonadReduce k nt fn j tk st sts stk =
        happyThen1 (fn stk tk) (\r -> happyGoto nt j tk st1 sts1 (r `HappyStk` drop_stk))
       where sts1@((HappyCons (st1@(action)) (_))) = happyDrop k (HappyCons (st) (sts))
             drop_stk = happyDropStk k stk

happyMonad2Reduce k nt fn 0# tk st sts stk
     = happyFail 0# tk st sts stk
happyMonad2Reduce k nt fn j tk st sts stk =
       happyThen1 (fn stk tk) (\r -> happyNewToken new_state sts1 (r `HappyStk` drop_stk))
       where sts1@((HappyCons (st1@(action)) (_))) = happyDrop k (HappyCons (st) (sts))
             drop_stk = happyDropStk k stk

             off    = indexShortOffAddr happyGotoOffsets st1
             off_i  = (off +# nt)
             new_state = indexShortOffAddr happyTable off_i




happyDrop 0# l = l
happyDrop n (HappyCons (_) (t)) = happyDrop (n -# (1# :: Int#)) t

happyDropStk 0# l = l
happyDropStk n (x `HappyStk` xs) = happyDropStk (n -# (1#::Int#)) xs

-----------------------------------------------------------------------------
-- Moving to a new state after a reduction


happyGoto nt j tk st = 
   {- nothing -}
   happyDoAction j tk new_state
   where off    = indexShortOffAddr happyGotoOffsets st
	 off_i  = (off +# nt)
 	 new_state = indexShortOffAddr happyTable off_i




-----------------------------------------------------------------------------
-- Error recovery (0# is the error token)

-- parse error if we are in recovery and we fail again
happyFail  0# tk old_st _ stk =
--	trace "failing" $ 
    	happyError_ tk

{-  We don't need state discarding for our restricted implementation of
    "error".  In fact, it can cause some bogus parses, so I've disabled it
    for now --SDM

-- discard a state
happyFail  0# tk old_st (HappyCons ((action)) (sts)) 
						(saved_tok `HappyStk` _ `HappyStk` stk) =
--	trace ("discarding state, depth " ++ show (length stk))  $
	happyDoAction 0# tk action sts ((saved_tok`HappyStk`stk))
-}

-- Enter error recovery: generate an error token,
--                       save the old token and carry on.
happyFail  i tk (action) sts stk =
--      trace "entering error recovery" $
	happyDoAction 0# tk action sts ( (unsafeCoerce# (I# (i))) `HappyStk` stk)

-- Internal happy errors:

notHappyAtAll = error "Internal Happy error\n"

-----------------------------------------------------------------------------
-- Hack to get the typechecker to accept our action functions


happyTcHack :: Int# -> a -> a
happyTcHack x y = y
{-# INLINE happyTcHack #-}


-----------------------------------------------------------------------------
-- Seq-ing.  If the --strict flag is given, then Happy emits 
--	happySeq = happyDoSeq
-- otherwise it emits
-- 	happySeq = happyDontSeq

happyDoSeq, happyDontSeq :: a -> b -> b
happyDoSeq   a b = a `seq` b
happyDontSeq a b = b

-----------------------------------------------------------------------------
-- Don't inline any functions from the template.  GHC has a nasty habit
-- of deciding to inline happyGoto everywhere, which increases the size of
-- the generated parser quite a bit.


{-# NOINLINE happyDoAction #-}
{-# NOINLINE happyTable #-}
{-# NOINLINE happyCheck #-}
{-# NOINLINE happyActOffsets #-}
{-# NOINLINE happyGotoOffsets #-}
{-# NOINLINE happyDefActions #-}

{-# NOINLINE happyShift #-}
{-# NOINLINE happySpecReduce_0 #-}
{-# NOINLINE happySpecReduce_1 #-}
{-# NOINLINE happySpecReduce_2 #-}
{-# NOINLINE happySpecReduce_3 #-}
{-# NOINLINE happyReduce #-}
{-# NOINLINE happyMonadReduce #-}
{-# NOINLINE happyGoto #-}
{-# NOINLINE happyFail #-}

-- end of Happy Template.
